2011-01-04  Veerapuram Varadhan  <v.varadhan@gmail.com>

	* assembly.c (framework_assemblies): Map System.Transactions to
	4.0 framework assemblies.

	Fixes #635335

2010-11-03  Martin Baulig  <martin@ximian.com>

	* mono-debug.c (mono_register_symfile_for_assembly): New method.
	This is used together with mono_register_bundled_assemblies() and
	mono_register_config_for_assembly() to support bundles.

2010-07-30  Mark Probst  <mark.probst@gmail.com>

	* sgen-archdep.h (ARCH_COPY_SIGCTX_REGS): Add casts to fix
	compiler warnings on AMD64.

2010-07-29 Rodrigo Kumpera  <rkumpera@novell.com>

	Add support for calling vararg methods from SRE code.
	This requires storing per-memberref signatures so
	the JIT can know how many varargs parameters are
	been passed.

	* loader.c (mono_method_get_signature_full): If the
	image is dynamic call mono_reflection_lookup_signature
	to lookup the signature.

	* reflection.c (mono_image_create_method_token): Save
	the method object into the MonoDynamicImage::tokens.
	Create a signature struct for MethodBuilders.
	Save the signature into vararg_aux_hash so it can be
	retrieved later.

	* reflection.c (mono_reflection_lookup_signature): New
	function. Check vararg_aux_hash for a signature before
	returning method's own signature.

	* metadata-internals.h (MonoDynamicImage): Add new
	vararg_aux_hash hashtable.

	* object-internals.h: Add mono_reflection_lookup_signature.

	Fixes #626441

2010-07-28 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (mono_method_verify): Don't move forward
	with verification if a stack overflow is detected for
	the ARGLIST opcode.

	Fixes #601953

2010-07-28 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_bounded_array_class_get): Fail arrays
	of void or typedbyref. Those two types are not allowed
	to be used with arrays. Failing them is easier and less
	error prone than returning NULL.

	Fixes #603279

2010-07-28 Rodrigo Kumpera  <rkumpera@novell.com>

	* object.c (mono_get_delegate_invoke): Don't assert if
	the Invoke method is not found. This can happen with
	broken types and it's the caller resposibility to deal
	with a null return.

	Fixes #553403

2010-07-28 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_assembly_name_from_token): Handle
	images with null assembly. This can happen with resource
	or broken assemblies.

	Fixes #623586.

2010-07-27 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (concat_two_strings_with_zero): Guard against
	null strings.

	Modified version of patch by Sebastien Pouliot.

	Fixes #623653.

2010-07-27 Rodrigo Kumpera  <rkumpera@novell.com>

	* image.c (mono_image_load_module): Handle the case of
	module index equal or smaller than zero. It is possible
	to embed a valid zero index into metadata so this case
	must be explicitly handled.

	Patch by Sebastien Pouliot.

	Fixes #623581.

2010-07-27 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (INVALID_IMPLMAP_FLAGS_BITS): Add non standard
	bits for best fit on/off (4,5) and throw on unmappable on/off (12/13).

	Fixes #622221.

2010-07-27  Geoff Norton  <gnorton@novell.com>

	* sgen-archdep.h: Ensure we store the registers we actually
	need to scan.

2010-07-27 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (do_invoke_method): Improve error message.

2010-07-27 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (mono_generic_param_is_constraint_compatible): Don't
	fail a contraint check even if the candidate has no constraints.
	All constraints might resolve to the candidate itself so it can
	have none.

	Fixes #622225.

2010-07-25  Mark Probst  <mark.probst@gmail.com>

	* sgen-internal.c: Only compile this if HAVE_SGEN_GC is defined.

2010-07-24  Mark Probst  <mark.probst@gmail.com>

	* sgen-internal.c, sgen-gc.h, sgen-major-copying.c: Make the
	internal allocator fast by keeping free-lists of chunks, not only
	within chunks.  Align the chunks, so that on freeing we can get
	the chunk without searching.

2010-07-24  Mark Probst  <mark.probst@gmail.com>

	* sgen-internal.c, sgen-gc.c, sgen-gc.h, sgen-gray.c,
	sgen-major-copying.c, sgen-marksweep.c, sgen-pinning-stats.c,
	sgen-pinning.c: Allocate fixed-size structs without specifying the
	size, instead registering it once with its type.
	Dynamically-sized need their size specified when being freed.

2010-07-24  Mark Probst  <mark.probst@gmail.com>

	* sgen-major-copying.c, sgen-internal.c, sgen-gc.c, sgen-gc.h,
	sgen-pinning.c: Copying major collector doesn't mess around with
	internals of the internal allocator anymore, instead using public
	functions.

2010-07-24  Mark Probst  <mark.probst@gmail.com>

	* sgen-internal.c: Internal allocator in its own module.

	* sgen-gc.c, sgen-gc.h, sgen-gray.c, sgen-los.c,
	sgen-major-copying.c, sgen-marksweep.c, sgen-pinning.c,
	sgen-pinning-stats.c: Remove internal allocator and call the
	public functions now.

	* Makefile.am: Added new file.

2010-07-24  Zoltan Varga  <vargaz@gmail.com>

	* sgen-archdep.h (ARCH_COPY_SIGCTX_REGS): Fix warnings on amd64.

2010-07-24  Sanjoy Das <sanjoy@playingwithpointers.com>

	* sgen-gc.h: Removed 'foo defined but not used' warnings for the
	  *_signal_num variables.

2010-07-23  Zoltan Varga  <vargaz@gmail.com>

	* file-io.c (ves_icall_System_IO_MonoIO_Read): Add a null check.
	(ves_icall_System_IO_MonoIO_Write): Ditto.

	* loader.c (mono_loader_cleanup): Delete loader_mutex, the shutdown races should
	be fixed now.

2010-07-23  Zoltan Varga  <vargaz@gmail.com>

	* loader.c (mono_loader_lock_if_inited): New helper function which can be called
	during startup before the loader lock is initialized.
	(mono_loader_unlock_if_inited): Ditto.


2010-07-21  Geoff Norton  <gnorton@novell.com>

	* sgen-archdep.h: Fix the build on amd64-darwin.

2010-07-16  Zoltan Varga  <vargaz@gmail.com>

	* object.c (mono_print_unhandled_exception): Fix a warning.

2010-07-15 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* threadpool.c: use a monitor thread to start up new ones when needed.
	Fixes bug #622398.

Thu Jul 15 18:44:44 CEST 2010 Paolo Molaro <lupus@ximian.com>

	* reflection.c, class-internals.h, class.c, icall.c: support
	reflection of default constant value for Re.Emit properties.

2010-07-14  Miguel de Icaza  <miguel@novell.com>

	* reflection.c (load_cattr_value): Add support for encoding
	DateTime constants into the blob.    Turns out that this is
	required by .NET, it was only documented post 1.0.

	* icall.c (ves_icall_type_GetTypeCodeInternal): Guard test for
	System.Decimal and System.DateTime inside a mono_is_corlib_image
	call.   A sample program showed that we could return the wrong
	TypeCode just by creating a class with those names. 

	* class.c (mono_is_corlib_image): Exposed this to other metadata/
	code.

2010-07-14  Sebastien Pouliot  <sebastien@ximian.com>

	* security-core-clr.c: Don't abort (only warn) if we cannot find 
	a caller for relfecting code (transparent is assumed). Fix
	get_method_access_exception to accept a NULL caller.

2010-07-14  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Heavy statistics on the internal allocator.

2010-07-13  Mark Probst  <mark.probst@gmail.com>

	* sgen-marksweep.c, sgen-gc.h: Keep track of num_empty_blocks
	properly and in a thread-safe way.

2010-07-13  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-marksweep.c: Make object marking thread-safe.

2010-07-13  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Versions of safe_object_get_size() and
	copy_object_no_checks() that work without the object's vtable
	intact, by passing the correct vtable as an argument.

2010-07-13  Mark Probst  <mark.probst@gmail.com>

	* sgen-marksweep.c: Make allocation of major sections thread-safe.

2010-07-13  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-gc.h, sgen-los.c, sgen-major-copying.c,
	sgen-marksweep.c: Update the heap boundaries thread-safe and lock
	free if parallel mark is enabled.

2010-07-13  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-gc.h, sgen-major-copying.c: Lock the internal
	allocator if parallel mark (not committed yet) is enabled.

2010-07-12 Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (inflate_mono_method): Handle dynamic
	generic instances that have method.count set but
	methods not. Fixes another crash from boo's test suite.

2010-07-12 Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_MonoMethod_get_base_method): If
	the method slot is bigger than the class vtable, return
	the original method. Makes booc work again.

2010-07-12 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (mono_generic_param_is_constraint_compatible):
	The candidate type itself might satisty the required
	constraints.

	Fixes #621599.

2010-07-12 Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (fix_partial_generic_class): Inflate the
	generic instance parent in case it was changed after
	MonoGenericClass was instantiated.

	Fixes one of the issues from #389886.

2010-07-10  Mark Probst  <mark.probst@gmail.com>

	* sgen-gray.c: Store only a pointer to one end of the gray queue.

2010-07-10 Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (mono_method_signature_checked): Release the domain
	lock on failure.

2010-07-10  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Store the forwarding address in the first word of an
	object, where the forwarding bit is stored.

2010-07-10  Mark Probst  <mark.probst@gmail.com>

	* gc.c, gc-internal.h, sgen-gc.c, sgen-gc.h, sgen-os-mach.c: An
	interface to register our Mach exception thread which will not be
	suspended by stop-the-world.

2010-07-10 Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (mono_get_method_constrained): Properly unlock the
	domain lock on failure. Use checked variant of
	inflate_generic_signature.

2010-07-10 Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (mono_method_signature_checked): Use checked
	variant of inflate_generic_signature.

	Fixes #606353.

2010-07-10 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata.c (mono_metadata_parse_type_internal): Don't use
	cannonical types when a transient type was requested.

	Fixes #608626.

2010-07-10  Mark Probst  <mark.probst@gmail.com>

	* sgen-gray.c, sgen-gc.c, sgen-major-copying.c, sgen-marksweep.c:
	All functions that touch the gray queue directly or indirectly now
	take it as an argument.

2010-07-10  Mark Probst  <mark.probst@gmail.com>

	* sgen-gray.c, sgen-gc.c, sgen-major-copying.c, sgen-marksweep.c:
	Put the gray queue data into a struct and pass it around.

2010-07-09 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_method_can_access_method_full): Handle type
	accessibility with very deep nested types.

	* class.c (mono_method_can_access_field_full): Ditto.

	Fixes #619300.

2010-07-10  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-los.c, sgen-major-copying.c, sgen-marksweep.c,
	sgen-scan-object.h: Use a macro for rounding up sizes and
	addresses to ALLOC_ALIGN.

2010-07-09 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* file-io.c: fix GetFileSystemEntries for patterns containing
	directories.

2010-07-09  Mark Probst  <mark.probst@gmail.com>

	* sgen-marksweep.c (major_finish_major_collection): Don't free
	major heap blocks on 32 bit platforms because it can lead to
	address space fragmentation.  We'll figure this out later.

2010-07-09  Mark Probst  <mark.probst@gmail.com>

	* sgen-marksweep.c, sgen-gc.c, sgen-major-copying.c: Free major
	heap blocks for mark&sweep eventually.

2010-07-09  Mark Probst  <mark.probst@gmail.com>

	* sgen-protocol.c: Fix build when binary protocol is disabled.

2010-07-09  Mark Probst  <mark.probst@gmail.com>

	* sgen-protocol.c, sgen-gc.c: Make binary protocol lock-freely
	thread-safe.

2010-07-08 Neale Ferguson <neale@sinenomine.net>

	* sgen-archdep.h: Add support for s390x
	* domain.c: Use gsize so that 64-bit big endian systems produce 
	bitmap.

2010-07-08 Rodrigo Kumpera  <rkumpera@novell.com>

	* pedump.c (verify_image_file): Initialize the vtable as well.

2010-07-07  Geoff Norton  <gnorton@novell.com>

	* sgen-gc.h:  Not every system has sys/signal.h.  Prefer the posix
	header.

2010-07-08 Rodrigo Kumpera  <rkumpera@novell.com>

	* assembly.c (mono_assembly_load_reference): Replace a g_warning
	with a mono_trace calls. This makes compiling MD a lot less scary.

2010-07-08 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (do_stobj): Improve error message.

2010-07-08  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c (OBJ_COMPLEX_ARR_FOREACH_PTR): Don't load the vtable
	from the object because it might have pinned/forwarding bits set.

2010-07-06  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am (sgen_sources): Add missing sgen files.

2010-06-07  Martin Baulig  <martin@ximian.com>

	* mono-debug-debugger.c (mono_debugger_get_thread_abort_signal):
	New helper function since mono_thread_get_abort_signal() is now
	internal.

2010-06-07  Martin Baulig  <martin@ximian.com>

	* mono-debug.h, debug-mono-symfile.h: Kill glib dependencies.

2010-07-02  Michael Hutchinson  <mhutchinson@novell.com>

	* object-internals.h, object.h: Make mono_string_to_utf_8_checked 
	public, as mono_string_to_utf_8 is deprecated.

	* object.(c|h): Added mono_object_to_string, a public helper function 
	that calls ToString on a MonoObject and returns a MonoString.

	* object.c (mono_print_unhandled_exception): Use mono_object_to_string.

2010-07-01  Zoltan Varga  <vargaz@gmail.com>

	* filewatcher.h filewatcher.h decimal.c threads-types.h: Applied patch
	from Elijah Taylor (elijahtaylor@google.com). Fix some definitions to
	match their declarations and vice-versa.


Wed Jun 30 12:08:36 CEST 2010 Paolo Molaro <lupus@ximian.com>

	* class-internals.h, domain-internals.h: mark functions that are
	needed by the llvm module.

2010-06-30 Rodrigo Kumpera  <rkumpera@novell.com>

	* assembly.c (framework_assemblies): Add 3.5 assemblies.

	* domain-internals.h (MonoRuntimeInfo): Increase version_sets
	by one to have room to remap 3.5 assemblies.

	* domain.c (supported_runtimes): Add 3.5 remapping information.

2010-06-30 Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (mono_image_create_token): Handle a
	FieldBuilder from a different assembly.

	Fixes #611836.

2010-06-30 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (do_store_static_field): Improve error
	message.

2010-06-29 Rodrigo Kumpera  <rkumpera@novell.com>

	* assembly.c: Revert r159692 since it breaks loading 3.5
	assemblies under 2.0.

2010-06-29 Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_Type_make_array_type): Raise a TLE if a
	TypedByRef is passed.

	* icall.c (ves_icall_Type_make_byref_type): Ditto.

	* icall.c (ves_icall_Type_MakePointerType): Ditto.

	Fixes #612780.

2010-06-29 Rodrigo Kumpera  <rkumpera@novell.com>

	* assembly.c: Add a few more assemblies to the list of framework
	assemblies.

	Fixes #617714.

2010-06-28  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_get_vtable_entry): Avoid a crash if mono_class_setup_vtable ()
	fails.

2010-06-25  Mark Probst  <mark.probst@gmail.com>

	* class.c (mono_class_inflate_generic_method_full_checked): Added
	a comment regarding a hack in mini-trampolines.c.

2010-06-26  Zoltan Varga  <vargaz@gmail.com>

	* sgen-gc.c (mono_gc_wbarrier_value_copy_bitmap): Use SIZEOF_VOID_P instead of
	sizeof(SIZEOF_VOID_P) which is 4.

	* gc.c (mono_gc_init): Move the GC disabled check to *-gc.c.

2010-06-25  Zoltan Varga  <vargaz@gmail.com>

	* null-gc.c boehm-gc.c: Define the mono_gc_ pthread wrapper functions for these
	GCs too.

	* *-gc.c (mono_gc_wbarrier_value_copy_bitmap): Implement this for all GCs.

	* sgen-gc.c (mono_gc_is_moving): New function returning whenever this GC can move
	objects.

	* *-gc.c (mono_gc_set_desktop_mode): New function setting up the GC to work in
	desktop mode.

2010-06-25  Zoltan Varga  <vargaz@gmail.com>

	* *-gc.c (mono_gc_get_description): New function returning a human readable
	description of the current GC.

2010-06-24  Miguel de Icaza  <miguel@novell.com>

	* mono-hash.c: Moved here from mono/utils as this file is
	GC-aware, and the utils directory is not.

2010-06-23  Miguel de Icaza  <miguel@novell.com>

	* Makefile.am: Add support for building a sgen-aware versions of
	the libraries: libmonoruntimesgen.la libmonoruntimesgen-static.la,
	they share all the components of the default, but use a differen
	set of CFLAGS to enable SGEN instead.

	Put the BOEHM defines in the CFLAGS definition. 

	* domain-internals.h (MonoJitInfo): this structure used to have
	different sizes depending on the GC that was configured (Boehm vs
	SGen).   I have removed this difference for the sake of avoiding
	the complexity of dealing with the mono/arch directory requiring
	GC-specific changes to their Makefiles.

2010-06-23  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-los.c, sgen-marksweep.c: Fix warnings.

2010-06-22 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata.c (mono_metadata_type_hash): Don't hash
	the type kind for dynamic types since it can change.

2010-06-22 Geoff Norton  <gnorton@novell.com>

	* sgen-os-mach.c: We cannot call malloc from the gc, so we need to use
	alloca instead to prevent a deadlock.

2010-06-22  Geoff Norton  <gnorton@novell.com>

	* domain.c: Allow gettings the tls key, since we need it for
	cross thread tls poking in sgen-mach
	* sgen-gc.(c|h), gc-internal.h: Rework sgen into having some functions
	in external files for platform specific STW support.
	* sgen-os-mach.c: Add a new mach kernel backend implementation of STW.
	* sgen-os-posix.c: Move the existing posix signal based STW here.

2010-06-21  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_array_to_lparray): Allow MONO_TYPE_PTR. Fixes #615952.

2010-06-21 Rodrigo Kumpera  <rkumpera@novell.com>

	* object-internals.h: Map new PropertyBuilder fields.

	* reflection.c (property_encode_signature): Emit an instance
	signature if property's callconv is hasthis.

	* appdomain.c: Bump corlib version.

2010-06-20  Jb Evain  <jbevain@novell.com>

	* metadata-verify.c: do not consider the assembly invalid if it
	doesn't have a #Blob stream as resource assemblies don't
	necessarily have one.

2010-06-17  Geoff Norton  <gnorton@novell.com>

	* sgen-archdep.h: sgen support for arm linux and darwin.

2010-06-17  Zoltan Varga  <vargaz@gmail.com>

	* loader.c (mono_method_get_header): Avoid a crash if the declaring method
	has a faulty header.

2010-06-17 Rodrigo Kumpera  <rkumpera@novell.com>

	* sgen-gc.c (mono_gc_wbarrier_value_copy_bitmap): Work in a similar
	way to mono_gc_wbarrier_value_copy but takes a bitmap that
	indicates which slots need a write barrier.

2010-06-14  Jonathan Pryor <jpryor@novell.com>

	* Makefile.am (EXTRA_DIST): Add runtime.h.

2010-06-14  Zoltan Varga  <vargaz@gmail.com>

	* object.c (build_imt_slots): Don't crash if callbacks.get_imt_trampoline is not set.

2010-06-11  Zoltan Varga  <vargaz@gmail.com>

	* object.c (mono_method_add_generic_virtual_invocation): Fix the computation of the
	IMT slot which is passed to callbacks.get_imt_trampoline.

2010-06-11  Zoltan Varga  <vargaz@gmail.com>

	* object.c: Use a callback to create IMT trampolines, allowing the usage of one
	imt trampoline per imt slot when using LLVM.

2010-06-10  Jonathan Pryor <jpryor@novell.com>

	* object.c (mono_runtime_run_main): Move fire_process_exit_event() into
	  runtime.c:mono_runtime_shutdown().
	* runtime.c: Added; adds mono_runtime_shutdown(), which invokes the
	  AppDomain.ProcessExit event in all AppDomains.

2010-06-06  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_get_runtime_invoke): Don't set *exc to NULL, it is now
	done by the caller.

2010-06-05  Mark Probst  <mark.probst@gmail.com>

	* sgen-los.c: Keep bitmaps on chunk usage in LOS sections to speed
	up freeing.

2010-06-05  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-los.c: New LOS allocator that allocates large
	segments of memory at once, to reduce the number of mmap/munmap
	calls.

2010-06-05  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-protocol.c, sgen-protocol.h: Protocol degraded
	allocations and distinguish between normal, degraded and pinned
	allocations.

2010-06-05  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-major-copying.c, sgen-marksweep.c: Make degraded
	allocations count toward major collections and trigger major
	collections from degraded allocations if appropriate.

2010-06-05  Mark Probst  <mark.probst@gmail.com>

	* sgen-marksweep.c (ms_get_empty_block): Update heap boundaries.

2010-06-05  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Enable mark&sweep again.

2010-06-05  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Increase the maximum small object size to 8000 bytes.

2010-06-05  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-major-copying.c, sgen-marksweep.c: Have only one
	major heap allowance for minor collections, instead of two
	separate ones for small and large objects.  This reduces the
	number of major collections.

2010-06-04  Damien Diederen  <dd@crosstwine.com>

	* icall.c (ves_icall_System_Char_GetDataTablePointers),
	char-conversions.h: New Unicode category tables compatible with MS .NET

	These new category tables, generated using create-category-table(.cs)
	available in the mcs sources, make the Mono runtime understand the
	same Unicode category codes as recent versions of Microsoft's runtime.

	CategoryData_v2 matches versions v2.0.50727 and v3.5.21022 of .NET.

	CategoryData_v4 matches version v4.0.30319 of .NET.  The v4 tables
	can be disabled by defining the DISABLE_NET_4_0 preprocessor symbol.

	Similarly, the astral portions of both tables can be disabled by
	defining the DISABLE_ASTRAL preprocessor symbol.

	CAUTION: Mcs has to be updated with the corresponding patches, or
	Mono will suffer a low-level (internal call) crash when
	initializing System.Char.


2010-06-04  Marek Habersack  <mhabersack@novell.com>

	* icall.c (ves_icall_MonoType_GetEvent): be case insensitive is
	the BFLAGS_IgnoreCase is raised

2010-06-03  Zoltan Varga  <vargaz@gmail.com>

	* debug-mono-symfile.c (mono_debug_symfile_lookup_locals): Rewrite this so it returns
	all information in a single structure. Return information about scopes as well.

	* mono-debug.c (mono_debug_lookup_locals): Ditto.

2010-06-02  Geoff Norton  <gnorton@novell.com>

	* appdomain.c: If we are running with IOMAP we might
	have been provided a string that isn't case-aware for our file-
	system, so we need to use io-portability to check if the file 
	exists, rather than a simple glib test.

	Fixes #608849

2010-06-02 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (verify_generic_parameters): Verify if
	there are not loops in constraints.

2010-06-02 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (is_compatible_boxed_valuetype): Constaints
	must be recursively checked if one generic argument
	has a constraint on another.

	Fixes #610625.

2010-05-31  Miguel de Icaza  <miguel@novell.com>

	* console-unix.c (terminal_get_dimensions): Fix my previous
	botched commit and return the actual value obtained from the ioctl.

2010-05-29  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Always use DESC_TYPE_RUN_LENGTH for objects without
	references so that we don't have to do the cache-cold fetch of the
	class in copy_object_no_checks().

2010-05-29  Robert Jordan  <robertj@gmx.net>

	* marshal.c (mono_marshal_asany): marshal LPWSTRs using
	mono_marshal_string_to_utf16_copy () to avoid memory allocation
	mismatches under Windows. Fixes pinvoke2:test_0_asany.

2010-05-28  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Change default nursery size to 4MB, because it
	improves performance on many applications and benchmarks.

2010-05-28  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-scan-object.h: Value types in arrays are not
	always aligned to ALLOC_ALIGN.  To handle this, shift the size in
	the GC descriptor by one bit, and don't encode the size for value
	types not containing references.  Also get rid of
	DESC_TYPE_STRING.

2010-05-28  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Don't depend on the size encoded in a GC descriptor
	other than for remset processing.

2010-05-28  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: More and better remset consistency checks.

2010-05-28 Rodrigo Kumpera  <rkumpera@novell.com>

	* sgen-gc.c: Add a note about the int[] trick to avoid some
	memset.

2010-05-27 Rodrigo Kumpera  <rkumpera@novell.com>

	* sgen-gc.c (sort_addresses): Use heap sort since it has better
	performance.

	This helps programs with lots of threads or thread with big stacks
	since the bottleneck the pin queue can get quite big.

2010-05-26 Rodrigo Kumpera  <rkumpera@novell.com>

	* sgen-gc.c (search_fragment_for_size): Move fragment setup into
	a separate function called setup_fragment.

	* sgen-gc.c (search_fragment_for_size_range): Variant of
	search_fragment_for_size that does search for a secondary smaller
	size.

	* sgen-gc.c (mono_gc_alloc_obj_nolock): Use search_fragment_for_size_range
	for tlab allocation so small fragments are used.

	This patch uses small fragments for tlab allocation when possible in order
	to improve nursery utilization. With a fixed size tlab this patch is not very
	usefull but once size gets dynamically adjusted, this will be invaluable.

	Performance under pystone 500k is unchanged. Nursery utilization improves by
	3.5% and 18 more fragments are used per minor GC.

	Performance under modified binary-tree is unchanged. Nursery utilization
	improves by 0.5% and 3 more fragments are used per minor GC.

	These numbers make sense since as more pinning happens, more fragments are
	created and so are the chances of having a bunch of small ones.

2010-05-26 Rodrigo Kumpera  <rkumpera@novell.com>
	* sgen-gc.c (mono_gc_alloc_obj_nolock): Avoid wasting space	from
	the current fragment when allocating a TLAB.

	Reduces number of pystone 500k minor collections by 7%.

2010-05-25  Martin Baulig  <martin@ximian.com>

	Applying a patch from Lucas Meijer <lucas@lucasmeijer.com>.

	* debug-mono-symfile.c: Release memory from symfiles that were
	loaded from memory.

2010-05-24  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_free_dynamic_wrappers): Avoid an assert when this is called
	during shutdown.

2010-05-22  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_get_runtime_invoke): Simplify the code computing the
	target class and remove some dead code.

2010-05-22  Zoltan Varga  <vargaz@gmail.com>

	* metadata.c: Add a 'transient' argument to the MonoType creation functions, so
	the MonoTypes inside method headers can be freed when the header is freed.

2010-05-21  Zoltan Varga  <vargaz@gmail.com>

	* threadpool.c: Fix the DISABLE_SOCKETS build.

2010-05-19 Martin Baulig  <martin@novell.com>

	Fix #604911.

	* threads.c (wait_for_tids_or_state_change): Use an
	alertable WaitForMultipleObjectsEx().
	(wait_for_tids): Likewise.

2010-05-19 Rodrigo Kumpera  <rkumpera@novell.com>

	* marshal.c (mono_marshal_init): Register mono_gchandle_get_target
	icall.

	* marshal.c (mono_delegate_to_ftnptr): Use a gchandle instead of
	gc tracked memory.

	* marshal.c (mono_marshal_emit_managed_wrapper): Retrieve the first
	argument from a gchandle.

	* marshal.c: Get rid of the delegate_target_locations hash table.

	Fixes #605295.

2010-05-17 Rodrigo Kumpera  <rkumpera@novell.com>

	* sgen-gc.c: Use _fast variants	for string and array length.

2010-05-17 Rodrigo Kumpera  <rkumpera@novell.com>

	* sgen-gc.c: Fix counters to be 64 bits.

	* sgen-gc.c (dump_heap): Fix formating strings.

2010-05-17 Rodrigo Kumpera  <rkumpera@novell.com>

	* sgen-gc.c (global_remset_location_was_not_added): New
	function that implements a 2 element LRU cache for just
	added remsets. It is used to avoid adding duplicate ones.

	* sgen-gc.c (add_to_global_remset): Check cache	before
	adding new entry.

	* sgen-gc.c (scan_from_remsets): Don't process global remsets
	that fail the cache test.

	* sgen-gc.c (scan_from_remsets): Simplify the global remset
	loop removing one condtion that is not possible.

	A 2 element LRU cache was chosen by profiling IronPython 2.6
	pytones with 1M passes and corlib compilation.

	For the ipy test duplication was originally 940.92, measured
	by "Store remsets" divided by "Unique store remsets".

	With a 2-element LRU, duplication went to 1.007. Without the
	check in scan_from_remsets 1.438.

	With a 16-elements LRU, duplication reduction was negligibe.
	A single element cache was basically of no use.

	With corlib compilation duplication went from  1.4 to 1.02.

	Performance results is a 20% time decrease for ipy and 2%
	with corlib.
2010-05-16  Zoltan Varga  <vargaz@gmail.com>

	* mono-debug.c (mono_debug_cleanup): Fix a crash in the previous change.

2010-05-15  Geoff Norton  <gnorton@novell.com>

	* mono-debug.c: Fix a leak of the global table on shutdown.

2010-05-15  Geoff Norton  <gnorton@novell.com>

	* debug-mono-symfile.(c|h): Add mono_debug_symfile_free_location
	to clean up MonoDebugSourceLocation's.

2010-05-13 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_create_from_typedef): Fail a class
	if there is a loop with its parent.

	Fixes #598239.

2010-05-13 Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (mono_loader_set_error_type_load): Convert
	a g_warninig to mono_trace_warning.

2010-05-13 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_get_full): Release strings on failure
	to avoid leaking them.

2010-05-13 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_create_from_typedef): Only return
	the class if no exceptions were detected.

	* class.c (mono_class_create_from_typedef): Don't remove
	broken classes from class_cache. Just set failure and
	bail out.

	This fixes a memory a memory leak where resolving the same
	broken class multiple times resulted in a memory leak.

	The right behavior would be to actually return the class
	a let the caller figure it out.

2010-05-13 Rodrigo Kumpera  <rkumpera@novell.com>

	* mono-ptr-array.h: Add mono_ptr_array_sort.

	* reflection.c (mono_image_build_metadata): Replace that ugly
	qsort call with mono_ptr_array_sort.

2010-05-13  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Switch to the copying major collector, because
	Mark&Sweep is still buggy.

2010-05-13 Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (mono_image_build_metadata): Don't put managed
	references on non-tracked memory.

2010-05-13  Zoltan Varga  <vargaz@gmail.com>

	* sgen-archdep.h (ARCH_COPY_SIGCTX_REGS): Fix this for amd64.

2010-05-12 Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c: Switch to mono-ptr-array.h.

2010-05-12 Rodrigo Kumpera  <rkumpera@novell.com>

	* Makefile.am: Add mono-ptr-array.h.

	* mono-ptr-array.h: New header that implements
	a GC tracked equivalent of g_ptr_array.	

2010-05-12 Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_Type_GetInterfaces): Rewrite this
	method to avoid initializing the class.

	Fixes #605115.

2010-05-12 Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_System_MonoType_getFullName): It
	doesn't require to init the class.

2010-05-11  Miguel de Icaza  <miguel@novell.com>

	* console-unix.c: Signal handlers now save and restore errno.   We
	have never had a bug report about this, ioctl does change errno. 

	Hide the unused method.   

	Remove internal declarations from public headers.

	Document what the signal handler is doing

2010-05-11 Rodrigo Kumpera  <rkumpera@novell.com>

	* sgen-gc.c (clear_unreachable_ephemerons): Clear
	unreachable keys with a tombstone.

	* sgen-gc.c (mark_ephemerons_in_range): Ignore
	tombstone keys.

2010-05-11 Rodrigo Kumpera  <rkumpera@novell.com>

	* icall-def.h:
	* gc-internals.h:
	* gc.c: New GC:get_ephemeron_tombstone.

2010-05-11 Rodrigo Kumpera  <rkumpera@novell.com>

	* appdomain.c (create_exceptions): Rename to
	create_domain_objects. Create the ephemeron tombstone object.

	* domains-internals.h (MonoDomain): Add new field for the
	ephemeron tombstone.

	* domain.c (mono_domain_free): Set ephemeron_tombstone to
	NULL.

2010-05-11 Rodrigo Kumpera  <rkumpera@novell.com>

	* sgen-gc.c (mono_gc_clear_domain): Both ephemerons
	and dislinks must be processed before LOS since they
	could end up with pointers to memory returned to the
	OS.

2010-05-11  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_alloc): New helper function to centralize memory allocation
	for classes, allocates either from the image mempool or from the heap.

	* class.c: Use mono_class_alloc to allocate memory owned by classes.

	* metadata.c (free_generic_class_dependents): Free more items belonging to
	generic classes.

2010-05-10  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (mono_reflection_method_get_handle): Handle MonoGenericMethod
	as well. Fixes #604054.

2010-05-07 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: MS doesn't mind duplicates in the
	typeref table. Move it to full verification.

	Fixes #600508.

2010-05-07 Rodrigo Kumpera  <rkumpera@novell.com>

	* image.c (do_mono_image_load): Report verification
	errors when loading an image fails.

2010-05-07 Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (mono_type_get_object): Remove chunk of code
	no longer in use.

2010-05-07 Rodrigo Kumpera  <rkumpera@novell.com>

	* icall-def.h
	* icall.c: Delete some unused icalls.

2010-05-07 Rodrigo Kumpera  <rkumpera@novell.com>

	* appdomain.c (mono_domain_has_type_resolve): Check for
	NULL domain objects to make pedump happy.

	* object.c (mono_field_get_value): Assert on NULL object.
	It's the caller resposibility to check for this.

	* object.c (mono_field_get_value_object): Ditto.

	Fixes #601384.

2010-05-07 Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_type_is_subtype_of): Non iface subtype
	checks can avoid doing a mono_class_init.

	* icall.c: Remove mono_class_init from a bunch of icalls that
	don't need it.

	Hopefully we're now lazy enough to fix most victims of #601431.

2010-05-07  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Remove REMSET_ROOT_LOCATION.

2010-05-07  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Remove unnecessary checks in domain clearing code.

2010-05-07  Marek Habersack  <mhabersack@novell.com>

	* culture-info-tables.h: updated to include en-TT culture. Fixes
	bug #594035

2010-05-06 Rodrigo Kumpera  <rkumpera@novell.com>

	Move mono_class_init from mono_type_get_object to icalls.
	This causes massive memory savings for Assembly::GetTypes () and
	make it fail a lot less due to missing dependencies.

	This is a conservative, naive change as it doesn't remove some
	mono_class_init from places that might not need them. Carefull
	review of those should follow.

	* reflection.c (mono_type_get_object): Don't mono_class_init the
	returning type.

	* reflection.c:
	* cominterop.c:
	* icall.c:
	* marshal.c: Call mono_class_init in functions receiving a MonoType
	object.

	First step into fixing #601431.

2010-05-06 Rodrigo Kumpera  <rkumpera@novell.com>

	* gc-internal.h: Add new functions required for ephemeron support.

	* gc.c: Implement ves_icall_System_GC_register_ephemeron_array.

	* icall-def.h: Add GC::register_ephemeron_array.

	* object.c (compute_class_bitmap): sys.rt.cs.Ephemeronis an opaque type
	under sgen. Its fields must not be marked.

	* sgen-gc.c (mono_gc_clear_domain): Call cleanup function for ephemerons.

	* sgen-gc.c (finish_gray_stack): Mark all reachable ephemerons before
	handling finalizable objects. Clean dead ones after all finalizable
	handling.

	* sgen-gc.c (dump_heap): Add new kind of internal memory.

	* sgen-gc.c (null_ephemerons_for_domain): Remove from the list ephemeron
	arrays from the dead domain.

	* sgen-gc.c (clear_unreachable_ephemerons): Clear dead ephemerons entries.

	* sgen-gc.c (mark_ephemerons_in_range): Mark/Copy all ephemeron values
	whose keys are reachable.

	* sgen-gc.c (mono_gc_ephemeron_array_add): Register the array into the
	list of live ephemeron arrays.

2010-05-05 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_layout_fields): Don't perform alignment
	if align is zero.

	* class.c (mono_class_layout_fields): Init field related information
	to sane defaults.

2010-05-05 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (mono_verifier_verify_class): Verify the constraint
	of generic type definitions.

2010-05-04  Mark Probst  <mark.probst@gmail.com>

	* sgen-marksweep.c: Simplify free list maintenance in sweep.

2010-05-02  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-marksweep.c, sgen-major-copying.c: Unify
	major_do_collection() across the two major collectors.

2010-05-02  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Add heavy statistics counter for re-added global
	remsets.

2010-05-02  Mark Probst  <mark.probst@gmail.com>

	* sgen-marksweep.c, sgen-gc.c: Use one mark bit per ALLOC_ALIGN to
	get rid of a division in critical code.

2010-04-29  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-marksweep.c, sgen-major-copying.c: Have separate
	blocks for objects without references in mark&sweep, to improve
	performance.

2010-04-28  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-marksweep.c, sgen-major-copying.c: Bring heavy
	statistics up-to-date.

2010-04-27  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-marksweep.c, sgen-major-copying.c: Support
	heap-dump for mark&sweep.

2010-04-27  Zoltan Varga  <vargaz@gmail.com>

	* loader.c (mono_method_get_header): Move the is_inflated case before the
	wrapper case, as a method can be both.

2010-04-27  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-marksweep.c, sgen-major-copying.c: Don't do a
	separate pass to scan pinned and large object but use the gray
	queue like for regular objects.

2010-04-26  Zoltan Varga  <vargaz@gmail.com>

	* boehm-gc.c: Applied patch from Robert Nagy (robert@openbsd.org). Include
	string.h for memmove.

	socket-io.c: Applied patch from Robert Nagy (robert@openbsd.org).
	ipaddress_to_struct_in6_addr() is only needed when
	defined(HAVE_STRUCT_IP_MREQN) || defined(HAVE_STRUCT_IP_MREQ).

2010-04-25  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-marksweep.c, sgen-major-copying.c: Properly
	separate copy_object functions for major vs nursery.  Allows us to
	get rid of a few checks and the start and end parameters for many
	functions.

2010-04-25  Mark Probst  <mark.probst@gmail.com>

	* sgen-marksweep.c, sgen-gc.c, sgen-major-copying.c,
	sgen-protocol.c, sgen-protocol.h, Makefile.am: Major Mark&Sweep
	collector.

2010-04-25  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_create_from_typedef): Initialize class->nested_in after
	calling setup_mono_type () since the nested parent could recursively reference
	the nested class using generic constraints. Fixes #599469.

2010-04-24  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-pinning.c, sgen-major-copying.c: Major collector
	abstraction.

2010-04-24  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Remove more unneeded code.

2010-04-24  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Disable managed allocator and wbarrier when the
	binary protocol is enabled.

2010-04-24  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Put nursery-fragment-cleaning into its own function.

2010-04-24  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Remove a few commented out and unneeded bits.

2010-04-23 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* threadpool.c: patch from Robert Nagy that fixes a nullref and
	uses mono_sem_wait instead of mono_sem_timedwait for openbsd.

2010-04-20 Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_type_is_assignable_from): Properly handle byref
	types.

	Fixes #331126

2010-04-21  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Turn off semi-precise stack mark.

2010-04-20  Sebastien Pouliot  <sebastien@ximian.com>

	* reflection.c (mono_custom_attrs_from_index): Use right function
	to free 'list' (i.e. g_list_free) if the verifier fails.

2010-04-19 Rodrigo Kumpera  <rkumpera@novell.com>

		* verify.c: Handle the case where mono_type_get_underlying_type_any
		returns NULL. Remove duplicated code between MONO_TYPE_GENERICINST
	 	and MONO_TYPE_VALUETYPE in those case.

		Based on a slightly modified patch by Sebastien Pouliot  <sebastien@ximian.com>

		Hopefully Fixes #564253.

2010-04-19 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* domain-internals.h: made threadpool_jobs volatile.
	* mono-wsq.c: add an assert to verify that the threadpool cleaned up
	all local jobs.
	* threadpool.c:
		-When two threads try to initialize the socket IO pool,
		the second one waits until the intialization is finished
		instead of continuing right away.
		-Add checks for domain unload: no items added in this case.
		-Only measure the time every 10 elements added to the queue.
		This is an experiment since linux x86 gettimeofday() sucks.
		-Create new thread if there are none waiting for work items.
		-There was a missing decrement of the busy threads.
		-Make sure the local queue is cleaned up before exiting the
		thread when the program ends.

2010-04-19 Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (mono_type_get_object): Normalize generics types
	as to how managed code expect them to be. A generic instance over
	the GTD arguments must have the same mirror as the GTD itself.

	Fixes #473289.

2010-04-19  Zoltan Varga  <vargaz@gmail.com>

	* locales.c: Implement support for DISABLE_NORMALIZATION.

2010-04-16  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_get_native_func_wrapper): Set the marshal info to NULL,
	since it is not a MonoMethod.

2010-04-16  Sebastien Pouliot  <sebastien@ximian.com>

	* icall-def.h: Add get_RequiresElevatedPermissions icall to
	System.Security.SecurityManager - used only by Moonlight
	* security-core-clr.c|h: Add Elevated Trust/Permission support
	for CoreCLR / Moonlight

2010-04-16  Zoltan Varga  <vargaz@gmail.com>

	* boehm-gc.c (mono_gc_base_init): Applied patch from Robert Nagy
	(robert@openbsd.org). Fix GC_stackbottom calculation on OpenBSD.

2010-04-16  Marek Habersack  <mhabersack@novell.com>

	* mono-perfcounters.c: added code for the "Mono
	Memory/Total Physical Memory" performance counter.

	* mono-perfcounters-def.h: added definition of the "Mono
	Memory/Total Physical Memory" performance counter.

2010-04-15 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_get_method_by_index): Return NULL
	on type load failures.

2010-04-15 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_from_typeref): Check if the supplied
	image has an assembly bound to it.

	Fixes #567884.

2010-04-15 Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (mono_method_get_signature_full): Use new function
	inflate_generic_signature_checked to check for errors.

	Fixes #560839.

2010-04-15 Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (inflate_generic_signature): Add _checked variant
	and move this function to use it.

2010-04-15 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_setup_vtable_general): Use error checking
	version of mono_class_inflate_generic_method_full.

	Fixes #596975.

2010-04-15 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_inflate_generic_type_no_copy): Do proper
	error handling passing MonoError around.

	Fixes #560336.

2010-04-14 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* socket-io.c: make GetHostByName ("") work on windows.
	Fixes bug #456723.

2010-04-14 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* object-internals.h:
	* threads.c: use a spin lock when accesing the per-thread appdomain
	list.

2010-04-14 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* threads.c: no need to take the threads lock in push/pop appdomain.

2010-04-14 Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (_mono_reflection_parse_type): MS supports
	non-assembly-qualified types in a generic type parameter list
	when enclosed in '[]' (which signals that they should be a fqn).

	This breaks ECMA specs for how type names are encoded in cattr
	blobs but F# does it.

	Fixes #576342.

2010-04-14 Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_InternalInvoke): Check if the vtable is sane
	for instance methods/ctors.

	Fixes #422113.

2010-04-13 Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c: Use the new verifier support for checking
	custom attributes.

	Fixes #595306.

2010-04-13 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Implement structural verification
	of custom attributes. This check requires access to the
	loader since to resolve the size of an enum we have to
	look it up.
	We don't check if named argumenments are encoded in a
	compatible fashion to their underlying field/prop.
	Maybe we should?

	* verify-internals.h: Add two new cattr verification API.

2010-04-13 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (decode_signature_header): Fix signature.

2010-04-13 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (mono_verifier_is_enabled_for_method): Handle
	assembly less images.

	* verify.c (mono_verifier_is_class_full_trust): Ditto.

2010-04-13 Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (mono_method_signature_checked): Properly
	init MonoError.

	* loader.c (mono_method_signature): It's the calee
	resposibility to init the error object.

2010-04-13 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (decode_signature_header): Do proper
	overflow checking.

Tue Apr 13 12:36:29 CEST 2010 Paolo Molaro <lupus@ximian.com>

	* reflection.c: maintain the invariants required by
	mono_class_layout_fields() also in typebuilder_setup_fields ().

2010-04-11  Sebastien Pouliot  <sebastien@ximian.com>

	* security-core-clr.c: Call mono_class_setup_methods in 
	get_default_ctor before checking klass->methods. Fix typo in
	comment

2010-04-10  Jb Evain  <jbevain@novell.com>

	* domain.c (supported_runtimes): remove .net 4.0 beta 2 and
	add .net 4.0 RTM version.

2010-04-09 Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (resolve_object): Properly inflate generic
	methods when a context is supplied.

	Fixes #591226.

2010-04-09 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (mono_method_verify): A switch op don't empty
	the stack for the next one. Fixes a bug when running fsi
	under --verify-all.

2010-04-09 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (is_valid_standalonesig_blob): Accept
	fields as valid standalone sig too. F# does generate them.

	* metadata-verify.c (verify_typedef_table_full): Ignore
	what <module> extends.

2010-04-09 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (do_invoke_method): It's ok to do use call with
	virtual, non-final methods if their class is sealed.

2010-04-08 Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_MonoField_GetValueInternal): This function
	is a near identical copy of mono_field_get_value_object. So simply
	call it.

	* object.c (mono_field_get_value_object): Handle literal fields
	on open generic classes.

	Fixes #594942.

2010-04-08 Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (mono_reflection_create_runtime_class): Setup
	parent/supertype information again since it can be changed
	without notice.

2010-04-07 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (verify_type_compatibility_full): Properly handle
	stores between arrays of primitives.

	Fixes the verifier side of #555950.

2010-04-07 Rodrigo Kumpera  <rkumpera@novell.com>

	class.c (mono_bounded_array_class_get): Properly init
	cast_class to take the fact that uint[] and int[] can be
	casted between each other.

	Fixes #555950.

2010-04-07  Geoff Norton  <gnorton@novell.com>

	* domain.c: Avoid a deadlock on osx.  Fixes #565765

2010-04-08  Zoltan Varga  <vargaz@gmail.com>

	* icall.c (ves_icall_System_Enum_ToObject): Avoid a crash for unfinished type
	builders. Fixes #594464.

2010-04-08  Zoltan Varga  <vargaz@gmail.com>

	* icall.c (ves_icall_System_Environment_Exit): Shutdown the threadpool before
	waiting for all threads to suspend, as those threads can't be suspended.

2010-04-08  Zoltan Varga  <vargaz@gmail.com>

	* threads.c (mono_thread_suspend_all_other_threads): Call ensure_synch_cs_set ()
	to avoid crashes on newly created threads.

2010-04-07 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* file-io.c: reset the MonoIOStat structure in case of error.
	Fixes bug #582667.

2010-04-06 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (print_implemented_interfaces): Print proper type name.

	* class.c (mono_class_setup_vtable): Don't try that hard to produce
	the override map for generic instances since it later ignored.

	* class.c (mono_class_implement_interface_slow): Don't break for
	dynamic generic instances.

	* object.c (mono_runtime_invoke_array): Add an assert for allocation.

	* reflection.c (mono_reflection_method_get_handle): New method that
	resolves a method handle.

	* reflection.c (mono_reflection_get_dynamic_overrides): Handle the
	case when we override methods from a dynamic generic instance interface.

	Fixes #575941.

2010-04-05 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* threadpool.c: don't attempt to close the pipe when it has not been
	created.

2010-04-05 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* threadpool.c: if there are no waiting threads, try to start a new
	one. This fixes the not-so-random hangs in System.ServiceModel tests.
	No need to use InterlockedCompareExchange to read volatile variables.

2010-04-05 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (verify_type_compatibility_full): Fail mixed valuetype
	and reference types that point to the same class.

	Fixes #565598.

2010-04-05 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (verify_stack_type_compatibility_full): Ignore constraints
	when verifying compatibility between a generic instance and a generic
	parameter.

	* verify.c (check_is_valid_type_for_field_ops): Improve error message.

	* verify.c (stack_slot_stack_type_full_name): Improve verification type
	name.

	Fixes #587849.

2010-04-04  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Remove superfluous scanning of alloc-pinned objects.

2010-04-04  Zoltan Varga  <vargaz@gmail.com>

	* threads.c Applied some openbsd changes from Robert Nagy <robert@openbsd.org>.

2010-04-03  Marek Habersack  <mhabersack@novell.com>

	* process.c: when cross-compiling with MinGW, force GetProcessId
	lookup using GetProcAddress.

2010-04-02  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: parse_environment_string_extract_number() must be
	static.

2010-04-02  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-gray.c: Macros for gray_object_enqueue() and
	gray_object_dequeue(), to make sure they're inlined.

2010-04-02  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-gray.c: Fix a few debug levels, put a few
	asserts in inner loops into DEBUG and lower MAX_DEBUG_LEVEL.

2010-04-02  Jb Evain  <jbevain@novell.com>

	* exception.c: remove dead code.

2010-04-02  Zoltan Varga  <vargaz@gmail.com>

	* *-gc.c: Fix the signature of mono_gc_get_used/heap_size () to be consistent
	with mono-gc.h.

2010-04-01  Sanjoy Das <sanjoy@playingwithpointers.com>

	* sgen-gc.c: Make the nursery size adjustable by the
	MONO_GC_PARAMS environment variable.

	Code is contributed under MIT/X11 license.

2010-04-01 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* threadpool.c: threadpool threads wait is alertable.
	Fixes bug #592964.
	Reduced the stack size of the *poll_wait thread.

2010-04-01  Sebastien Pouliot  <sebastien@ximian.com>

	* exception.c|metadata-internals.h: Add new mono_get_exception_
	field_access_msg and mono_get_exception_method_access_msg 
	functions that accept a const char* parameter to provide more 
	details when the exception is thrown.
	* security-core-clr.c|h: Rework code to allow logging exceptions
	(export MONO_LOG_MASK="security") and to supply more details in
	[TypeLoad|MethodAccess|FieldAccess]Exception thrown. Also added
	mono_security_core_clr_is_field_access_allowed and 
	mono_security_core_clr_is_call_allowed to return an exception,
	with messages and logging, that can be emitted by method-to-ir.c

2010-04-01  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-pinning-stats.c: In the heap-dump, dump each
	pinned object.

2010-04-01  Zoltan Varga  <vargaz@gmail.com>

	* appdomain.c (mono_domain_assembly_postload_search): Avoid a crash/assert if
	the assembly name is not well formed utf8. Fixes #567882.

2010-04-01  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (mono_reflection_create_generic_class): Set the flags field of
	the generic parameters from the builder. Fixes #473298.

2010-03-31  Miguel de Icaza  <miguel@novell.com>

	* object.c (mono_class_proxy_vtable): Eliminate warning. 

	* marshal.c (emit_marshal_boolean): Eliminate possible
	uninitialized local warning. 

2010-03-30  Sebastien Pouliot  <sebastien@ximian.com>

	* class.c (mono_class_init): Postpone coreclr inheritance check
	until the end of the initialization (so we can check up the 
	default ctor manually for the core-clr inheritance rules).
	* security-core-clr.c: Add the missing (undocumented) checks on
	default constructors when verifying inheritance rules.

2010-03-30 Rodrigo Kumpera  <rkumpera@novell.com>

	* domain-internals.h (MonoJitExceptionInfo): Add new field
	handler_end to the data union. To be used to point the end
	of a finally block.

2010-03-30 Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c: Add support for new v4 type
	System.Reflection.MonoModule that is the concrete version
	of Module which is abstract unver v4.

2010-03-30 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_init): Don't set class failure after
	inited = 1 is set. It must be done before.

2010-03-30  Andreas Färber  <andreas.faerber@web.de>

	* mono-config.c: Add support for OS "haiku"
	* ChangeLog: Fix UTF-8 encoding

	Code is contributed under MIT/X11 license.

Tue Mar 30 15:53:06 CEST 2010 Paolo Molaro <lupus@ximian.com>

	* console-unix.c: fixed include logic for sys/ioctl.h.

2010-03-30  Mark Probst  <mark.probst@gmail.com>

	* threads.c: Fix bitmap generation for TLS marking on 64 bit
	systems.

2010-03-30  Zoltan Varga  <vargaz@gmail.com>

	* icall.c (ves_icall_System_Enum_get_underlying_type): Don't crash on
	unfinished/broken typebuilders.

2010-03-29  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Use the same heuristic for the LOS target that we use
	for the minor section allowance.

2010-03-29  Raja R Harinath  <harinath@hurrynot.org>

	* metadata-verify.c (INVALID_METHOD_IMPLFLAG_BITS): Allow bit 6
	"NoOptimization".

2010-03-29  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Count bytes allocated with heavy statistics.

2010-03-29  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: More detailed time statistics.

Mon Mar 29 11:52:34 CEST 2010 Paolo Molaro <lupus@ximian.com>

	* gc-internal.h, sgen-gc.c, threads.c, utils/mono-hash.c:
	fix the user defined mark interface to pass a pointer
	to the object location and not the object itself.

2010-03-27 Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (mono_method_body_get_object): Release
	the method header before the call to CACHE_OBJECT since
	this is a macro that returns.

2010-03-26 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (inflate_generic_type): mono_metadata_type_dup
	already dupes array information, the g_memdup was just
	leaking memory.

2010-03-26 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c: Add stack_peek function. Fix CEE_DUP
	to not read from invalid memory if push did expand
	the stack.

2010-03-26 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c: Remove old table verification code that has
	been superseeded by the new metadata verifier.

	* verify.h: Remove mono_image_verify_tables from the public
	API.

	* pedump.c: Fix for removed bits.

2010-03-26 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c: Allocate stack slows lazily to reduce stack usage
	in case of methods with huge stacks. Reduces memory consumption
	for mcs yyparse from 459Mb to 1.8Mb.

2010-03-26 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* threadpool.c: don't try executing items from domains being
	unloaded. Fixes appdomain-async-invoke test.

2010-03-26 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* threadpool.c: spin while the threadpool initializes.
	* mono-wsq.c: if the WSQ has not been initialized or has been shut
	down, don't do anything.

2010-03-26  Zoltan Varga  <vargaz@gmail.com>

	* threads.c (mono_thread_create_internal): Set the GC type of the
	threads_starting_up hash table.

2010-03-26 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* threadpool.c: reset 'state' to avoid returning non-null when the
	event type is not found.

Fri Mar 26 19:03:09 CET 2010 Paolo Molaro <lupus@ximian.com>

	* sgen-gc.c: make copy_object () take the address of the
	slot holding the reference. This allows saving memory stores
	when not needed and it allows keeping track of oldspace->nursery
	references for the card table code.

2010-03-26  Andreas Färber  <andreas.faerber@web.de>

	* null-gc.c (mono_gc_invoke_with_gc_lock): Fix function name.

	Code is contributed under MIT/X11 license.

Fri Mar 26 11:33:17 CET 2010 Paolo Molaro <lupus@ximian.com>

	* object.c, threads.c, threads-types.h, threads.h: make the
	managed thread local storage references precisely tracked.

2010-03-25 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* threadpool.[ch]: reworked the threadpool:
		-Threadpool threads use a work-stealing queue. Adding a work
		item from a threadpool thread will queue it in the thread
		local queue without locking (in most cases).
		-epoll events are coalesced before being added to the IO
		queue.
		-Dynamically change the number of active threads
		-Changed the global queue to be more GC friendly

	* class-internals.h: add 2 new performance counters for the number of
	threads in the threadpool and the IO threadpool.

	* object-internals.h: new field in MonoAsyncResult.
	* icall-def.h: new internal call for queueing work items.

	* Makefile.am: add 2 new files.

	* appdomain.c: bump up corlib version.

	* mono-wsq.[ch]: an implementation of a work-stealing queue.

	* mono-perfcounters-def.h:
	* mono-perfcounters.c: added 2 new performance counters.

2010-03-26  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: More FIXME/TODO updates.

2010-03-25  Mark Probst  <mark.probst@gmail.com>

	* gc-internal.h, sgen-gc.c, sgen-gc.h, boehm-gc.c, null-gc.c: New
	function mono_gc_invoke_with_gc_lock() which invokes a function
	with the guarantee that no collection will occur during its execution.

2010-03-25  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Update a few comments.

2010-03-24 Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c: Add support for new v4 type
	System.Reflection.MonoAssembly that is the concrete version
	of Assembly which is abstract unver v4.

2010-03-24  U-anarquia\miguel  <miguel@anarquia>

	* reflection.c (mono_reflection_get_custom_attrs_info): Protect
	code that uses System.Reflection.Emit in DISABLE_REFLECTION_EMIT.

	Expose a few macros that are needed for SR but not SRE to the
	world (previous inside the SRE ifdef)

2010-03-24  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c (gc_register_current_thread): We need
	stack_start_limit as well in the non-attribute pthread case.

2010-03-23 Rodrigo Kumpera  <rkumpera@novell.com>

	* threads.c: Fix windows build.

2010-03-22 Rodrigo Kumpera  <rkumpera@novell.com>

	* thread-types.h: Add mono_thread_resume_interruption.

	* threads.c: Add mono_thread_resume_interruption, this
	function should be called after the last protected handler
	found at interruption time has finished.

2010-03-22 Rodrigo Kumpera  <rkumpera@novell.com>

	* threads.c (ves_icall_System_Threading_Thread_ResetAbort):
	Check MonoInternalThread's ::state instead of ::abort_exc
	since the later can be lazily created.

	This is specially problematic when running a finally block
	under AbortRequested state. ResetAbort must work, but the
	abort_exc object has not been created because interruption
	has not began.

2010-03-22  Geoff Norton  <gnorton@novell.com>

	* locales.c: Its possible for CFStringGetCStringPtr
	to return null and not convert encodings.  Use
	CFStringGetCString instead.

Mon Mar 22 18:06:38 CET 2010 Paolo Molaro <lupus@ximian.com>

	* class-internals.h, class.c, object.c: introduce compressed
	interface bitmaps (for now only under small config): this saves
	about 600 KB of runtime memory on gmcs bootstraps or monodevelop
	startups.

Mon Mar 22 16:03:34 CET 2010 Paolo Molaro <lupus@ximian.com>

	* mono-debug.c: don't try to get the method header, it causes a
	deadlock and it is not used for anything anymore.

2010-03-22  Zoltan Varga  <vargaz@gmail.com>

	* loader.c (mono_method_get_marshal_info): Fix the handling of dynamic methods
	broken by the last change.

2010-03-21  Andreas Färber  <andreas.faerber@web.de>

	* socket-io.c: Don't depend on AF_SNA, AF_DECnet,
	SOCK_RDM.
	
	Code is contributed under MIT/X11 license.

2010-03-20  Sanjoy Das <sanjoy@playingwithpointers.com>

	* sgen-gc.c (mono_gc_get_write_barrier): Handle non-aligned
	nursery.

	Code is contributed under MIT/X11 license.

2010-03-19  Martin Baulig  <martin@ximian.com>

	* mono-debug.c (MonoDebugWrapperData): Replace `cil_code' with a
	dummy field, containing an empty string.
	(mono_debug_add_method): Don't call mono_disasm_code() for wrappers.


Fri Mar 19 17:26:43 CET 2010 Paolo Molaro <lupus@ximian.com>

	* class.c: setup_interface_offsets() refactor to not call
	mono_class_get_implemented_interfaces () more times than needed and
	to reduce the runtime memory requirements to be O(num_interfaces)
	instead of O(max_interface_id).

2010-03-18 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* mono-mlist.[ch]: add mono_mlist_set_next ().

2010-03-16 Rodrigo Kumpera  <rkumpera@novell.com>

	* domain-internals.h: Add MonoTryBlockHoleJitInfo struct and
	associated changes to support holes in the protected range of a
	try block.

	* domain.c: Add mono_jit_info_get_try_block_hole_table_info, which
	retrieves the holes table from a given MonoJitInfo.

Tue Mar 16 13:11:15 CET 2010 Paolo Molaro <lupus@ximian.com>

	* object.h, object-internals.h, object.c, icall.c, gc-internal.h,
	debug-helpers.c, cominterop.c, process.c, sgen-gc.c, socket-io.c:
	hide the contents of the MonoString and MonoArray structs from the
	public API. Change the accessor macros to accessors functions where
	needed. Adjusted the array API to allow for pointer-sized lengths and
	starting positions, so 64 bit arrays can be optionally provided in an
	API compatible way if needed on 64 bit systems.

Tue Mar 16 10:18:07 CET 2010 Paolo Molaro <lupus@ximian.com>

	* class-internals.h, class.c, loader.c, marshal.c, metadata.c,
	reflection.c: the MonoMethodNormal struct is now unused, so remove it.

Mon Mar 15 18:28:00 CET 2010 Paolo Molaro <lupus@ximian.com>

	* class-internals.h: remove the method header from MonoMethod since
	from now on it will be transient. We have a header pointer for method
	wrappers, since in that case we need to keep track of it. For this
	reason, all the Reflection.Emit generated methods use MonoMethodWrapper
	structs now. The same happens with MonoMethodInflated.
	* class.c: reset the sre_method flag for inflated method structures:
	this makes the code that cares look at the header in the MonoMethodInflated
	structure.
	* loader.c: lookup the method header in the appropriate field now that
	it is removed from MonoMethod.
	* metadata-internals.h: add a flag to the method header to know if it
	can be freed inside mono_metadata_free_mh ().
	* method-builder.c: updates after moving the header field from
	MonoMethod to MonoMethodWrapper.
	* reflection.c: MonoMethods generated from Reflection.Emit use
	MonoMethodWrapper structs if they need a method header now (later take
	advantage of this and remove all the current unsafe uses of method_aux_hash).
	* metadata.c: make method header parsing not leak when verification
	fails. Alloc it with g_malloc() and free it in mono_metadata_free_mh().
	These changes save a few hundred KB of runtime memory in a mcs
	bootstrap or a monodevelop startup.

2010-03-12 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c: Improve error message.

2010-03-12  Jb Evain  <jbevain@novell.com>

	* reflection.c (add_exported_type): populate the exported
	table with the type's nested type.

2010-03-10  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c (STRING_SIZE): Semi-revert r153342.  I'm an idiot who
	can't read parentheses.

2010-03-10  Mark Probst  <mark.probst@gmail.com>

	* threads.c (thread_cleanup): Add a guard to dereferencing
	"thread" to avoid an unlikely race condition.

2010-03-09  Sebastien Pouliot  <sebastien@ximian.com>

	* assembly.c: Fix crash in moon-unit when aname->culture is NULL
	instead of an empty string.

2010-03-09  Zoltan Varga  <vargaz@gmail.com>

	* object-internals.h (_G_BOOLEAN_EXPR): Fix the definition of this to explicitly
	convert to a boolean, recent gcc versions compile this differently.

2010-03-09  Zoltan Varga  <vargaz@gmail.com>

       * sgen-gc.c (safe_object_get_size): Avoid a function call so this can really be
       inlined.

2010-03-09  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c (STRING_SIZE): Off by one.

2010-03-09  Mark Probst  <mark.probst@gmail.com>

	* sgen-archdep.h: Fix the signal context register access for
	AMD64.

2010-03-09  Zoltan Varga  <vargaz@gmail.com>

	* sgen-gray.c: Get rid of the unused 'start' field in GrayQueueSection.

2010-03-08  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c: Store the initial basic block returned by mono_basic_block_split
	so we can release the whole list and not just the first one.

Mon Mar 8 17:30:44 CET 2010 Paolo Molaro <lupus@ximian.com>

	* verify.c, debug-helpers.c, profiler.c, loader.c,
	mono-basic-block.c, mono-debug.c, reflection.c: prepare to make
	MonoMethodHeader a transient entity.

2010-03-08  Zoltan Varga  <vargaz@gmail.com>

	* sgen-gc.c (scan_needed_big_objects): Call drain_gray_stack () to avoid
	uncontrolled growth of the gray stack.

	* sgen-gray.c: Rewrite this so it behaves like a stack, not a queue, so recently
	added items are removed first, improving cache locality. Avoid freeing queue
	segments in the fast path, use the list of segments as the free list, truncate
	it to its max size at the start of collection.

Mon Mar 8 10:13:52 CET 2010 Paolo Molaro <lupus@ximian.com>

	* metadata-internals.h: more memory savings, both with small config and without.


Sat Mar 6 19:12:12 CET 2010 Paolo Molaro <lupus@ximian.com>

	* appdomain.c, domain-internals.h, domain.c, object.c:
	make class_vtable_hash into an array to reduce memory usage.

Sat Mar 6 18:16:35 CET 2010 Paolo Molaro <lupus@ximian.com>

	* mempool.c, class-internals.h, class.c, icall.c, metadata.c,
	object-internals.h, object.c, reflection.c, threadpool.c:
	reduce resource usage when the small config is selected.
	In particular, up to 64K of methods/fields/properties/events
	are allowed and "other" methods in events are ignored.

Fri Mar 5 19:05:47 CET 2010 Paolo Molaro <lupus@ximian.com>

	* threads.c: reduce resource usage when compiled for a small config.

2010-03-05  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Also collect number of degraded-alloced objects with
	heavy statistics.

2010-03-04  Geoff Norton  <gnorton@novell.com>

	* assembly.c: Only support OSX bundling if the bundle is 
	actually detectable.

2010-03-04  Geoff Norton  <gnorton@novell.com>

	* loader.c: The marshal specs are freed at the end of the call
	but it explicitly frees the strings as well as the container,
	so we need to dup them too to avoid referencing free'd memory.

2010-03-04  Geoff Norton  <gnorton@novell.com>

	* icall-def.h:
	* icall.c: Add a new private internal icall to construct
	an object from its type without running the ctor.

Thu Mar 4 15:37:09 CET 2010 Paolo Molaro <lupus@ximian.com>

	* profiler.c: allow multiple profiler engines to be loaded
	at the same time.

Wed Mar 3 20:19:45 CET 2010 Paolo Molaro <lupus@ximian.com>

	* profiler-private.h, profiler.c, profiler.h, sgen-gc.c: introduce
	profiler event to track object moves.

Wed Mar 3 19:20:39 CET 2010 Paolo Molaro <lupus@ximian.com>

	* object.c, profiler.c, profiler.h, string-icalls.c:
	remove the reduntant MONO_PROFILE_STRING_ALLOC profiler event.

2010-03-03  Miguel de Icaza  <miguel@novell.com>

	* decimal.c (mono_double2decimal): Add support for reducing the
	scale of a decimal.  It turns the 0.6000000000000 into 0.6 as
	expected.

2010-03-03 Rodrigo Kumpera  <rkumpera@novell.com>

	* icall-def.h:
	* icall.c: Implement System.MonoType::get_core_clr_security_level icall.

2010-03-03  Marek Habersack  <mhabersack@novell.com>

	* mono-config.c (mono_config_parse_assembly_bindings): added -
	parses assembly binding redirections from appdomain's config
	file.

	* metadata-internals.h: added definition of a new function -
	mono_config_parse_assembly_bindings - to support parsing assembly
	binding redirections defined in appdomain's config file.

	* domain-internals.h: added two new fields to _MonoDomain - a list
	of assembly bindings and a flag to parse the config file only
	once.

	* assembly.c (assembly_binding_maps_name): empty culture name and
	NULL culture name are considered equal.
	(mono_assembly_apply_binding): added support for domain specific
	assembly binding redirections, read from the appdomain's
	configuration file. Fixes bug #580185

Wed Mar 3 11:46:06 CET 2010 Paolo Molaro <lupus@ximian.com>

	* appdomain.c, domain.c, icall.c, image.c, marshal.c, object.c,
	reflection.c, socket-io.c, threadpool.c, threads.c: removed 1.1/1.0
	support.

2010-03-02 Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (mono_image_get_memberref_token): Extract mono_image_add_memberef_row
	from this function. The new function receive the parent token instead of a type.

	* reflection.c (mono_image_get_methodref_token_for_methodbuilder):
	* reflection.c (mono_image_get_ctorbuilder_token): Use new function to encode
	typebuilders. This make it possible to properly encode generic type builders since
	their unmanaged type don't have generics data while unfinished.

	Fixes #583655.

2010-03-02  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-protocol.c, sgen-protocol.h: New facility for
	writing binary log files (can be enabled by #define'ing
	BINARY_PROTOCOL) for better debugging of timing-dependent bugs or
	bugs in longer running programs.

Mon Mar 1 19:35:32 CET 2010 Paolo Molaro <lupus@ximian.com>

	* metadata.c: added some API documentation.

2010-03-01  Robert Jordan  <robertj@gmx.net>

	* filewatcher.h: Include glib.h to fix the MSVC build.

2010-03-01  Zoltan Varga  <vargaz@gmail.com>

	* class-internals.h (MonoClass): Get rid of the reflection_info field, add
	a GC handle instead. This is a bit slower to access, but avoids burdening the
	GC with 100s of individual roots.

	* reflection.c (mono_class_get_ref_info):
	(mono_class_set_ref_info):
	(mono_class_free_ref_info): New internal helper fuctions.

	* reflection.c appdomain.c icall.c class.c: Use the new helper functions instead
	of accessing klass->reflection_info directly.

	* sgen-gc.c (alloc_complex_descriptor): Fix the computation of the number of
	words.

	* gc.c (alloc_handle): Create a GC descriptor for the 'entries' array, free
	the previous array.

2010-02-28  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (get_runtime_invoke_type): Avoid sharing byref with I, as the latter
	needs an indirection.

2010-02-26  Zoltan Varga  <vargaz@gmail.com>

	* generic-sharing.c: Removed, moved its contents to mini/mini-generic-sharing.c,
	so all generic sharing code is in one place.

	* class.c (get_implicit_generic_array_interfaces): Fix the last change so
	we don't call setup_interface_offsets () for unfinished types.

2010-02-26  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_generic_sharing_enabled): Move this to
	generic-sharing.c.

	* image.c: Add an unload hook which is called before an image is unloaded.

	* generic-sharing.c: Use the unload hook to unregister per-image data, to avoid
	metadata.c having to depend on generic sharing.

Fri Feb 26 19:23:18 CET 2010 Paolo Molaro <lupus@ximian.com>

	* class.c: reduce size of ridiculously large cache.

2010-02-26  Martin Baulig  <martin@ximian.com>

	* mono-debug.h
	(MONO_DEBUGGER_MINOR_VERSION): Bump to 5.

	* threads.c (mono_thread_internal_reset_abort): New method; resets
	the abort, but doesn't throw any exception if no abort was requested.

2010-02-26  Zoltan Varga  <vargaz@gmail.com>

	* class.c (get_implicit_generic_array_interfaces): Call
	mono_class_setup_interface_offsets () before accessing
	eclass->interface_offsets_count. This only shows up on platforms without IMT for
	some reason.

Thu Feb 25 12:12:44 CET 2010 Paolo Molaro <lupus@ximian.com>

	* environment.c, environment.h, icall.c: make the GetOSVersionString()
	icall internal.

Thu Feb 25 11:37:50 CET 2010 Paolo Molaro <lupus@ximian.com>

	* metadata.c, metadata.h: make MONO_TYPE_IS* functional without
	direct access to the MonoType fields.

2010-02-25  Zoltan Varga  <vargaz@gmail.com>

	* threads.h: Move some internal functions which were added to this header by
	mistake to threads-types.h.

	* class.c (mono_class_init): Get rid of mono_setup_vtable_in_class_init.

Wed Feb 24 17:45:27 CET 2010 Paolo Molaro <lupus@ximian.com>

	* class-internals.h, class.h, object.h: make MonoRemoteClass
	and mono_remote_class() internal.

Wed Feb 24 17:05:18 CET 2010 Paolo Molaro <lupus@ximian.com>

	* metadata-internals.h, class-internals.h, metadata.h: make the
	MonoType guts internal as well.

Wed Feb 24 16:02:42 CET 2010 Paolo Molaro <lupus@ximian.com>

	* reflection.h: the MonoTypeNameParse guts are internal now.
	* assembly.c, assembly.h, image.h: the MonoAssemblyName guts
	are internal now, provide accessors as needed.
	* metadata.h, metadata-internals.h: the MonoMethodSignature
	guts are internal now.
	* Makefile.am: mempool.h is an internal header now.
	* *.h, *.c: remove glib.h usage from the public headers.

2010-02-24  Atsushi Enomoto  <atsushi@ximian.com>

	* culture-info-table.h : regenerated.

2010-02-22  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata.c: Add mono_method_get_header_summary which returns minimal
	information about the header of a method. This is the information used
	by the inline oracle to reject methods.

	This method doesn't decode local variables and doesn't cache it's result,
	so it should cause a minimal reduction in memory usage.

	* metadata-internals.h: Add MonoMethodHeaderSummary structure and
	mono_method_get_header_summary.

2010-02-22  Jeffrey Stedfast  <fejj@novell.com>

	* threads.c (mono_thread_exit): Make sure that the main thread is
	non-null before dereferencing it.

2010-02-21  Geoff Norton  <gnorton@novell.com>

	* Makefile.am: Add CoreFoundation linkage on darwin to properly get the current
	locale.
	* locaes.c: When running on darwin, try to get the local from CoreFoundation 
	before falling back to the posix lookup.

2010-02-19  Zoltan Varga  <vargaz@gmail.com>

	* threads.c (mono_thread_suspend_all_other_threads): Ignore threads which have
	the DONT_MANAGE flag set.

2010-02-19  Rodrigo Kumpera  <rkumpera@novell.com>

	* domain.c: Remove old v1 version strings. Let the runtime
	default to 2.0 instead of failing because it can't find a
	working 1.0 instalation.

2010-02-19  Rodrigo Kumpera  <rkumpera@novell.com>

	* domain.c: Add v4 RC version string.

2010-02-19  Rodrigo Kumpera  <rkumpera@novell.com>

	* mono-basic-block.c (mono_opcode_value_and_size): Use pointer variant
	of overflow checking function.

2010-02-18  Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (mono_reflection_method_on_tb_inst_get_handle): Handle non
	generic methods.

	* reflection.c (mono_reflection_get_custom_attrs_info): Handle compiler context
	cases for ParameterInfo.

	Fixes #579493.

2010-02-18  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_get_cctor): Fix support for dynamic classes, which doesn't
	have has_cctor set. Fixes #575946.

2010-02-16 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* appdomain.c: display a warning if the parsing the config file
	produces any error.
	Skip the BOM in UTF-8 files.
	Copy the AppDomainSetup before setting the privateBinPath so that the
	correct configuration file is read.

2010-02-15  Zoltan Varga  <vargaz@gmail.com>

	* object.c: Instead of using one vtable trampoline, allow the JIT to use one
	vtable trampoline per vtable slot index. Not used yet.

2010-02-13 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* icall-def.h:
	* icall.c: add internal call that returns the system page size.

2010-02-13  Zoltan Varga  <vargaz@gmail.com>

	* debug-helpers.c (mono_method_desc_search_in_image): Handle short names like
	'int' for system classes.

Fri Feb 12 18:36:02 CET 2010 Paolo Molaro <lupus@ximian.com>

	* icall.c, icall-def.h: new icall to check for sufficient
	stack space.

2010-02-12  Mark Probst  <mark.probst@gmail.com>

	* reflection.c (ensure_complete_type): Check that reflection_info
	is set, too.  Fixes crash of corlib testsuite with -O=-all.

2010-02-11  Rodrigo Kumpera  <rkumpera@novell.com>

	* attrdefs.h:
	* tabledefs.h: Add NoOptimization flag.

2010-02-10  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Don't consider it a missing remset if the target
	object is pinned - we might have done the store but not added the
	remset yet.

2010-02-10  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: When checking for missing remsets, don't assert on
	the first one, but print them all and then assert.

2010-02-10  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c (find_in_remset_loc): Handle the small bitmap case.

2010-02-09  Miguel de Icaza  <miguel@novell.com>

	* console-unix.c: On OSX Control-Y is assigned to
	VDSUSP (non-Posix), the
	suspend-program-next-time-it-tries-to-read-input command (this is
	different than C-z, which suspends immediately).

	Do the same thing that bash does and ignore this setting,
	making our repl/getline support pasting.

2010-02-10  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Simple plausibility check for scan_starts.

2010-02-10  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Round up when calculating the number of scan starts.

2010-02-10  Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c: Export mono_get_object_from_blob.

	* object-internals.h: Ditto.

	* icall.c: New icall property_info_get_default_value to get the default
	value of a property. Since using this is not common, no caching is done.

	* icall-def.h: Add new icall.

2010-02-10  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c: Add mono_class_get_property_default_value.

	* class-internal.h: Export mono_class_get_property_default_value.

2010-02-10  Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (mono_image_get_property_info): Encode the default value of a property.

Wed Feb 10 14:48:45 CET 2010 Paolo Molaro <lupus@ximian.com>

	* sgen-gc.c: introduced critical regions to allow some lockless
	operations and increase scalability.

2010-02-10  Geoff Norton  <gnorton@novell.com>

	* reflection.c: Support building with DISABLE_REFLECTION

2010-02-09 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* threadpool.c: Fixes for SetMinThreads and SetMaxThreads.
	Closes bug #566057.

	* exception.c: fix typo in comment.

2010-02-09  Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (param_info_get_type_modifiers): Handle the case when the member object is a
	property. This happens which instances returned by PropertyInfo::GetIndexParameters ().

	* reflection.c (mono_reflection_get_custom_attrs_info): Ditto.

	* object-internals.h: Export mono_class_is_reflection_method_or_constructor as part of
	the internal API.

	Fixes #574434.

2010-02-09  Mark Probst  <mark.probst@gmail.com>

	* threads.c: Removed two assertions that were too strict.  Added a
	clarifying comment.  Fixes #577090.

2010-02-08  Zoltan Varga  <vargaz@gmail.com>

	* domain.c (mono_jit_info_table_find): Avoid looking in the root domain, since
	the caller has no way of knowing the domain which owns the returned MonoJitInfo.

	* appdomain.c (create_exceptions): Call mono_thread_push/popappdomain_ref ().

	* verify.c (mono_type_get_stack_name): Fix a warning.

2010-02-07  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_get_wrapper_info): Rename from
	mono_marshal_wrapper_info_from_wrapper.

	* marshal.c (mono_marshal_set_wrapper_info): Rename from
	mono_marshal_method_set_wrapper_data, and export.

	* boehm-gc.c sgen-gc.c null-gc.c: Get rid of mono_gc_get_allocator_type, store
	the allocator type in a AllocatorWrapperInfo structure instead, which is accesible
	by calling mono_marshal_get_wrapper_info ().

	* sgen-gc.c (mono_gc_get_managed_allocator): Add a specialized allocator for
	small objects which does no size checks.

2010-02-05  Rodrigo Kumpera  <rkumpera@novell.com>

	* icall-def.h: Rename get_MetadataToken to GetMetadataToken.

2010-02-04  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (mono_method_verify): Use the new basic block formation pass
	to avoid verifying dead basic blocks. This is the same behavior as the
	runtime MS verifier.

2010-02-04  Rodrigo Kumpera  <rkumpera@novell.com>

	* mono-basic-block.c:
	* mono-basic-block.h: New implementation of a basic block formation pass.
	The formation pass does static liveness analysis as well to detect dead
	basic blocks.

2010-02-04  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_get_native_wrapper): Emit a null check for the
	'this' argument in icalls.

2010-02-02  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (resolve_object): Handle MonoArrayMethod. Fixes #575955.

2010-02-01  Mark Probst  <mark.probst@gmail.com>

	* object.c, domain.c: When using SGen, we must register
	vtable->type as a root if it's not a MonoType, because then it
	wasn't pin-alloced.

2010-02-01  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Reset to_space_bumper to to_space_section->next_data
	at the start of nursery collections, because we might have had
	degraded allocations which changed next_data.

2010-01-30  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_get_managed_wrapper): Avoid constructing the
	custom attr so this function works in cross-compiling mode.

2010-01-29  Zoltan Varga  <vargaz@gmail.com>

	* class.c (make_generic_param_class): Initialize interface offsets since we
	set klass->inited. Fixes #574819.

2010-01-28  Zoltan Varga  <vargaz@gmail.com>

	* domain.c (mono_domain_free): Send the END_UNLOAD profiler event before
	calling the JIT domain cleanup hook.

2010-01-28  Rodrigo Kumpera  <rkumpera@novell.com>

	* pedump.c (main): Properly set the verifier mode when running the metadata
	verifier.

2010-01-28  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (verify_class_for_overlapping_reference_fields): Properly verify
	overlapping fields now that we're called before has_references is set.

	* pedump.c (dump_verify_info): Clear any loader error before verifying another
	method. Otherwise all sort of weird stuff happens.

2010-01-27  Zoltan Varga  <vargaz@gmail.com>

	* object.c (mono_field_get_value_object): Handle nullable types correctly.
	Fixes #572874.

2010-01-25  Zoltan Varga  <vargaz@gmail.com>

	* icall.c (ves_icall_System_Array_SetValueImpl): Handle nullable types correctly.
	Fixes #573322.

2010-01-23  Mark Probst  <mark.probst@gmail.com>

	* sgen-pinning.c (evacuate_pin_staging_area): Don't assume
	pin_staging_area_index is greater than 0.

2010-01-22 Miguel de Icaza (miguel@novell.com)

	* loader.c: Since we do nothing with the error returned, pass NULL
	to ignore the error.

2010-01-21  Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (typebuilder_setup_fields): Pretend field setup already
	happened before starting to encode the actual fields. This avoid ciclic
	dependencies and eventual crashes.

	Fixes #572660.

2010-01-21  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, gc-internal.h, object.c: Make string allocation
	atomic and remove the half-constructed hack in SGen.

2010-01-21  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (parse_generic_inst): Fail a type signature if it 
	has a recursive reference to itself.

	Fixes #571863.

2010-01-21  Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (mono_method_signature): Fix error message.

2010-01-21  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Reuse to-space sections between nursery collections.

2010-01-20 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* icall.c: don't raise AppDomain.TypeResolve when the type is loaded
	from the current assembly or mscorlib. Fixes bug #322957.

2010-01-20  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c: Calculate the target class of the delegete invoke wrappers using
	get_wrapper_target_class.

2010-01-19  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Fix warnings.

2010-01-19  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (store_local): Better error message.

2010-01-19  Rodrigo Kumpera  <rkumpera@novell.com>

	* object.c (mono_object_get_virtual_method): Handle generic interfaces with variant
	arguments.

2010-01-19  Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_Remoting_RemotingServices_GetVirtualMethod): This
	function is generics variance aware.

2010-01-19  Sebastien Pouliot  <sebastien@ximian.com>

	* security-core-clr.c (mono_security_core_clr_can_access_internals):
	Handle the case where 'basedir' can be NULL (e.g. SRE assemblies)

2010-01-19  Sylvain Dupont <duposyl@gmail.com>

	* cominterop.c marshal.c: Added support for marshalling in, in/byref,
	  in/out, in/out/byref parameters of type SAFEARRAY[VARIANT].

	Code is contributed under MIT/X11 license.

2010-01-19  Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_MonoMethod_GetGenericMethodDefinition): Handle inflated generic methods
	on a GTD.

2010-01-19  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_wrapper_info_from_wrapper): New helper function to
	return a point to a wrapper specific info structure describing the wrapper.
	(mono_marshal_get_array_address): Store the rank+elem_size in the wrapper info.
 
2010-01-18  Mark Probst  <mark.probst@gmail.com>
 
	* sgen-gc.c: Make minor collection section allowance adaptive,
	depending on the amount of memory reclaimed in the last major
	collection.  If more memory was reclaimed (i.e. more garbage
	produced), do the next collection earlier.

2010-01-18  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (parse_type): Fail a type signature if it has a recursive reference
	to itself.

	* metadata-verify.c (mono_verifier_verify_typespec_signature): Change signature to take
	the token as parameter.

	* verify-internals.h: Ditto.

	* metadata.c (mono_type_create_from_typespec): Pass token to verifier.

	Fixes #571460.

2010-01-18  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Make store_remset_buffer_index long.

2010-01-18  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_from_typeref): Fail loading of self-referencing typeref tokens.

	Fixes #569579.

2010-01-18  Zoltan Varga  <vargaz@gmail.com>

	* sgen-gc.c (mono_gc_base_init): Add 'conservative_stack_mark' option to turn
	off precise marking if it is available.
	(mono_gc_get_bitmap_for_descr): Fix the handling of run length descriptors.

2010-01-17  Zoltan Varga  <vargaz@gmail.com>

	* sgen-gc.c (mono_gc_conservatively_scan_area): Resurrect this.

	* sgen-pinning.c (evacuate_pin_staging_area): Don't assert if there are no
	pinned objects.

	* sgen-gc.c (create_allocator): Add the missing n > MONO_ARRAY_MAX_INDEX check
	to the array allocator.

2010-01-16  Zoltan Varga  <vargaz@gmail.com>

        * generic-sharing.c (instantiate_other_info): Don't create ftnptr's from the
        result of mono_compile_method (), it already includes an ftnptr.

2010-01-16  Zoltan Varga  <vargaz@gmail.com>

	* metadata.c (get_image_set): Remove an assert which can happen in normal use.

2010-01-15  Zoltan Varga  <vargaz@gmail.com>

	* metadata.c (mono_metadata_str_hash): New helper function to compute a stable
	hash value which doesn't depend on glib/eglib versions.
	(mono_metadata_type_hash): Use it.

	* object.c (mono_method_get_imt_slot): Ditto.

2010-01-14  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_type_has_exceptions): Check the generic instance. It can fail
	independently of the GTD.

	* class.c (mono_class_setup_fields): Fail if field has negative offset.

	* class.c (mono_class_setup_fields): Fail if valuetype has zero size. Add sizeof(MonoObject)
	to the upper limit since instance_size includes this amount.

	* class.c (mono_class_layout_fields): Check if the types of the static fields have failed.

	Fixes #569544.

2010-01-14  Zoltan Varga  <vargaz@gmail.com>

	* object.c (build_imt_slots): Compute the vtable slot correctly for interfaces
	with static methods.

	* object.c (build_imt_slots): Avoid asserting when static methods are
	encountered in an interface.

2010-01-13  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c (to_space_expand): Fix assertion.

Wed Jan 13 15:42:28 CET 2010 Paolo Molaro <lupus@ximian.com>

	* string-icalls.c: missing declaration fixes.
	* sgen-gc.c: portability fixes.

2010-01-12  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_get_implemented_interfaces): Now take a MonoError argument.

	* class.c:
	* cominterop.c:
	* icall.c:
	* object.c: 
	* class-internals.h: Adjust for new signature of mono_class_get_implemented_interfaces.

2010-01-12  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_setup_interfaces): Now take a MonoError argument and
	it can fail loading the type.

	* class.c: Add mono_class_inflate_generic_class_checked.

	* class.c:
	* verify.c:
	* class-internals.h: Adjust for new signature of mono_class_setup_interfaces.

2010-01-11  Zoltan Varga  <vargaz@gmail.com>

	* loader.c (mono_method_signature_checked): New internal function taking an
	MonoError argument.

	* socket-io.c (AI_ADDRCONFIG): Applied patch from John Lightsey (jd@cpanel.net).
	Fixes build on rh 7.3.

2010-01-10  Aaron Bockover  <abockover@novell.com>

	* assembly.c (mono_set_rootdir): Support finding the mono paths on OS X
	at runtime in the same way as on Windows, which yields a relocatable
	Mono. Uses dyld's _NSGetExecutablePath and realpath to resolve the path
	of the running mono process.

	On TARGET_ARM, fallback () will always be executed.

2010-01-08  Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_Type_GetInterfaceMapData): This function is generics variance aware.

2010-01-08  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_is_assignable_from_slow): Support variant
	generic delegates.

	* class.c (mono_class_implement_interface_slow): Support types with
	variant generic arguments.

2010-01-08  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c: Remove some code duplication.

2010-01-07  Rodrigo Kumpera  <rkumpera@novell.com>

	* object.c: Update docs.

2010-01-07  Rodrigo Kumpera  <rkumpera@novell.com>

	* object.c (add_imt_builder_entry): Improve DEBUG_IMT spew.

	* object.c (build_imt_slots): Interfaces with variant generic arguments use the
	fallback trampoline as well.

	* class.c (mono_class_interface_offset_with_variance): Add new non_exact_match
	out argument that is set to TRUE if the match was direct. 

	* class.c (mono_class_is_assignable_from): Delegates require variance testing as well.

	* class-internal.h: Update prototype of mono_class_interface_offset_with_variance.

2010-01-07  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c: Add mono_class_interface_offset_with_variance function that does same
	as mono_class_interface_offset but takes variance into account.

	* class-internal.h: Export mono_class_interface_offset_with_variance.

	* object.c: Fix and improve DEBUG_IMT. Added an assert for IMT thunk building.

2010-01-07  Rodrigo Kumpera  <rkumpera@novell.com>

	* object.c:
	* icall.c:
	* class.c: Add some FIXME for due to variant generic arguments.

	object.c (mono_object_isinst_mbyref): Interfaces with variant generic arguments
	can't use the simple bitfield check, so call mono_class_is_assignable_from if
	the bitfield check fails.

2010-01-07  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_is_assignable_from): Rework the generics variance code
	to be easier to read and fix bugs in the case a non generic type implements a variant
	interface.

	* class.c (mono_class_has_variant_generic_params): Make non static.

	* class-internals.h: Export mono_class_has_variant_generic_params as part of
	the private API.

2010-01-07 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* assembly.c: fix MONO_PATH debug output.

2010-01-06  Atsushi Enomoto  <atsushi@ximian.com>

	* culture-info-table.h : regenerated.

2010-01-04  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (mono_verifier_verify_class): Properly check for broken parent. Ignore
	types that are meant to not have a parent.

2010-01-04  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_get_runtime_invoke): Make a copy of the signature
	from the image mempool, so it is not leaked.

2010-01-04  Zoltan Varga  <vargaz@gmail.com>

	* metadata-internals.h (_MonoImage): Remove unused generic_class_cache field.

2010-01-04  Sebastien Pouliot  <sebastien@ximian.com>

	* verify.c (verify_valuetype_layout_with_target): Fix case
	that can lead to infinite recursion. Fix bug #567861

2010-01-04  Rodrigo Kumpera  <rkumpera@novell.com>

	* pedump.c: Run code verifier even if image verification fails
	due to a failed type we. This allows more errors to be shown.

2010-01-04  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (count_virtual_methods): Remove the assert and now
	fail properly.
	
	* class.c (setup_interface_offsets): This can fail now.

	* class.c (mono_class_setup_vtable_general): Check for parent vtable
	errors. Check setup_interface_offsets errors.

	* class.c (setup_interface_offsets): Simplify the return error logic
	and remove class_init_ok.

	Fixes #560327.

2010-01-04  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_init): Do class verification at the beginning. Add
	some asserts to avoid tripping into invalid memory.

	* object.c (compute_class_bitmap): Replace a g_assert_not_reached with a
	g_error and a decent message.

	* verify.c (mono_verifier_verify_class): Verify for invalid super type.

	Fixes #567548.

2010-01-03  Zoltan Varga  <vargaz@gmail.com>

	* mempool-internals.h (g_list_prepend_mempool): Define this and related functions
	as inline functions instead of defining them in mempool.c.

	* metadata-internals.h (MonoImageSet): New structure representing a set of
	MonoImages, which own a collection of generic instances.

	* metadata.c: Get rid of the global generic caches, instead assign each generic
	instance to the image set which consists of all the images referenced by the
	instance. This greatly speeds up mono_metadata_clean_for_image (), and allows
	the memory used by generic instances to be allocated from a per image-set mempool
	later.

2010-01-03  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_get_runtime_invoke): Fix a memory leak.

2010-01-03  Zoltan Varga  <vargaz@gmail.com>

	* appdomain.c (zero_static_data): Fix a warning.

	* locales.c (construct_culture_from_specific_name): Applied patch from
	José Antonio Sánchez Lázaro <jasl@darcysoft.es>. Fix a crash if a culture was
	not found. Fixes #567900.

2009-12-31  Sebastien Pouliot  <sebastien@ximian.com>

	* loader.c (mono_method_get_signature_full): Remove two asserts.
	Return NULL instead so that the verifier can handle both cases 
	gracefully.

2009-12-30  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_setup_methods): Use checked version of mono_class_inflate_generic_method_full
	so we can properly fail types instead of crashing.

	Fixes #567676.

2009-12-30  Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (reflection_methodbuilder_to_mono_method): Assert in case of a broken
	generic method.

2009-12-30  Rodrigo Kumpera  <rkumpera@novell.com>

	* marshal.c (mono_mb_emit_restore_result): Properly handle generic enums.

2009-12-26  Zoltan Varga  <vargaz@gmail.com>

	* monitor.c (ves_icall_System_Threading_Monitor_Monitor_wait): Don't close the
	wait handle if the wait is interrupted, since it is still in mon->wait_list, and
	we can't remove it from it since we don't hold the lock.
	(mon_new): Free the orphaned events here when a mon structure is added to the
	freelist. Fixes #561239. Thanks to Mike Rieker <wmrieker@nii.net> for tracking
	this down.

2009-12-26  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (init_stack_with_value_at_exception_boundary): Do stack overflow checking here
	as max stack might be zero.

	Fixes #562320.

2009-12-26  Rodrigo Kumpera  <rkumpera@novell.com>

	Rework all uses of mono_class_setup_methods to accept that it can fail now.

	* class.c (mono_class_setup_methods): This function now can fail the class. Do so for generic
	instances if the GTD did.

	* class.c (mono_class_setup_properties): Ditto.

	* class.c (mono_class_setup_events): Ditto.

	* class.c (mono_class_setup_vtable): Fail early if the type is already broken.

	* class.c (mono_class_setup_vtable_general): Add a few more missing broken type checks.	Sanitize
	error setting.

	* class.c (mono_class_init): Fail if GTD did.

	* cominterop.c:
	* generic-sharing.c:
	* icall.c:
	* loader.c:
	* object.c:
	* verify.c: Properly handle failure of mono_class_setup_methods.

2009-12-26  Rodrigo Kumpera  <rkumpera@novell.com>

	* class-internals.c: Add mono_class_inflate_generic_method_full_checked and make
	mono_class_inflate_generic_method_full internal.

	* class.c (inflate_generic_context): Now takes a MonoError argument.

	* class.c (mono_class_inflate_generic_method_full): Now calls the _checked and abort on
	errors.

2009-12-26  Zoltan Varga  <vargaz@gmail.com>

	* generic-sharing.c (instantiate_other_info): Avoid creating jump trampolines since
	they cannot be patched. Partly fixes #564408.

2009-12-24  Mark Probst  <mark.probst@gmail.com>

	* metadata-internals.h, reflection.c: Use the
	MonoDynamicImage.handleref hash table only with unmanaged keys,
	and add a managed hash table handleref_managed for managed keys.

2009-12-24  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Unset to-space bumper between collections.  It might
	become invalid due to degraded allocations.

2009-12-21  Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (mono_method_get_signature_full): Check if the returned signature is compatible
	with the one from the original method.

	* metadata-verify.c (mono_verifier_is_sig_compatible): New function to verify signature
	compatibility.

	* verify-internals.h: Add new function to the internal API.

2009-12-18  Dimitar Dobrev  <dpldobrev@yahoo.com>

	* culture-info-tables.h: regenerated it to include the Georgian culture.

2009-12-18  Zoltan Varga  <vargaz@gmail.com>

	* sgen-gc.c: Include mono/utils/memcheck.h.

	* reflection.c (mono_reflection_get_type_internal_dynamic): Use assembly->domain
	instead of the current domain, since the two might not match if this is called
	from the debugger.

	* metadata-internals.h (MonoDynamicAssembly): Add a 'domain' field to specify the
	domain which created this assembly.

2009-12-18  Zoltan Varga  <vargaz@gmail.com>

	* debug-helpers.c (dis_one): Avoid a glib assert on empty strings.

2009-12-17  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Managed implementation of the specialized generic
	store write barrier.

2009-12-17  Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_Type_GetMethodsByName): Don't pin virtual methods if they are newslot.
	A private virtual newslot method is used to implement an interface method without exposing
	it to users. When querying for public instance methods, such method would hide a public one
	on a parent type.

	Fixes #564379.

2009-12-17  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (resolve_object): Fix the encoding of unmanaged calling
	conventions.

2009-12-16  Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (mono_type_get_object): Guard against NULL generic param owner.

2009-12-16  Rodrigo Kumpera  <rkumpera@novell.com>

	* class-internals.h (MonoDynamicGenericClass): Kill property and event related fields
	as they are no longer used.
	
	 * metadata.c (free_generic_class_dependents): Remove reference to previous fields

	* reflection.c (mono_reflection_generic_class_initialize): Ditto.

2009-12-16  Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (mono_type_get_object): If the type is VAR or MVAR check
	if the owner class has not been finished before returning reflection_info.	

	Fixes #565127.

2009-12-16  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (mono_custom_attrs_from_param): Avoid a crash if a dynamic
	param doesn't have custom attributes. Fixes #565117.

	* class.c (mono_bounded_array_class_get): Make these classes PUBLIC. Fixes
	#565120.

2009-12-15  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_setup_fields): Fail valuetypes that are bigger than 1Mb.

2009-12-15  Rodrigo Kumpera  <rkumpera@novell.com>

	* pedump.c: Add partial-md mode that doesn't perform full metadata verification. It does the
	same amount done by a core-clr enabled runtime.

2009-12-15  Marek Habersack  <mhabersack@novell.com>

	* appdomain.c (mono_make_shadow_copy): make sure access mode of
	the target files is reset to writable by owner and readable by
	everyone else to prevent problems when updating shadow copies of
	files whose source is read-only. Fixes bug #556884

2009-12-15  Mark Probst  <mark.probst@gmail.com>

	* class.c (mono_generic_class_get_class): Allocate the generic
	class via malloc again, so that it can be freed when any one of
	the images of its constituent types is closed.

	* metadata.c: When closing an image, don't free generic insts and
	generic classes right away, but put them into a list for later
	freeing.

	* image.c, metadata-internals.h: Store the free list and in the
	second pass of closing an image, free it.

2009-12-14  Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (mono_generic_class_get_object): Assert if this is ever called.

	* reflection.c (mono_reflection_register_with_runtime): Only register dynamic
	types in type_hash.

	* reflection.c (resolve_object): Call ensure_complete_type on the inflated field.

2009-12-14  Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (mono_reflection_type_get_handle): Properly fail in case of a broken
	user type.

	* reflection.c (mono_reflection_register_with_runtime): Throws in case a bad user type
	is used.

2009-12-14  Miguel de Icaza  <miguel@novell.com>

	* verify.c (mono_method_verify): The Unused opcodes produce an
	InvalidProgramException on .NET

2009-12-14  Sebastien Pouliot  <sebastien@ximian.com>

	* loader.c (mono_method_get_header): Move assert after the verifier
	has been called on the method header.

2009-12-12  Rodrigo Kumpera  <rkumpera@novell.com>

	* object-internals.h: Remove useless field from MonoReflectionGenericClass.

	* appdomain.c: Bump corlib version.

2009-12-12  Rodrigo Kumpera  <rkumpera@novell.com>

	To properly support user types, MonoGenericClass has to be used for regular, non SRE,
	types as well since otherwise generic instances would not return UT as arguments but
	their undelying system type.

	* object-internals.h: Change field types of MonoGenericClass and *OnTypeBuilderInst
	to reflect the fact that they can have now multiple different types.

	* reflection.c (mono_image_get_field_on_inst_token): Handle MonoField.

	* reflection.c (mono_image_get_ctor_on_inst_token): Handle MonoCMethod.

	* reflection.c (mono_image_get_method_on_inst_token): Handle MonoMethod.

	* reflection.c (mono_reflection_register_with_runtime): Init super types
	if the image is not dynamic.

	* reflection.c (mono_reflection_bind_generic_parameters): In case of a MonoGenericClass,
	check if the generic type definition is a TypeBuilder.

	* reflection.c (mono_reflection_generic_class_initialize): If the generic type definition
	doesn't belong to a dynamic image, skip initialization.

	* reflection.c (resolve_object): Properly handle *OnTypeBuilderInst types where their
	base definition is not a dynamic type.

2009-12-11  Marek Habersack  <mhabersack@novell.com>

	* object.c (mono_ldstr, mono_ldstr_metadata_sig): added calls to
	mono_profiler_string_allocation

	* string-icalls.c (ves_icall_System_String_InternalAllocateStr):
	if string profiling is enabled, call
	mono_profiler_string_allocation

	* profiler.h: added two MonoProfileFlags -
	MONO_PROFILE_IOMAP_EVENTS and MONO_PROFILE_STRING_ALLOC as well as
	installation functions for the hooks below.

	* profiler-private.h, profiler.c: added two hooks:
	mono_profiler_string_allocation called whenever a string is
	allocated by InternalAllocateStr and mono_profiler_iomap called
	whenever IOMAP code performs an adjustement on a file path.

Fri Dec 11 18:24:04 CET 2009 Paolo Molaro <lupus@ximian.com>

	* boehm-gc.c: fixed race condition while getting the target of a
	disappearing link (bug #522233).

2009-12-10  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_type_get_full): Produce warning instead of simply swallowing
	the error.

2009-12-10  Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c: Add mono_reflection_register_with_runtime icall to
	allow a MonoGenericClass to register itself as the managed mirror of
	a given generic instance.
	This is a temporary workaround until all MGC instantiation happens in
	managed code.

	* object-internals.h: Ditto.

	* icall-def.h: Ditto.

2009-12-10  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c (find_in_remsets): Also search the generic store
	remsets.

2009-12-10  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Don't access class names in debugging code when
	unloading a domain, because they might not be valid anymore.

2009-12-10  Mark Probst  <mark.probst@gmail.com>

	* domain.c, domain-internals.h: New function mono_domain_unset().

	* appdomain.c (unload_thread_main): Detach the thread again at the
	end.

	* threads.c: When a thread exists or is detached, unset its domain
	so that it's NULL when, for example, a pthread destructor runs.

	* sgen-gc.c: Assert that there is no domain set after a thread is
	done.

2009-12-10  Mark Probst  <mark.probst@gmail.com>

	* class.c (mono_generic_class_get_class),
	metadata.c (free_generic_class): Allocate generic MonoClass's from
	the image mempool, not via malloc.  The problem with malloc is
	that when unloading a domain those classes are freed before
	clearing the heap and SGen needs the classes.  Rewriting the
	unloading code to do the free later would be more work and there's
	no point in using malloc anyway.

2009-12-09  Sebastien Pouliot  <sebastien@ximian.com>

	* loader.c (mono_method_signature): Always call mono_loader_unlock 
	before returning.

2009-12-09  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Add mono_verifier_verify_string_signature to check
	user string blobs.

	* verify-internals.h: Add new function to the internal API.

	* verify.c (do_ldstr): Call into mono_verifier_verify_string_signature to
	check if it's a valid string.

	* object.c (mono_ldstr): Ditto.

	Fixes #561943.

2009-12-09  Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_GetCurrentMethod): Drop all generic arguments
	from a method before returning it. This is the expected behavior.

2009-12-08  Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (inflate_method): Handle the case of a regular system type.

2009-12-08  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-pinning-stats.c, sgen-gray.c: More statistics
	gathering code.

	* mempool.c, mempool-internals.h: New function
	mono_mempool_get_bytes_allocated().

	* Makefile.am: sgen-pinning-stats.c added.

2009-12-08  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c (create_allocator): Only use the fast path if the
	object size is within the small object size limit.

2009-12-07  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Make sure section->data is aligned to 8 bytes by
	possibly adding padding to sizeof (GCMemSection).

2009-12-07  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c (mono_gc_wbarrier_nostore): Skip the remset if the
	reference is not in the nursery.

2009-12-07  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_from_typeref): Bounds check idx against the 
	assemblyref table.

2009-12-07  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-pinning.c: When pinning, make only one pass
	through the potential roots, then sort the results and find the
	pinned objects from there.

	* Makefile.am: sgen-pinning.c added.

2009-12-07  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Record generic stores in specialized remset buffers.

2009-12-06  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Make pinned chunks the same size as major heap
	sections, and align them as well, so that we can check whether an
	object is in a pinned chunk or a major section in constant time.

2009-12-06  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c (build_nursery_fragments): Don't leak fragments.

2009-12-06  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Make all major heap sections the same size (currently
	128k) and allocate them on aligned addresses.  Small heap sections
	give us better granularity with pinned objects - we can free up
	much more memory.

2009-12-06  Mark Probst  <mark.probst@gmail.com>

	* string-icalls.c (ves_icall_System_String_GetLOSLimit): Debug
	output removed.

2009-12-05  Zoltan Varga  <vargaz@gmail.com>

	Applied patch from Laurent Etiemble (laurent.etiemble@gmail.com).

	* mono/metadata/assembly.c: When opening an assembly image, pass the real
	names in addition to the runtime generated one.

	* mono/metadata/image.h: Add a function to take the real name of the assembly
	image.

	* mono/metadata/image.c: If a real name has been passed to load an assembly,
	use it instead of the runtime generated one.

	Code is contributed under MIT/X11 license.

2009-12-05  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (emit_marshal_vtype): Do the klass == date_time_class checks
	before the other checks to prevent problems if the DateTime class is blittable.
	Hopefully fixes #559600.

2009-12-05  Mark Probst  <mark.probst@gmail.com>

	* string-icalls.c, string-icalls.h, icall-def.h: New icall that
	returns the largest string length that will not be put into the
	LOS.

	* sgen-gc.c, gc-internal.h: New function that returns the largest
	object size that will not be put into the LOS.

	* appdomain.c: Bump corlib version.

2009-12-05  Zoltan Varga  <vargaz@gmail.com>

	* class-internals.h: Add MONO_RGCTX_INFO_METHOD_DELEGATE_CODE.

	* generic-sharing.c: Handle MONO_RGCTX_INFO_METHOD_DELEGATE_CODE.

2009-12-04  Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (inflate_method): Fix signature.

	* object-internals.h (MonoReflectionMethodOnTypeBuilderInst): Reflect change
	in managed code.

2009-12-04  Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (inflate_method): Make this method work with TypeBuilder as well.

2009-12-03  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Abstract to-space handling.

2009-12-03  Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (find_method_in_class): Ignore methods with broken signatures.

	Fixes #559906.

2009-12-03  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Only add references from outside the nursery to
	within the nursery to the global remset list.

2009-12-03  Mark Probst  <mark.probst@gmail.com>

	* appdomain.c (create_exceptions): Set the domain temporarily if
	necessary to avoid cross-domain references.

2009-12-02  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (get_stack_type): Return that the type is invalid instead of
	asserting.

	* verify.c (mono_method_verify): Verify that all locals and arguments
	have valid stack types.

	Fixes #559913.

2009-12-02  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (mono_method_verify): Bounds check the filter offset. Make all
	bounds checking overflow aware.

	Fixes #559910.

2009-12-02  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (do_invoke_method): Check for invalid method signatures.

	Fixes #553450.

2009-12-02  Jb Evain  <jbevain@novell.com>

	* appdomain.c (MONO_CORLIB_VERSION): bump.
	* icall-def.h (get_base_definition): renamed to get_base_method
	and add a boolean argument indicating we want the original
	method definition, or the immediate base method.
	* icall.c: apply the get_base_definition to get_base_method change.

2009-12-02  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_setup_fields): Fail an enum without an instance field.

	Fixes #558042.

Wed Dec 2 16:35:49 CET 2009 Paolo Molaro <lupus@ximian.com>

	* class.c: remove asserts for invalid type token in
	mono_class_name_from_token(), mono_assembly_name_from_token() and
	mono_class_create_from_typedef () (fixes bug #553318).

Wed Dec 2 15:48:19 CET 2009 Paolo Molaro <lupus@ximian.com>

	* metadata.c, class.c, loader.c: remove assert after bsearch() for
	incorrect assemblies (bug #553322).

2009-12-02  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata.c (mono_metadata_inflate_generic_inst): Add MonoError parameter.

	* metadata-internals.h: Change signature of mono_metadata_inflate_generic_inst. 

	* class.c (inflate_generic_type): Use new version of mono_metadata_inflate_generic_inst.

	* class.c (inflate_generic_context): Ditto.

	* loader.c (method_from_methodspec): Ditto.

	Fixes #558230.

2009-12-02  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_type_retrieve_from_typespec): Use MonoError machinery to report errors.

	* class.c (mono_class_create_from_typespec): Ditto.

	* class.c (mono_class_get_full): Fix for change on the above 2 functions.

	* class.c (mono_type_get_full): Fix for change on the above 2 functions.

	Fixes #558184.

2009-12-02  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (mono_class_has_default_constructor): Check fror broken signatures.

	* verify.c (verify_delegate_compatibility): Ditto.

	* verify.c (do_newobj): Ditto.

	Fixes #558046.

2009-12-02  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Use a gray queue instead of requiring that gray
	objects are in a contiguous region.

	* sgen-gray.c: The gray queue implementation.

	* Makefile.am: sgen-gray.c added.

2009-12-02  Mark Probst  <mark.probst@gmail.com>

	* appdomain.c: When unloading a domain, zero its static data and
	perform a minor collection when using SGen.  That will get rid of
	all the remsets pointing into that domain's static data.

	* sgen-gc.c: Allow remsets into static data.  By doing this we
	need less checks so we're more efficient.

2009-12-01  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (mono_method_verify): Check for catch clauses with broken
	types.

	Fixes #558465.

2009-12-01  Jb Evain  <jbevain@novell.com>

	* class.c (make_generic_param_class): set the namespace of
	the generic parameter class from its owner, if available.

2009-12-01  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (code_bounds_check): Do proper overflow checking.

	* verify.c (mono_method_verify): The number of switch entries is
	an unsigned int. Properly bounds check it.

	Fixes #558594.

2009-12-01  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata.c: Kill mono_metadata_get_param_attrs_checked. Add
	mono_metadata_method_has_param_attrs which only checks if a given param
	list has a non zero flags entry.

	* metadata.c (mono_metadata_get_param_attrs): Add param_count parameter
	to inform how many params should we expect to decode.

	* loader.c (mono_method_signature): Use mono_metadata_method_has_param_attrs
	as it's faster than mono_metadata_get_param_attrs.

	* metadata-internals.h: Fix mono_metadata_get_param_attrs signature and
	add mono_metadata_method_has_param_attrs.

2009-12-01  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_setup_vtable_general): Check for mono_method_get_vtable_slot
	failures.

	* class.c (mono_method_get_vtable_slot): Don't assert if the computed method slot
	is -1 but its class is broken.

	Fixes #558522.

2009-12-01  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata.c: Introduce mono_metadata_get_param_attrs_checked which checks
	for parameter overflow.

	* metadata.c (mono_metadata_parse_method_signature_full): Use checked version
	of mono_metadata_get_param_attrs.

	* metadata-internals.h: Add mono_metadata_get_param_attrs_checked to the internal
	API.

	* loader.c (mono_method_signature): Use checked version of mono_metadata_get_param_attrs.

2009-12-01  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_setup_fields): Check for fields with broken types.

	Fixes #558741.

2009-11-28  Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (ensure_generic_class_runtime_vtable): Split this function in 2
	so we can avoid calling ensure_runtime_vtable multiple times for the GTD during
	its TypeBuilder::CreateType ().

	* reflection.c (ensure_generic_class_runtime_vtable): Avoid initializing interfaces
	if not needed.

	* reflection.c: Every time we change the interface array, set interfaces_packed to NULL
	to make setup_interface_offsets happy.

	* reflection.c (remove_instantiations_of_and_ensure_contents): Fix instances again as corlib
	compilation now works.

2009-11-28  Zoltan Varga  <vargaz@gmail.com>

	* appdomain.c (create_exceptions): New helper function extracted from
	mono_runtime_init () to precreate objects used during exception handling.
	(mono_runtime_init): Call it.
	(mono_domain_create_appdomain_internal): Ditto. Fixes #555264.

2009-11-27  Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (remove_instantiations_of_and_ensure_contents): Temp hack to fix corlib
	compilation until the proper one is found.

2009-11-27  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_setup_vtable_general): Cache the result of
	get_virtual_methods () since it can be slow because of the metadata
	optimization.

	* metadata-internals.h (_MonoImage): Change 'method_cache' to a GHashTable
	from a MonoValueHashTable for now, since the later is based on an earlier
	version of hpj's internal probing code and seems to have serious collision
	issues.

	* loader.c (mono_get_method_full): Update after the change above.

2009-11-26  Zoltan Varga  <vargaz@gmail.com>

	* class-internals.h (MonoCachedClassInfo): Add 'is_generic_container' field.

2009-11-26  Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (get_field_on_inst_generic_type): Try to fallback using the field from
	the GTD instead of the DGC instead of crashing.

	* reflection.c (ensure_generic_class_runtime_vtable): Only reinflate stuff that is
	required. Inflate fields if needed.

	* reflection.c (remove_instantiations_of): Ensure generic instances are properly
	finished. Renamed.

2009-11-26  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (check_interface_method_override): Check for NULL signatures and fail
	the type.

	* debug-helpers.c (mono_signature_get_desc): Return a fixed string for NULL signatures.

	Fixes #553428.

2009-11-26  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_get_virtual_methods): Call decode_row_col to obtain
	the MONO_METHOD_FLAGS column instead of decoding the whole row.

2009-11-25  Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (field_from_memberref): Resolve the class first then the field
	signature. Remove a lot of duplicated code and make sure we don't pass valid
	values to mono_loader_set_error_field_load.

	Fixes #553306.

2009-11-25  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (inflate_generic_type): Change code to use new signature of
	mono_error_set_bad_image.

	Fixes #558124.

2009-11-25  Sebastien Pouliot  <sebastien@ximian.com> 

	* verify.c (mono_method_verify): Don't free ctx.params items if 
	we aborted while inflating the ctx.locals. Complete previous fix

2009-11-25  Sebastien Pouliot  <sebastien@ximian.com>

	* verify.c (mono_method_verify): Use the uninflated type name, 
	when the inflated is null, to report errors. Also take care when
	freeing, not to free everything since, in case of an error, some
	stuff would be copies (i.e. not allocated by the function itself)
	Fix bug #558145

2009-11-24  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (stack_push, stack_pop, stack_pop_safe): Assert if we underflow
	or overflow. The caller must have done this check explicitly. This guard us
	from accessing invalid memory.

	* verify.c (do_push_static_field): Check for stack overflow.

	Fixes #553333.

2009-11-24  Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (find_method_in_class): Don't crash if the signature cannot
	be resolved.

	* metadata.c (mono_metadata_parse_generic_param): Return NULL instead
	of asserting for the case of invalid params.

	Fixes #553304.

2009-11-24  Sebastien Pouliot  <sebastien@ximian.com>

	* image.c (mono_image_load_module): Fix crash when a bad assembly
	has no module at all (fix bug #553412) and also replace the 
	g_assert with a return NULL (documented return value for failure)

2009-11-23  Zoltan Varga  <vargaz@gmail.com>

	* debug-helpers.c (mono_type_get_desc): Handle typedbyref.

2009-11-23  Miguel de Icaza  <miguel@novell.com>

	* file-io.c: Change FindFirst/FindNext/FindClose API to return the
	file attribute to managed code and avoid doing the mask/attribute
	checks here. 

2009-11-22  Miguel de Icaza  <miguel@novell.com>

	* file-io.c: Surface a smart FindFirst/FindNext/FindClose API to
	the managed world.

	* icall-def.h: New entry points.
	
2009-11-19  Mark Probst  <mark.probst@gmail.com>

	* process.c: Don't put references to managed objects into a
	g_ptr_array.

2009-11-18  Sebastien Pouliot  <sebastien@ximian.com>

	* class.c (can_access_internals): Allow CoreCLR to participate in
	allowing (or not) [InternalsVisibleTo] between assemblies.
	* security-core-clr.c|h: Make sure that only trusted code (a 
	superset of platform code) can access the internals of platform
	code.

Mon Nov 16 16:28:11 CET 2009 Paolo Molaro <lupus@ximian.com>

	* reflection.c: use the correct base class to get the virtual method
	"get_UnderlyingSystemType" and speed up the icall. Fixes bug #555013.

2009-11-16  Sebastien Pouliot  <sebastien@ximian.com>

	* security-core-clr.c (get_caller_no_reflection_related): 
	[Mono]Type.InvokeMember is outside System.Reflection[.Emit] but
	it's still reflection and must be filtered correctly.

2009-11-16  Mark Probst  <mark.probst@gmail.com>

	* object.c (compute_class_bitmap): Fix for large bitmaps.

2009-11-15  Zoltan Varga  <vargaz@gmail.com>

	(mono_gc_get_suspend_signal): Fix the build with a system libgc.

	* boehm-gc.c (mono_gc_base_init): Applied patch from DKoushik K. Dutta (
	koush@koushikdutta.com). Disable GC_no_dls on android.

2009-11-12  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c (find_tlab_next_from_address): Handle the case where
	tlab_next points outside the TLAB because the allocator was
	interrupted.

2009-11-09  Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (mono_image_module_basic_init): Handle exceptions correctly.

2009-11-09  Rodrigo Kumpera  <rkumpera@novell.com>

	* object-internals.h: Change signature for mono_string_to_utf8_image.

	* object.c (mono_string_to_utf8_image): Change signature to take a MonoError
	argument.

	* reflection.c: Take care of mono_string_to_utf8_image change and avoid raising
	exceptions due to mono_string_to_utf8.

2009-11-09  Rodrigo Kumpera  <rkumpera@novell.com>

	* object-internals.h: Change signature for mono_string_to_utf8_mp.

	* object.c (mono_remote_class): Make sure all resources are released before
	raising an exception.

	* object.c (mono_print_unhandled_exception): Avoid raising an exception.

2009-11-09  Rodrigo Kumpera  <rkumpera@novell.com>

	* mono-perfcounters.c (network_get_impl): Change variable initialization
	ordering to fix potential memory leak in case of exceptions.

	* mono-perfcounters.c (mono_perfcounter_create): Properly handle badly
	encoded strings.
	
2009-11-09  Rodrigo Kumpera  <rkumpera@novell.com>

	* file-io.c (ves_icall_System_IO_MonoIO_GetFileSystemEntries): Change
	variable initialization ordering to fix potential memory leak in case
	of exceptions.

2009-11-09  Zoltan Varga  <vargaz@gmail.com>

	* icall.c (mono_ArgIterator_Setup): Remove the MONO_ARCH_REGPARMS stuff, its not
	needed.

2009-11-07  Rodrigo Kumpera  <rkumpera@novell.com>

	* appdomain.c: Fix shadow path code to better deal with exceptions.

2009-11-07  Rodrigo Kumpera  <rkumpera@novell.com>

	* appdomain.c: Use checked version of mono_string_to_utf8 to avoid raising an
	exception in the middle of the runtime code.

2009-11-07  Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_System_Environment_InternalSetEnvironmentVariable): Don't
	leak memory with broken envvar value.

2009-11-06  Mark Probst  <mark.probst@gmail.com>

	* reflection.c (mono_reflection_setup_internal_class): Because
	nested classes are not added to the name cache, we must put them
	in the reflection_info_unregister_classes list.

2009-11-05  Sebastien Pouliot  <sebastien@ximian.com>

	* class.c: When CoreCLR is enabled don't call mono_init_com_types
	if MONO_CLASS_IS_IMPORT return true unless the type reside in 
	platform (trusted) code. Instead we return a TypeLoadException to
	be thrown later. This is the exception thrown by Silverlight 2 if
	a type, inside application (user) code is marked with [ComImport]

2009-11-05  Zoltan Varga  <vargaz@gmail.com>

	* icall.c (ves_icall_System_Diagnostics_Debugger_IsAttached_internal): Call
	mono_is_debugger_attached () too.

	* mono-debug.c (mono_is_debugger_attached): New helper function.
	(mono_set_is_debugger_attached): Ditto.

2009-11-05  Rodrigo Kumpera  <rkumpera@novell.com>

	* object-internals.h: Add mono_string_to_utf8_checked.

	* object.c: Implement mono_string_to_utf8_checked.

2009-11-05  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c: Add missing check for load errors after every
	call to mono_class_setup_fields

	Fixes #552282.

2009-11-05  Rodrigo Kumpera  <rkumpera@novell.com>

	metadata-verify.c (verify_tables_schema): Fix the error message.

2009-11-05  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata.c: Change event table schema to use TDOR for event type
	as this is what it's meant to be.

	* metadata.c (mono_metadata_compute_size): Change MONO_TABLE_ASSEMBLYPROCESSOR
	to MONO_TABLE_ASSEMBLYREFPROCESSOR, which is table that has a MONO_MT_TABLE_IDX
	entry.

	* metadata.c (mono_metadata_compute_size): Trim MT_TABLE_IDX of code that no
	longer makes sense: remove MONO_TABLE_EVENT and remove checks for non-existent
	rows in MONO_TABLE_GENERICPARAM.

	Fixes #552289.

2009-11-05  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_image_add_to_name_cache): Assert on duplicate
	insertion.

	* reflection.c (mono_reflection_setup_internal_class): Avoid
	registering a gc root the same MonoClass multiple times.
	Don't register nested types on the global scope as they should
	not be available there.

2009-11-05  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* culture-info-tables.h: regenerated.

2009-11-04 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* debug-helpers.c: avoid g_strdup() in mono_type_full_name().

2009-11-04  Sebastien Pouliot  <sebastien@ximian.com>

	* string-icalls.c|h: Remove string internal calls that are not 
	used anymore by the class libraries.
	* icall.c: Remove System_Reflection_FieldInfo_internal_from_handle
	which is not used in the class librairies.
	* icall-def.h: Update tables.

2009-11-04  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.h: Move mono_class_inflate_generic_type_checked...

	* class-internals.h: to here and make it internal. We don't want to
	further expose MonoGenericContext. 

2009-11-04  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (mono_method_verify): Improve error message.

2009-11-04  Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (fieldref_encode_signature): If field_image is NULL then
	the token is already properly encoded. Fixs 4.0 build.

2009-11-04  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* locales.c (construct_number_format): Check if the number index is
	valid before trying to use it, if not, just return.
	
2009-11-04  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_get_runtime_invoke): Don't reset abort exceptions,
	since that loses the abort state. Fixes #539394.

2009-11-03  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_get_native_wrapper): For icall wrappers, add an
	explicit this argument to the call signature.
	(mono_marshal_get_icall_wrapper): Ditto.

2009-11-03  Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (fieldref_encode_signature): Add new field_image parameter
	to indicate which assembly to use when resolving a custom-mod.

	Fixes handling of volatile fields used across assemblies as reported in #551513.

2009-11-03  Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c: Improve error messages.

2009-11-03  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_setup_methods): Only give a slot for virtual methods
	of interfaces. Fixes IKVM.

	* class.c (mono_class_setup_vtable_general): Improve debug spew.

2009-11-03  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (verifier_inflate_type): Return the inflated type on success.

2009-11-02  Zoltan Varga  <vargaz@gmail.com>

	* debug-mono-symfile.c (check_line): Fix the handling of IL offset 0.

	* threads.c (mono_thread_attach): Call the profiler thread start callback.

	* object-internals.h (_MonoThreadInternal): Add a 'flags' field.

	* threads.c (build_wait_tids): Ignore threads which have the DONT_MANAGE
	flag set.

	* profiler.c: Add new profiler callbacks for runtime invoke.

	* object.c (mono_runtime_invoke): Call the runtime invoke callbacks.

2009-11-01  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Keep track of the reason for a major collection and
	write it to the heap-dump file.

2009-10-31  Miguel de Icaza  <miguel@novell.com>

	* threads.c: refactor the code that initializes the
	thread_start_args into a reusable function and use this in the two
	methods that start up threads.

2009-10-31  Zoltan Varga  <vargaz@gmail.com>

	* appdomain.c (mono_domain_try_unload): Applied patch from Romain Tartière.
	Fix returning when WaitForSingleObjectEx returns WAIT_IO_COMPLETION.

2009-10-31 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* mono-perfcounters.c: add the "_Total" instance for CPU counters.
	Until now, we only had the per-cpu(core) counters.

2009-10-28  Mark Probst  <mark.probst@gmail.com>

	* gc-internal.h, boehm-gc, sgen-gc.c, null-gc: Add
	mono_gc_get_suspend_signal(), which returns the suspend signal
	number used by the GC.

2009-10-25  Zoltan Varga  <vargaz@gmail.com>

	* threads.c (start_wrapper): Avoid an assert if thread_start_args () is NULL.

	* threads.c (start_wrapper): Call mono_profiler_thread_start () later after
	signalling start_notify.

2009-10-24 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* appdomain.c: do not test the st_mode field for shadow-copies.
	Fixes bug #545276.

2009-10-24 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* threadpool.[ch]: added hooks for thread start/finish and item
	processing begin/end. For monotouch use only.

2009-10-24  Zoltan Varga  <vargaz@gmail.com>

	* threads.c (mono_thread_get_name): New helper function.

	* reflection.c (resolve_object): Set handle_class for strings too.
	(mono_reflection_create_custom_attr_data_args): New helper function to decode
	a cattr blob into a set of arrays and structures without creating the custom
	attributes themselves.
	(create_custom_attr_data): Simplify using create_custom_attr_data_args.

	* mono-debug.c (mono_debug_il_offset_from_address): New helper function.

	* debug-mono-symfile.c (mono_debug_symfile_get_line_numbers): New helper
	function.

2009-10-23  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c: Replace calls to mono_class_inflate_generic_type with
	mono_class_inflate_generic_type_checked. Fixes #480005.

2009-10-23  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_inflate_generic_type_with_mempool): Clear the error
	object since not all paths lead to callees initing it.

2009-10-23  Alp Toker  <alp@nuanti.com>

	Fix embedding API breakage from r144688. mono-compiler.h is an internal
	header and should not be shipped:

	* class.h: Back out MONO_DEPRECATED change. Currently depends on config.h
	which is specific to the mono build. Not going to work.

2009-10-23  Sebastien Pouliot  <sebastien@ximian.com>

	* security-manager.c: Report if core-clr is active from
	ves_icall_System_Security_SecurityManager_get_SecurityEnabled
	to allow Moonlight BCL to behave appropriately (both in browser
	and outside, e.g. smcs)

2009-10-23 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* mono-config.c: ignore UTF-8 BOM and report parser errors.
	Fixes bug #549108.

2009-10-22 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* class.c: fix typo.

2009-10-22  Rodrigo Kumpera  <rkumpera@novell.com>

	* class-internals.h: Change signature of mono_class_inflate_generic_type_with_mempool to take
	a MonoError parameter.

	* class.h: Mark mono_class_inflate_generic_type deprecated, add new mono_class_inflate_generic_type_checked
	version that can does proper error handling.

	* class.c (inflate_generic_type): Add a MonoError parameter. Don't assert on error, use new mono error machinery.

	* class.c (mono_class_inflate_generic_type_with_mempool): Add new MonoError parameter.

	* class.c, generics-sharing.c: Changes to handle mono_class_inflate_generic_type_with_mempool new signature.

2009-10-20  Zoltan Varga  <vargaz@gmail.com>

	* debug-helpers.c (dis_one): Fix the disassembly of empty strings when
	NO_UNALIGNED_ACCESS is defined.

2009-10-22  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_string_builder_to_utf16): Applied patch from
	Hib Eris  <hib@hiberis.nl>. Return empty string for empty string builders.
	Fixes #549173.

2009-10-22  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Shorten sections whenever possible.

2009-10-22  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Use our portable semaphore #defines.

2009-10-22  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: A debug option for dumping the heap layout to a file
	after each collection.

2009-10-21  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Make managed write barriers atomic via
	thread-restarts.

2009-10-21  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (verify_delegate_compatibility): Properly verify delegate creation of static
	methods. Fixes #543021.

2009-10-21 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* socket-io.[ch]: fix VS build.

2009-10-21 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* icall-def.h:
	* socket-io.[ch]: implemented SendFile.

2009-10-20  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_create_from_typedef): Initialize class->element_class
	before the interfaces to avoid crashes later if class initialization fails.
	Fixes #548417.

	* marshal.c (emit_marshal_vtype): Implement byref marshalling of DateTime.
	Fixes #548276.

2009-10-20  Marek Safar  <marek.safar@gmail.com>

	* domain.c: Bump 4.0 version.

2009-10-19  Sebastien Pouliot  <sebastien@ximian.com>

	* assembly.c (mono_assembly_load_reference): Fix leak when 'status'
	code is known. (parse_public_key) Remove duplicate (unneeded) NULL
	check since 'pubkey' can't be NULL at this stage
	* icall.c (ves_icall_System_Array_FastCopy): Add comment about
	the check. (ves_icall_Type_GetInterfaceMapData) Remove duplicate
	initialization of 'iter'

2009-10-16  Bill Holmes  <billholmes54@gmail.com>

	* cominterop.c : Search the interface parts of vtable to find 
	  method matches.  Fixes 547030.

	Code is contributed under MIT/X11 license.

2009-10-15 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* marshal.c: BeginInvoke cannot be called on multicast delegates with
	multiple targets. Fixes bug #574426.

2009-10-14  Massimiliano Mantione  <massi@ximian.com>

	* profiler.h: Put here the definition of
	MONO_PROFILER_MAX_STAT_CALL_CHAIN_DEPTH
	(and fix the build...).

2009-10-14  Massimiliano Mantione  <massi@ximian.com>

	* profiler.c, profiler.h, profiler-private.h:
	Added support for different ways of getting call chains in stat mode.

2009-10-12  Mark Probst  <mark.probst@gmail.com>

	* object.c, object-internals.h: New function for computing the
	size of an array, factored out of mono_array_new_full().  Use
	SGen's functions for allocating arrays and vectors.

	* sgen-gc.c, gc-internal.h: Special functions for allocating
	arrays and vectors without race conditions.  A managed array
	allocator method.

	* boehm-gc.c, null-gc.c: Don't provide a managed array allocator.

2009-10-12  Mark Probst  <mark.probst@gmail.com>

	* object.c, object.h, icall.c: Write barriers do the copying now,
	as well, so no need for an additional memcpy.

	* sgen-gc.c: Lock when storing remsets.  Do the memory
	copying/moving in the write barriers.

	* null-gc.c, boehm-gc.c: Write barriers must copy here, too.

	* reflection.c: Added an assert.

2009-10-12  Mark Probst  <mark.probst@gmail.com>

	* threads.c, process.c: A few missing write barriers.

2009-10-12  Joel W. Reed <joelwreed@gmail.com>

	* mono-perfcounters.c, mono-perfcounters-def.h: Add
	network performance counters for bytes sent per second, bytes
	received per second, and bytes total per second.

	Code is contributed under MIT/X11 license.

2009-10-09  Mark Probst  <mark.probst@gmail.com>

	* threads.c (ves_icall_System_Threading_Thread_GetAbortExceptionState):
	Fix warning.

2009-10-09  Mark Probst  <mark.probst@gmail.com>

	* threads.c, object-internals.h, object.c: Move code for
	transferring an object to a different domain (via
	serialization/remoting) to object.c.

	* object.c (call_unhandled_exception_delegate): If the exception
	is in a different domain than the delegate, transfer the exception
	to that domain.

2009-10-07  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (emit_marshal_vtype): Emit marshalling of DateTime to OLE DATE.
	Fixes #322934.

2009-10-06  Zoltan Varga  <vargaz@gmail.com>

	* domain.c (DEFAULT_RUNTIME_VERSION): Change this to v2.0.

2009-10-06  Mark Probst  <mark.probst@gmail.com>

	* object.c (mono_method_return_message_restore): Handle the case
	where the argument is an instance of a generic type.  Fixes
	#544446.

2009-10-06  Mark Probst  <mark.probst@gmail.com>

	* object.c (set_value): Write barrier fix - we must pass the
	count, not the size.

2009-10-05  Zoltan Varga  <vargaz@gmail.com>

	* domain.c (mono_init_internal): Print a useful error message when encountering
	an old mscorlib, instead of crashing. Fixes #544307.

2009-10-04  Zoltan Varga  <vargaz@gmail.com>

	* appdomain.c (copy_app_domain_setup): Fix a warning.

	* debug-helpers.c (dis_one): Ditto.

2009-10-04  Mark Probst  <mark.probst@gmail.com>

	* domain-internals.h, appdomain.c: The AppDomainSetup is copied
	into the new domain, instead of referencing the original one.

	* marshal.c, marshal.h: Make mono_marshal_xdomain_copy_value()
	non-static.

	* appdomain.c: Corlib version bump.

2009-10-02 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* threadpool.c: one more...

2009-10-02 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* threadpool.c: forgot a LeaveCriticalSection when telling the idle
	threads to die because we're shutting down. delgate5.exe works again.

2009-10-01  Bill Holmes  <billholmes54@gmail.com>

	* cominterop.c (mono_marshal_free_ccw_entry): Updating the
	  ccw_interface_hash table when a ccw is finalized.

	Code is contributed under MIT/X11 license.

2009-09-30  Mark Probst  <mark.probst@gmail.com>

	* assembly.c, domain.c, image.c, metadata-internals.h: Split
	domain and image unloading into two steps.  We must do this
	because clearing the domain in SGen requires the class metadata to
	be intact, but we need to free the mono_g_hash_tables in case a
	collection occurs during domain unloading and the roots would trip
	up the GC.

2009-09-30  Mark Probst  <mark.probst@gmail.com>

	* object-internals.h: Remove serialized culture fields from
	MonoInternalThread.

	* icall-def.h, thread-types.h, threads.c: Remove serialized
	culture icalls.

	* appdomain.c: Corlib version bump.

2009-09-30  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (emit_marshal_object): Emit out marshalling of stringbuilders.
	Fixes #543133.

2009-09-30  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Try to shorten the new section after a major
	allocation to avoid ever-growing sections.

2009-10-13  Martin Baulig  <martin@ximian.com>

	* mono-debug-debugger.h (MonoDebuggerEvent): Renamed
	`MONO_DEBUGGER_EVENT_TRAMPOLINE' into
	`MONO_DEBUGGER_EVENT_OLD_TRAMPOLINE' and added a new
	`MONO_DEBUGGER_EVENT_TRAMPOLINE'.

	* mono-debug.h (MONO_DEBUGGER_MINOR_VERSION): Bump to 4.

2009-09-29 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* threadpool.c: fixed the order in which 'completed' and the wait
	handle, if any, are set.  Fixes bug #542933 and delegate2.exe
	No need to use the wait_handle field of ASyncCall. Make sure the
	threadpool is active when adding a job or queueing an idle thread.

2009-09-29  Zoltan Varga  <vargaz@gmail.com>

	* object.c (mono_unhandled_exception): Fix a crash if there is no main thread.

	* threads.c (build_wait_tids): Fix a crash if there is no main thread, like
	when using --compile-all.

2009-09-27  Mark Probst  <mark.probst@gmail.com>

	* metadata.c (free_generic_class): Unregister the field_objects
	roots if we're using SGen.

2009-09-27  Mark Probst  <mark.probst@gmail.com>

	* reflection.c (mono_dynamic_image_free): Deregister the GC root
	for GenericParamTableEntry.gparam.

2009-09-27 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* marshal.c: don't create the handle when calling. It is created later
	if needed.

2009-09-26  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Warning fixes.

2009-09-26  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: New debug option "xdomain-checks", which scans the
	whole heap for cross-domain references before each collection.

	* sgen-scan-object.h: The scan action can now use SCAN to scan the
	object.

	* threadpool-internals.h, threadpool.c: New function
	mono_thread_pool_is_queue_array() for checking whether a given
	array is used as a (cross-domain) queue by the thread pool code.

2009-09-26  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: New function mono_gc_scan_for_specific_ref() which
	searches the whole heap for objects containing a specific
	reference.  Only for debugging.

2009-09-26  Mark Probst  <mark.probst@gmail.com>

	* appdomain.c (MONO_CORLIB_VERSION): Bumped.

	* icall-def.h, threads.c, threads-types.h: New icalls for copying
	byte arrays between domains.

2009-09-25 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* threadpool.c:
	* class-internals.h:
	* mono-perfcounters-def.h:
	* mono-perfcounters.c:
	-There is a list of idle threads
	-Each of those idle threads wait on their own WaitHandle instead
	of all of them using the same semaphore. When a new work item is
	added, the job is assigned directly to an idle thread or a newly
	created one if possible and then the handle for that thread is
	signaled. Compare that to the current approach where all the
	threads in the pool compete to dequeue a job from the same
	queue.
	-New struct ThreadPool that brings together the bunch of static
	variable for each threadpool (IO and regular).
	-New performance counters: # of items added and its rate per
	threadpool. The rate will be used later, perhaps together with
	other perf. counters, to decide when idle threads should exit.

2009-09-25  Jonathan Chambers  <joncham@gmail.com>

	* socket-io.c (ves_icall_System_Net_Sockets_Socket_Receive_internal): 
	Fix typo on Windows build.	
	(ves_icall_System_Net_Sockets_Socket_Accept_internal): Fix typo on Windows build.
	
	Code is contributed under MIT/X11 license.

2009-09-25  Mark Probst  <mark.probst@gmail.com>

	* object-internals.h: The Thread class is split up into Thread and
	InternalThread now.  We have exactly one InternalThread per
	thread, and at most one Thread per appdomain per thread.  Most
	data is stored in InternalThread.  All InternalThread objects live
	in the root domain.

	* class-internals.h: Add internal_thread_class to MonoDefaults.

	* appdomain.c (mono_domain_unload), attach.c (receiver_thread),
	domain.c, gc.c, icall-def.h, monitor.c, object.c, sgen-gc.c,
	socket-io.c, threadpool.c, thread-types.h, threads.c: Changes
	resulting from the split of the Thread class.

	* gc-internal.h: Prototype for new function for checking whether a
	thread is the finalizer thread.

	* appdomain.c: Corlib version bump.

2009-09-25  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* appdomain.c|h: Add a mono_domain_try_unload method which is
	equivalent to mono_domain_unload, except that it returns an exception
	instead of throwing it. Make mono_domain_unload use the
	mono_domain_try_unload method to avoid code-duplication.

2009-09-25  Zoltan Varga  <vargaz@gmail.com>

	* debug-helpers.c (dis_one): Avoid unaligned accesses on platforms where that is
	a problem.

2009-09-24  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (emit_ptr_to_object_conv): Generate an exception instead of
	aborting when a conversion is not implemented.

2009-09-23  Miguel de Icaza  <miguel@novell.com>

	* verify.c: when comparing culture strings, use g_ascii_strcmp

	* assembly.c (mono_public_tokens_are_equal): Change g_strcasecmp
	when comparing public key tokens to use memcmp on 16 bytes.   I do
	not believe this ever worked as advertised in the past.

	The standard Public Key is 00 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00
	which would have always failed earlier.

2009-06-25  Miguel de Icaza  <miguel@novell.com>

	* gc.c: Raise a NullArgumentException if the object passed is
	null.

2009-09-22  Zoltan Varga  <vargaz@gmail.com>

	* image.c (mono_image_close): Atomically decrement the reference count and
	remove the image from the hash tables, to prevent another thread from seeing a
	dying MonoImage. Fixes #541194.

2009-09-22 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* threadpool.c: actually use the minimum number of 'completion ports'
	(for us is just a potential worker thread).

2009-09-22 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* threadpool.c: remove ares_htable. It does not make sense any more
	since the same objects are now stored in GC-tracked arrays while they are
	in the queue.

2009-09-22 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* threadpool.c: increase the minimum length of the queues to 128.
	Remove warning.

2009-09-21  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_get_string_ctor_signature): New internal function to
	return the modified signature used by string ctors.

2009-09-20  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_get_runtime_invoke_dynamic): New internal function
	to return a runtime-invoke wrapper which uses DYN_CALL to call the wrapped
	method, to be used by full-aot.

2009-09-18  Rodrigo Kumpera  <rkumpera@novell.com>

	Since the runtime supports lazy initialization of a type's vtable and this can cause a type
	to fail, we need to ensure that the vtable is properly initialized at spots were the type must
	be known to be good.

	* class.c (mono_class_init): Fail array types if their element type fails initialization
	as well.

	* object.c (mono_class_create_runtime_vtable): Fail array types if their element type fails
	initialization, additionally we request the element_type vtable to be initialized as well.

	This is fine and should not increase the working set in any meaningful way since it's reasonable
	to assume	that most code will create an array and eventually populate it, which will require the
	type's vtable to be initialized.

	* loader.c (field_from_memberref): Add a comment for a possibly useless mono_class_init call.

2009-09-17  Atsushi Enomoto  <atsushi@ximian.com>

	* normalization-tables.h : regenerated.

2009-09-16  Zoltan Varga  <vargaz@gmail.com>

	* mono-debug.c (mono_debug_add_method): Increase the size of the buffer,
	a leb128 encoding can take up to 5 bytes.

2009-09-15  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (verify_class_overrides): Remove useless argument.

	* class.c (mono_class_setup_vtable_general): Move the overrides check to happen
	before interface enumeration as this is no longer required.

2009-09-15  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c: New function mono_class_is_assignable_from_slow that is safe to be
	used under mono_class_init context. This functions avoid any code path that
	calls mono_class_init, which leads it to be slow as some things like the interface
	bitmap are not available.

	* class.c (verify_class_overrides): Use mono_class_is_assignable_from_slow instead
	of it's own broken version. Fixes the verifier part of #538588.

	* class-internals.h: Export mono_class_is_assignable_from_slow as part of the internal
	API.

2009-09-15  Mark Probst  <mark.probst@gmail.com>

	* class.c (mono_class_init): Always set an exception in a class if
	vtable setup fails.  Fixes #538577.

	* generic-sharing.c: Raise an exception if mono_class_vtable()
	returns NULL.

2009-09-13  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_get_runtime_invoke): Don't share instance 
	methods of vtypes, as they could be incorrectly shared with static methods
	taking an IntPtr argument.

2009-09-12 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* domain.c:
	* object.c:
	* class-internals.h: renamed waithandle_class to
	manualresetevent_class.
	* marshal.c: propagate the exception if a remoting BeginInvoke call
	fails.

2009-09-11  Rodrigo Kumpera  <rkumpera@novell.com>

	* object.c: Properly handle vtable failures.

2009-09-11  Rodrigo Kumpera  <rkumpera@novell.com>

	* socket-io.c: Assert on vtable failure.

	* mono-mlist.c: Assert on vtable failure.

2009-09-11  Rodrigo Kumpera  <rkumpera@novell.com>

	* marshal.c: Assert on vtable failure.

2009-09-11  Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c: Properly handle vtable failures.

2009-09-11  Rodrigo Kumpera  <rkumpera@novell.com>

	* debug-helpers.c (mono_class_describe_statics): Properly handle vtable failures.

2009-09-11  Rodrigo Kumpera  <rkumpera@novell.com>

	* cominterop.c (ves_icall_System_ComObject_CreateRCW): Property handle vtable failures.

	* console-unix.c (do_console_cancel_event): Same.

2009-09-11  Rodrigo Kumpera  <rkumpera@novell.com>

	* class-internals.h: Add mono_class_vtable_full function that allows control
	if an exception should be raised or not.

	* object.c (mono_class_vtable): Call into mono_class_vtable_full. Fix this function
	to do what its documentation say, that is to return NULL and set exception_type on
	failure.

	* object.c (mono_class_create_runtime_vtable): Add new raise_on_error parameter
	and change the code to honor it.

2009-09-11  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c: Fix typo in error message.

2009-09-10  Sebastien Pouliot  <sebastien@ximian.com>

	* security-core-clr.c: Fix default_platform_check so it can run
	the runtime coreclr tests (without an infinite recursion when
	throwing an exception).

2009-09-10  Rodrigo Kumpera  <rkumpera@novell.com>

	object.c (mono_delegate_ctor_with_method): Guard against null method.

2009-09-10  Rodrigo Kumpera  <rkumpera@novell.com>

	* marshal.c (mono_marshal_get_xappdomain_dispatch): Add an assert
	that should be replaced with error handling later.

2009-09-10  Rodrigo Kumpera  <rkumpera@novell.com>

	* marshal.c (mono_delegate_end_invoke): Fix warning.

2009-09-10  Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (mono_field_from_token): Properly handle invalid
	dynamic tokens.

2009-09-10  Rodrigo Kumpera  <rkumpera@novell.com>

	* pedump.c (verify_image_file): Skip types that can't be
	decoded.

2009-09-10  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c: Look for recursive valuetypes only against the
	type been initialized as this is a lot simpler and works.

2009-09-10  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c: Ensure that fields are properly loaded before
	checking them.

2009-09-10  Bill Holmes  <billholmes54@gmail.com>

	* object.c (mono_object_get_virtual_method) : Call 
	  mono_cominterop_get_invoke if the object is a COM object.

	Code is contributed under MIT/X11 license.

2009-09-09  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c: Check for recursive valuetype definitions.

2009-09-08  Rodrigo Kumpera  <rkumpera@novell.com>

	Use inheritance-aware interface offsets. Inherited types use the same offsets
	of their parents. This reduce offset duplication in case more than one type in
	the inheritance tree explicitly implements the same interface.

	This also removes a source of vtable bubbles found in #532409. An abstract type
	isn't required to provide abstract methods to all interfaces it implements, which
	resulted in a bubble with the previous scheme as the child would get a non-full
	vtable from its parent. We fail all concrete types with vtable bubbles, so this
	should be fixed.

	This change causes an increase of 1.7% in vtable memory usage for IronPython pystone but
	it's expected to not cause any significant increase beyond that.

	* class.c (setup_interface_offsets): Compute super class iface offsets
	first to force sharing.

	* class.c: Add VTABLE_SELECTOR macro to the vtable debug macros to help
	dumping only the relevant ones.

	* class.c (mono_class_setup_vtable_general): Give newslot, non final, virtual
	methods a new slot regardless if they belong to an interface or not. This allows
	an inherited type to override the iface method separately from the class one.

2009-09-04 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* threadpool.c: make the Sleep() alertable to prevent delays exiting
	applications that take less than 2s to execute.
	Bug #524984 fixed.

2009-09-04  Zoltan Varga  <vargaz@gmail.com>

	* object-internals.h (MonoRuntimeCallbacks): Add a 'get_runtime_build_info' callback.

	* object.c (mono_get_runtime_callbacks): New helper function to return
	the runtime callbacks.

	* icall.c (ves_icall_Mono_Runtime_GetDisplayName): Use the result of
	mono_get_runtime_build_info () as the display name.
	
2009-09-03  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (emit_marshal_array): Call conv.ovf.i on the array parameter
	argument, since NEWARR expects a native int. Fixes #481559.

2009-09-03  Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_MonoMethod_GetDllImportAttribute): Guard
	against broken SRE methods.

2009-09-03  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_type_get_full): Don't call mono_metadata_free_type on
	a NULL variable. Abort early on failure.

2009-09-03  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (can_access_type): Fail visibility test for non nested
	types with nested visibility.

2009-09-02  Sebastien Pouliot  <sebastien@ximian.com>

	* assembly.c (parse_public_key): Avoid allocating (and not 
	freeing) the public key array when it's not requested by the 
	caller.
	* threads.c (mono_thread_manage, mono_thread_create_internal, 
	ves_icall_System_Threading_Thread_Thread_internal): Free 
	allocated memory on error.

2009-09-02  Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c, icall-def.h: Remove some dead code from early SRE changes.

2009-09-02  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_setup_fields): Remove duplicated local variable
	named gklass.
	Rename gklass to gtd to reflect the fact that it points to the generic
	type definition.
	Remove the duplicated call to mono_class_setup_fields on gtd and move
	the error check to the beginning.

2009-09-02  Rodrigo Kumpera  <rkumpera@novell.com>

	* marshal.c (mono_array_to_lparray): Do DISABLE_COM properly.
	Remove cruft of the previous patch.

2009-09-01  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_method_table): Check for abstract + final.
	Fixes #534175.

2009-09-01  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (verify_class_fields): Check for duplicate fields.

2009-09-01  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the typeref table for duplicates.

2009-09-01  Rodrigo Kumpera  <rkumpera@novell.com>

	This reverts r140936 and properly handles interfaces with static methods. The
	right fix is to ensure vtables without bubles which is an easier to verify
	constraint. We should avoid such special cases as of the reverted patch as those
	only make the runtime more brittle.

	* class.c (mono_class_setup_vtable_general): Revert previous change that handle
	static methods on interfaces.

	* class.c (setup_interface_offsets): Use the number of virtual methods when
	calculating interface offsets instead of the number of methods. This way we
	avoid bubles on the layout.

2009-08-31  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_metadata_header): Some very smart
	obfuscators like to add extra stream headers. Ignore them.

2009-08-30  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_setup_vtable_general): Verify interfaces with static
	methods correctly.

2009-08-29  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify for duplicated types.

2009-08-28  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_typedef_table): Verify for nested types
	without an entry on the nested class table.

2009-08-28  Zoltan Varga  <vargaz@gmail.com>

	* cominterop.c (cominterop_get_ccw): Applied patch from tom hindle
	<tom_hindle@sil.org>. Add locking around hash table accesses.

2009-08-25  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (mono_verifier_verify_class): Verify all interface if
	really are interfaces. Fixes #534184.

2009-08-27  Rodrigo Kumpera  <rkumpera@novell.com>

	* pedump.c: Initialize all types during metadata validation so we report
	errors only detected as part of class initialization.

2009-08-26  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_method_table): PInvoke requires method to
	be static. Fixes #534189

2009-08-26  Zoltan Varga  <vargaz@gmail.com>

	* threads.c (mono_thread_suspend_all_other_threads): Handle 'threads_starting_ip'
	being NULL.

2009-08-25  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_setup_vtable_general): Verify the resulting vtable
	for holes or bad methods. Fixes #525314.

2009-08-25  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (setup_interface_offsets): Don't allocate slot
	for the same interface multiple times. This creates bubbles
	that waster space and make vtable verification harder.

	The same interface get a slot multiple times since we need
	to get the closure of all implemented interfaces, which means
	the same interface is reported multiple times.

2009-08-25  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (mono_verifier_verify_class): Don't check the fields
	of generic instances since the context on which they got expanded
	might lead to false positives.

	Such thing happens when a generic type is inflated in the context
	of a generic method and the inflated type of a field turns into a
	generic method argument, which causes the checking code to think
	it's an invalid class when it's not.

2009-08-25  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (mono_type_is_valid_in_context): Verify if type
	is NULL and remove duplicate test.

2009-08-24  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (mono_verifier_verify_class): Check fields for
	invalid generic arguments.

2009-08-24  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (verify_class_overrides): Verify if for static
	and non virtual methods.

2009-08-24  Rodrigo Kumpera  <rkumpera@novell.com>

	* icaa.c (ves_icall_System_Runtime_CompilerServices_RuntimeHelpers_RunClassConstructor):
	Check for errors after retrieving the vtable.

2009-08-24  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_setup_vtable_general): Verify
	if method overrides are valid before processing them.

2009-08-24  Rodrigo Kumpera  <rkumpera@novell.com>

	* marshal.c (mono_array_to_lparray): Fix minimal build with
	cominterop disabled.

	* marshal.c (mono_free_lparray): Same.

2009-08-21  Mark Probst  <mark.probst@gmail.com>

	* threadpool.c (mono_thread_pool_init): Use mono_object_hash() as
	the hash function for the ares_htable.

2009-08-20  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_assembly_table): Accept 0x10 as a valid
	bit for assembly flags. MS is ok with it but there is no spec anywhere
	on its mean

2009-08-19  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_create_from_typedef): Emit profiler events
	in all cases.

2009-08-19  Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_Type_GetMethodsByName): Don't leak loader errors.
	Release memory on failure.

2009-08-19  Rodrigo Kumpera  <rkumpera@novell.com>

	* class-internals.h: Add mono_metadata_load_generic_param_constraints_full
	to the internal API.

	* metadata.c (get_constraints): Use a single-linked table as we don't
	traverse it backward. Fail and return FALSE if only of the contraint types
	is not found.

	* metadata.c (mono_metadata_load_generic_param_constraints_full): Identical
	to mono_metadata_load_generic_param_constraints except for having a return value.
	This has to be done since the later is part of the public API.

	* class.c (mono_class_create_from_typedef): Properly check the loading of constrains
	and fail the type.

	* loader.c (mono_get_method_from_token): Properly check the loading of constraints
	and fail the method.

2009-08-19  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (is_valid_method_header): Add work-around to deal
	with MS broken behavior of emmitting EH section sizes without the
	header size added.

2009-08-19  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata.c (mono_type_create_from_typespec): Don't allocate image
	memory until we're sure that we'll need it. This avoids leaking for
	broken types or duplicated instantiation.

2009-08-19  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (is_valid_method_header): Fix stupid formating
	mistake.

2009-08-19  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (is_valid_method_header): Fix number of clauses
	and expected size calculation.

2009-08-18  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_get_field_idx): Add fixme for broken
	behavior for types with multiple fields with the same name.
	I would rather fix it, but have no idea on how to generate
	such artifact for testing.

2009-08-18  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (verifier_load_field): We should allow references to
	fields to be made using the generic type definition. It's up to
	the loader system to fail invalid ops.

	* verify.c (get_boxable_mono_type): Only uninstantiated GTDs
	are invalid.

2009-08-18  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c: Fix usage of mono_metadata_interfaces_from_typedef_full.

	* metadata-internals.h: Fix declaration of 
	mono_metadata_interfaces_from_typedef_full.

	* metadata.c (mono_metadata_interfaces_from_typedef_full): Add extra
	heap_alloc_result parameter that controls if the result should be
	g_malloc'd.

	* metadata.c (mono_metadata_interfaces_from_typedef): Let the resulting
	array be g_malloc'd and properly document this public API function.

2009-08-18  Rodrigo Kumpera  <rkumpera@novell.com>

	* cil-coff.h: Fix METHOD_HEADER_FORMAT_MASK to be 2 bits and
	remove METHOD_HEADER_TINY_FORMAT1.

	* reflection.c: Remove reference to METHOD_HEADER_TINY_FORMAT1.

	* metadata.c (mono_metadata_parse_mh_full): Kill tiny format1.

	Both spec and MS uses only 2 bits to enumerate the kind of header.
	So given that 0x6 and 0x2 are equal under a 2 bits mask, tiny format1
	is superfluous, only used for tiny headers with odd code lengths.

	This change also make sure that mono doesn't wronly interpret bit 2
	of fat header flags, which is currently reserved.

2009-08-18  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata.c (do_mono_metadata_parse_type): Do error
	checking for element types. Don't abort if presented
	with a broken type kind.

2009-08-18  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata.c (mono_metadata_parse_method_signature_full):
	Gracefully fail bad vararg signatures.

2009-08-18  Christian Hergert  <chris@dronelabs.com>

	* profiler.c:
	* class.c: Fix warnings for uninitialized variables.

2009-08-18  Christian Hergert  <chris@dronelabs.com>

	* icall.c: Fix _NSGetEnviron method declaration warning.

2009-08-18  Christian Hergert  <chris@dronelabs.com>

	* icall.c:
	* reflection.c: Make bitwise checks explicit.

2009-08-18  Christian Hergert  <chris@dronelabs.com>

	* debug-helpers.c:
	* marshal.c: Fix printf warnings.

2009-08-18  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (encode_cattr_value): Fix a warning.

2009-08-17  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata.c (mono_metadata_parse_array_full): Fix memory leak
	of array bounds.

2009-08-17  Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (mono_method_signature): Don't assert on broken
	signature. Print a more useful error message.

2009-08-17  Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (mono_method_get_marshal_info): Assert if
	signature is invalid. Bounds check stores to the
	mspecs array;

2009-08-17  Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (field_from_memberref): Fix warning.

2009-08-17  Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (mono_method_get_param_names): Check if signature
	is null. Don't store beyond the size of the name array.

2009-08-17  Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (mono_get_method_constrained): Check if signature
	is null.

2009-08-17  Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (mono_loader_set_error_bad_image): Improve
	error messages.

2009-08-17  Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (mono_get_method_full): Convert an assertion
	into a loader error.

2009-08-17  Rodrigo Kumpera  <rkumpera@novell.com>

	* class-internals.h, class.c: Better naming and documentation.

2009-08-17  Zoltan Varga  <vargaz@gmail.com>

	* boehm-gc.c (mono_gc_add_weak_track_handle): Don't do any work if
	obj is NULL.

2009-08-14  Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (mono_method_get_signature_full): Fail gracefully if signature
	parsing fails.

2009-08-14  Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (mono_loader_error_prepare_exception): Handle missing field
	errors with no class set.

	* loader.c (field_from_memberref): If the field signature is of the wrong
	type fail with a MissingFieldException instead of a BadImageException as
	this is the behavior observed on MS. 

2009-08-14  Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (field_from_memberref): Don't crash if either the field
	signature or the typespec class are invalid.

2009-08-14  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (verifier_load_field): Don't allow field related
	ops to reference fields on generic type definition.

2009-08-14  Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Add new warning level for errors specified
	by ECMA 335 but that MS ignores.

	* metadata-verify.c (verify_method_table): Make compiler controled
	visibility + (rt)specialname error a warning as MS ignores this. Ignoring
	this check is safe because the end result will only be some visibility
	exceptions been thrown.

2009-08-14  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (get_boxable_mono_type): Don't allow the
	use of the generic type definition on boxed type positions.

	Fixes #531237.

2009-08-14  Mark Probst  <mark.probst@gmail.com>

	* threadpool.c: Make sure no cross-domain references remain in
	ares_htable or the arrays that are thrown away when resizing.

2009-08-14  Mark Probst  <mark.probst@gmail.com>

	* appdomain.c, metadata-internals.h, image.c: In MonoImage add a
	list of classes for which we have to unregister reflection_info
	with the GC and which are not in the namespace cache.

	* reflection.c (mono_reflection_initialize_generic_parameter): Add
	the class to the list.

2009-08-14  Mark Probst  <mark.probst@gmail.com>

	* domain.c (mono_domain_free): Unregister the GC roots in
	MonoDomain.

2009-08-12  Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (mono_reflection_type_get_handle): Fix typo.

2009-08-12  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c: Add mono_class_get_field_from_name_full which does
	the same as mono_class_get_field_from_name but does check field
	signature as well.

	* class-internals.h: Export mono_class_get_field_from_name_full as
	part of the internal API.

	* loader.c (field_from_memberref): Search fields by name and signature
	as it's valid to have two fields with same name but different types.

	Fixes #528055.

2009-08-10  Rodrigo Kumpera  <rkumpera@novell.com>

	* icall-def.h: Add a bunch of temporary icalls to MonoGenericClass.

	* reflection.c (mono_reflection_type_get_handle): Handle MonoGenericClass.

	* reflection.c (encode_cattr_value): Use mono_reflection_type_get_handle to encode
	System.Type.

2009-08-13  Zoltan Varga  <vargaz@gmail.com>

	* gc.c (GCHandle_CheckCurrentDomain): Moved this here from icall.c.

	* boehm-gc.c (mono_gc_add_weak_track_handle): Handle nulls.

2009-08-12  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, sgen-scan-object.h: Object scanning code factored out
	to sgen-scan-object.h, which can be included and parameterized via
	macros.

	* Makefile.am: sgen-scan-object.h added.

2009-08-12  Mark Probst  <mark.probst@gmail.com>

	* gc.c: #define GC_dont_gc if we're compiling with SGen.

2009-08-12  Mark Probst  <mark.probst@gmail.com>

	* domain.c (mono_domain_free): Free a domain's mono_g_hash_tables
	before clearing a domain in the GC.

2009-08-12  Mark Probst  <mark.probst@gmail.com>

	* exception.c (mono_exception_from_name_domain): Actually create
	the exception in the specified domain.

	* appdomain.c (mono_domain_create_appdomain_internal): Create the
	OutOfMemoryException a bit later so that the domain is inialized
	"enough" that it works.

2009-08-12  Mark Probst  <mark.probst@gmail.com>

	* threads.c (thread_cleanup): Clean up the cached_culture_info
	array to prevent cross-domain references.

Tue Aug 11 14:38:57 CEST 2009 Paolo Molaro <lupus@ximian.com>

	* metadata.c: more documentation for MonoType accessors.

2009-08-11  Raja R Harinath  <harinath@hurrynot.org>

	Fix incorrect size definitions where the tail array isn't a list
	of pointers
	* class-internals.h (MONO_SIZEOF_MARSHAL_TYPE): Use offsetof to
	define size.
	* domain-internals.h (MONO_SIZEOF_JIT_INFO): Likewise.
	* metadata.h (MONO_SIZEOF_TYPE): Likewise.
	* reflection.h (MONO_SIZEOF_CUSTOM_ATTR_INFO): Likewise.

2009-08-11 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* reflection.h:
	* reflection.c: MONO_SIZEOF_CUSTOM_ATTR_INFO.

2009-08-11 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* metadata.c:
	* loader.c:
	* metadata-internals.h:
	* method-builder.c:
	* reflection.c: use MONO_SIZEOF_METHOD_HEADER.

2009-08-11 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* cominterop.c:
	* metadata.c:
	* metadata.h:
	* loader.c:
	* marshal.c:
	* reflection.c: #define for sizeof in MonoType and
	MonoMethodSignature.

2009-08-11 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* domain.c:
	* domain-internals.h: add and use #define's instead of sizeof()
	for MonoJitInfo and MonoJitInfoTable.

2009-08-11 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* object.c:
	* class.h: use #define instead of sizeof() for MonoRemoteClass.

2009-08-10 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* metadata.c:
	* metadata.h:
	* object.c:
	* class-internals.h:
	* generic-sharing.c:
	* marshal.c: use a #define instead of sizeof() for a few
	structures that use a zero-length array.

2009-08-06  Rodrigo Kumpera  <rkumpera@novell.com>

	* object-internals.h (MonoReflectionMethodOnTypeBuilderInst): Add new fields
	to handle inflated generic methods.

	* appdomain.c: Bump corlib version.

	* reflection.c (mono_image_get_method_on_inst_token): Handle generic method
	instances.

	* reflection.c (fixup_method): Same

	* reflection.c (resolve_object): Same.

	* reflection.c (inflate_method): Replace a g_assert_not_reached with a
	g_error and a decent message.

2009-08-06  Massimiliano Mantione  <massi@ximian.com>

	* bohem-gc.c (mono_gc_add_weak_track_handle): Get the domain
	from the object because it could not yet be available globally
	(it happens if the profiler tries to create a gchandle on the
	MonoThread object of a thread that is still registering itself
	with the runtime).

2009-08-04  Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (mono_generic_class_get_object): Initialized the
	managed type arguments array.

	* object-internals.h (MonoReflectionGenericClass): Add type_arguments field.

	* appdomain.c: Bump corlib version.

2009-08-04  Zoltan Varga  <vargaz@gmail.com>

	* threads.c (thread_cleanup): Free serialized_ui_culture_info. Fixes
	#527902.

2009-08-03  Zoltan Varga  <vargaz@gmail.com>

	* threads.c (ves_icall_System_Threading_Thread_Thread_free_internal): 
	Avoid a crash if synch_cs is not set.
	
	* threads.c (ves_icall_System_Threading_Thread_Thread_free_internal): 
	Handle the case when the handle is 0.

	* appdomain.c: Bump corlib version.

2009-08-02  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (mono_type_get_object): Fix a warning.

2009-08-01  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c (mono_gc_wbarrier_value_copy): Don't compute the GC
	descriptor here.  We assume it's already been computed.

	* generic-sharing.c (instantiate_other_info): Compute the GC
	descriptor for info type MONO_RGCTX_INFO_KLASS.

2009-08-01  Mark Probst  <mark.probst@gmail.com>

	* reflection.c (mono_type_get_object): MonoDomain is an unmanaged
	type, so don't use MONO_OBJECT_SETREF to set a field.

2009-08-01  Mark Probst  <mark.probst@gmail.com>

	* gc.c: We were missing one case where invoking a finalizer would
	not reset the domain.  Also, in the finalizer thread loop, assert
	that we're in the root domain.

2009-07-31  Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_MonoType_GetArrayRank): Throw ArgumentException
	if the type is not an array.

2009-07-31  Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_MonoType_get_DeclaringMethod): Return the
	method bound to the declaring type of the method. Raise an exception
	if the type is not a generic param.

2009-07-31  Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (print_unimplemented_interface_method_info): Print the
	full type name.

	* class.c (mono_class_setup_vtable_general): When dealing with a
	generic instance first check if the generic type definition is
	not broken.

2009-02-11 Tom Hindke <tom_hindle@sil.org>

	* marshal.c (mono_array_to_lparray): Implemented so managed object types are converted to native types.

	* marshal.c: Added new method mono_free_lparray to free memory allocated by mono_array_to_lparray

	* marshal.c (emit_marshal_array): call emit mono_free_lparray where approprate.

	* marshal.c (conv_to_icall): added MONO_MARSHAL_FREE_LPARRAY case

	* metadata.h (MonoMarshalConv enum): added MONO_MARSHAL_FREE_LPARRAY

	Code is contributed under MIT/X11 license

2009-08-30  Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c: Fix naming of stelem and ldelem.

2009-07-30  Mark Probst  <mark.probst@gmail.com>

	* generic-sharing.c: Replace the templates lock with the loader
	lock because of very hard to resolve deadlock issues.

2009-07-30  Zoltan Varga  <vargaz@gmail.com>

	* icall.c (ves_icall_Type_GetMethodsByName): Use 
	mono_class_get_vtable_size () instead of accessing klass->vtable_size
	directly. Fixes #525338.

	* class.c (mono_class_get_vtable_size): New helper function.

	* icall.c (ves_icall_System_Reflection_FieldInfo_internal_from_handle_type): Fix the second argument, its a MonoType* not a MonoClass*. Check whenever
	the field belongs to the type. Fixes #525733.

2009-07-30  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: When we stop a thread and its stack top is not within
	its allocated stack (because it's in an altstack signal handler),
	restart it and stop it again, until it is.

2009-07-30  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Take a thread's stack top and registers from the
	sigcontext in the suspend signal handler.

	* sgen-gc.h, sgen-archdep.h, Makefile.am: Move arch-dependent
	stuff to sgen-archdep.h.

	* gc.c, gc-internal.h: Remove the get_ip_from_sigctx installer and
	caller, because have code in sgen-archdep.h to acquire that data.

2009-07-29  Massimiliano Mantione  <massi@ximian.com>

	* profiler.c, profiler.h, profiler-private.h:
	Added support for keeping track of code chunks and buffers.

2009-07-29 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Fix endianness problems on decoding functions.
	Based on a patch by Ulrich Weigand <uweigand@de.ibm.com>

2009-07-28 Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_Type_make_array_type): Handle the new encoding
	schema for vectors and one dimension SZARRAY.

2009-07-28 Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (mono_reflection_type_get_handle): Handle the new encoding
	schema for vectors and one dimension SZARRAY.

2009-07-27  Mark Probst  <mark.probst@gmail.com>

	* icall-def.h, thread-types.h, threads.c: New separate icalls for
	Interlocked.(Compare)Exchange with object arguments, which invoke
	write barriers.

2009-07-26  Miguel de Icaza  <miguel@novell.com>

	* icall.c (ves_icall_Type_GetNestedType): Throw an exception when
	passed invalid arguments.   Fixes another crasher in the
	Silverlight test suite.

	* class.c (mono_class_array_element_size): Return 0 for the size
	of the class;  This fixes the crasher exposed by :

	typeof (void).MakeArrayType ();

	* icall.c (ves_icall_MonoType_GetEvent): Do not dereference method
	if there is no method to dereference.    Put all the code that
	depends on this inside the if (method) block.

	This fixes the crasher exposed by Microsoft's Silvelright CLR test
	suite  ./Reflection/Emit/TypeBuilder/TypeBuilderGetEvent.exe

	With this change, we pass the test.
	
	* reflection.c (mono_reflection_sighelper_get_signature_local):
	Only dereference the assembly if it has been set.    Fixes a
	crasher exposed by #525328

2009-07-25  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, object.h, null-gc.c, boehm-gc.c, marshal.c: Really
	don't perform the store in mono_gc_wbarrier_generic_nostore().
	Remove the second argument (value), which is not needed.

2009-07-24  Zoltan Varga  <vargaz@gmail.com>

	* null-gc.c (mono_gc_wbarrier_generic_nostore): Define this to fix
	the build.

	* boehm-gc.c: Ditto.
	
2009-07-24  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c, marshal.c, object.h: Make the managed write barrier
	not perform the store itself.  Introduce
	mono_gc_wbarrier_generic_nostore(), which is the same as
	mono_gc_wbarrier_generic_store(), except it doesn't perform the
	store.

2009-07-24  Mark Probst  <mark.probst@gmail.com>

	* icall.c (ves_icall_System_Array_SetGenericValueImpl):
	mono_gc_wbarrier_value_copy() doesn't perform the copy itself, so
	we still need the memcpy().

2009-07-22  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Align array bounds calculation to mono_array_size_t
	so that big arrays are handled correctly.  Always use
	safe_object_get_size() to calculate array object sizes, which
	takes bounds into account.

2009-07-22  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c (mono_gc_wbarrier_value_copy): Make sure the class's
	GC descriptor is computed before we use it.

2009-07-22  Mark Probst  <mark.probst@gmail.com>

	* icall.c (ves_icall_System_Array_SetGenericValueImpl): Use a
	write barrier if necessary.

2009-07-22  Mark Probst  <mark.probst@gmail.com>

	* icall-def.h, icall.c, thread-types.h: New separate icall for
	VolatileWrite(object&,object) that uses a write barrier.

	* console-unix.c, file-io.c, icall.c, threads.c: Use write
	barriers in icalls which write to "ref" or "out" arguments.

2009-07-21  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_get_runtime_invoke): Do the work done in the exception
	handler in a separate icall, to reduce the size of the wrappers.

2009-07-20 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (is_valid_typespec_blob): Fix error message.

2009-07-20 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (parse_field): Allow byref field.

	* metadata-verify.c (parse_locals_signature): Allow byref locals.

	* metadata-verify.c (is_valid_typespec_blob): Allow byref typespec.

2009-07-20 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (do_cast): Fail for any non reference type that isn't boxed.
	Fixes #522784.

2009-07-20  Robert Jordan  <robertj@gmx.net>

	* cominterop.c (cominterop_get_managed_wrapper_adjusted):
	Fix invalid IL in valuetype handling (STOBJ must push the
	corresponding class). Fixes bug #523149.

	Code is contributed under MIT/X11 license.

2009-07-20  Geoff Norton  <gnorton@novell.com>

	* gc.c: Use proper semaphores where available on posix and darwin.

2009-07-19  Geoff Norton  <gnorton@novell.com>

	* gc.c: Unnamed posix semaphores are broken on darwin-arm too.

2009-07-19 Rodrigo Kumpera  <rkumpera@novell.com>

	* refletion.c (is_sre_usertype): Change name to is_usertype and
	invert it's result so it returns true if the type is an user type
	and not the opposite.

	* reflection.c (is_*_type): Change all of those to use new macro
	check_corlib_type_cached that cached the type lookup so we don't
	need to do string comparisons all the type. Changed the signature
	to take a MonoClass instead.

	* reflection.c: Change mono_image_create_token and resolve_object
	to use is_sre_* functions.

2009-07-18  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Check for writes to the stack in the managed
	wbarrier as well.

2009-07-18  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: When a thread is unregistered, don't free its remsets
	but put them on a list which is processed with the other thread's
	remsets.

2009-07-18  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Fix and enable the internal allocator instead of
	using malloc/free (which causes deadlocks).

2009-07-16 Rodrigo Kumpera  <rkumpera@novell.com>

	* refletion.c: Fix builds with SRE disabled by adding a minimal
	implementation of mono_reflection_type_get_handle.

2009-07-15 Rodrigo Kumpera  <rkumpera@novell.com>

	* refletion.c: Make mono_reflection_type_get_handle non static.

	* object-internals.h: Export mono_reflection_type_get_handle.

	* icall.c (ves_icall_MonoGenericClass_InflateType): Resolve the
	unmanaged handle using mono_reflection_type_get_handle.

2009-07-15 Rodrigo Kumpera  <rkumpera@novell.com>

	* refletion.c: Replace all reads of MonoReflectionType::type with
	calls to mono_reflection_type_get_handle. Only the functions that
	deal with constructing TypeBuilder::type have not been changed
	because they have to deal with NULL values.

	This is a first step into supporting reflection types that don't
	map directly into their unmanaged counterpart.

2009-07-14 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (parse_locals_signature): Don't complain
	on signature with zero locals since MS generates it and doesn't
	bother with.

2009-07-14 Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (mono_image_get_array_token): Resolve return
	type using mono_reflection_type_get_handle.

	* reflection.c (mono_image_get_array_token): Resolve array method
	parent type using mono_reflection_type_get_handle.

2009-07-14  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (mono_image_basic_init): Applied patch from
	<Dax@daxxfiles.net>. Set the public key token from the assembly
	builder. Fixes #518909.

	* appdomain.c: Bump corlib version.

2009-07-13  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_needs_cctor_run): Make this return false if
	the class has no cctor.

2009-07-13  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: When the minor GC needs to allocate a new section,
	invoke the major GC afterwards.

2009-07-14  Bill Holmes  <billholmes54@gmail.com>

	* process.c  (ves_icall_System_Diagnostics_Process_ShellExecuteEx_internal) :
	  Applying the window_style field to the SHELLEXECUTEINFO struct.

	Code is contributed under MIT/X11 license.

2009-07-13  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Fix the race condition in the unmanaged allocator by
	locking earlier.  Fix it in the managed allocator by making sure
	that no thread is stopped there before the GC runs.  If we do stop
	a thread there, we restart it and let it run a but, until it stops
	somewhere else.

	* gc-internal.h, gc.c: Function for getting the IP from a signal
	context via a function registered by mini.

2009-07-11  Zoltan Varga  <vargaz@gmail.com>

	* object-internals.h (MonoIntPtr): New structure describing a boxed
	IntPtr.

	* object.c (mono_runtime_invoke_array): Handle ptr arguments and
	returns. Fixes #519953.

	* marshal.c (mono_marshal_get_runtime_invoke): Handle pointer returns.

2009-07-09  Mark Probst  <mark.probst@gmail.com>

	* class-internals.h, generic-sharing.c: New RGCTX info type for
	getting a remoting invoke with check wrapper.

2009-07-07  Geoff Norton  <gnorton@novell.com>

	* icall-def.h: Fix the enable-minimal build.

2009-07-07 Rodrigo Kumpera  <rkumpera@novell.com>

	* object-internals.h: Add MonoReflectionDerivedType.

	* reflection.c: Implement support for PointerType.
	Fixed tons of warnings.

2009-07-07 Rodrigo Kumpera  <rkumpera@novell.com>

	* object-internals.h: Add MonoReflectionByRefType.

	* reflection.c: Implement support for ByRefType.

2009-07-07 Rodrigo Kumpera  <rkumpera@novell.com>

	* icall-def.h: Add System.Reflection.Emit.DerivedType::create_unmanaged_type.

	* object-internals.h: Add MonoReflectionArrayType and
	mono_reflection_create_unmanaged_type.

	* reflection.c: Implement support for ArrayType.

2009-07-07 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (is_valid_method_header): Parse EH block
	flags correctly.

2009-07-03  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c (finish_gray_stack): Set the to_space pointer after
	processing the disappearing links, and process disappearing links
	in a loop until no new objects are copied.

2009-07-03  Mark Probst  <mark.probst@gmail.com>

	* object.c (handle_enum): Invoke the write barrier when copying
	value type instances.

	* sgen-gc.c: Register remsets for unmanaged write barriers only
	when the address written to is actually on the heap.  This makes
	set_value() in object.c work without requiring that the result be
	on the heap.

2009-07-02 Rodrigo Kumpera  <rkumpera@novell.com>

	The runtime wrappers are all bound to a given type that must
	exist in the same image. For regular images we use the <Module>
	type, which is required to exist for all images.

	The <Module> type can't be used for dynamic images because it
	might not exist at the time the wrapper is required, so we create
	a synthetic type to use instead.

	The current code works because of the 2 stage setup of MonoClass,
	but once this is gone it will no longer work.

	* icall-def.h: Add ModuleBuilder::set_wrappers_type.

	* metadata-internals.h (MonoDynamicImage): Add wrappers_type.

	* object-internals.h: Export mono_image_set_wrappers_type icall
	as part of the internal API.

	* marshal.c (get_wrapper_target_class): If the image is dynamic,
	use MonoDynamicImage::wrappers_type instead of the <Module> type.

	reflection.c: Add mono_image_set_wrappers_type qhixh sets the dynamic
	image wrappers_type to the provided value.

2009-07-01 Rodrigo Kumpera  <rkumpera@novell.com>

	* appdomain.c (deregister_reflection_info_roots): No need
	to use the image lock here.

2009-07-02  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c (collect_nursery): Also scan from write-barrier roots.

2009-06-29  Zoltan Varga  <vargaz@gmail.com>

	* threads.c: Store the thread start argument in a hash table instead of
	registering it as a root, as libgc doesn't support unregistering roots
	under windows, leading to 'too many root sets' errors when many threads
	are created.

	* gc.c (mono_gc_run_finalize): Avoid finalizing dynamic methods during
	shutdown, they can still be referenced by the other dying objects.
	Fixes #514506.

2009-06-27 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* socket-io.c: DontLinger does not allow LingerOptions.

2009-06-26 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: The spec doesn't mention that it's possible to add
	custom attribute to a generic parameter. Fixed.

2009-06-26 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (inflate_generic_type): Don't crash while trying to output a message
	on why we're aborting.

2009-06-26 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* socket-io.c: DontLinger can take an int or a boolean too.

Fri Jun 26 17:00:04 CEST 2009 Paolo Molaro <lupus@ximian.com>

	* gc.c: check for a null argument to SuppressFinalize () and
	ReRegisterForFinalize ().

2009-06-26 Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (method_from_methodspec): Call into the verifier to check
	the signature.

	* metadata-verify.c: Addmono_verifier_verify_methodspec_signature.

	* verify-internals.h: Export mono_verifier_verify_methodspec_signature as
	part of the internal API.

2009-06-25 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata.c (mono_type_create_from_typespec): Call into the verifier to check
	the signature.

	* metadata-verify.c: Add mono_verifier_verify_typespec_signature.

	* verify-internals.h: Export mono_verifier_verify_typespec_signature as
	part of the internal API.

2009-06-25 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata.c (mono_metadata_parse_mh_full): Call into the verifier to check
	the signature.

	* metadata-verify.c: Add mono_verifier_verify_standalone_signature. Fix
	blob verification.

	* verify-internals.h: Export mono_verifier_verify_memberref_signature as
	part of the internal API.

2009-06-25 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Use is_valid_blob_object to verify blob validity
	when doing basic verification. 

	This check must be done since the runtime peeks into signatures in much
	more places than it does decoding so it makes sense to ensure that all
	pointers to blob objects are well formed.

2009-06-25 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (is_valid_blob_object): Add extra minsize argument.
	Use proper overflow dectection. Fix usage of it.

2009-06-25 Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (field_from_memberref): Call into the verifier to check
	the signature.

	* loader.c (mono_method_get_signature_full): Same.

	* loader.c (method_from_memberref): Same.

	* metadata-verify.c: Add mono_verifier_verify_memberref_signature.

	* verify-internals.h: Export mono_verifier_verify_memberref_signature as
	part of the internal API.

2009-06-25  Mark Probst  <mark.probst@gmail.com>

	* threadpool.c (mono_thread_pool_add): If the domain is unloading
	or unloaded, still return an AsyncResult, but don't add it to the
	threadpool.

2009-06-25 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* threads.c: fix missing colon when DEBUG is defined.

2009-06-25  Mark Probst  <mark.probst@gmail.com>

	* threadpool.c: Don't add new calls to a threadpool if the domain
	of the call is unloading or unloaded.  When dequeuing a job, null
	the reference in the queue.

2009-06-25  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c (null_link_in_range): Add the dislink for the old
	generation if an object was moved.

2009-06-25  Sylvain Dupont <duposyl@gmail.com>

	* cominterop.h cominterop.c marshal.c: Added support for marshalling out 
	  parameters of type SAFEARRAY[VARIANT].

	* reflection.c (encode_marshal_blob): Properly generate element type
	  (SafeArraySubType marshal attribute option).

	Code is contributed under MIT/X11 license.

Thu Jun 25 15:48:09 CEST 2009 Paolo Molaro <lupus@ximian.com>

	* reflection.c: in mono_method_clear_object () really ensure all the
	objects are removed.

2009-06-24 Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (mono_method_signature): Call into the verifier to check
	the method signature.

	* metadata-verify.c (verify_method_table): Move signature verification
	to verify_method_table_full.

	* metadata-verify.c: Add mono_verifier_verify_method_signature.

	* verify-internals.h: Export mono_verifier_verify_method_signature as
	part of the internal API.

2009-06-24 Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (mono_method_get_header): Call into the verifier to
	check the method header.

	* metadata-verify.c: Add mono_verifier_verify_method_header.

	* verify-internals.h: Export mono_verifier_verify_method_header as
	part of the internal API.

2009-06-24 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_find_enum_basetype): Call into the verifier to
	check the field signature. Replace an assert with an explicit check.

	* class.c (mono_class_setup_fields): Call into the verifier to check
	the field signature.

	* metadata-verify.c: Add mono_verifier_verify_field_signature.

	* verify-internals.h: Export mono_verifier_verify_field_signature as
	part of the internal API.

2009-06-24 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_find_enum_basetype): Simplify this function
	by moving code outside of the loop and not decoding static fields.

2009-06-24 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_typedef_table): Check the extends
	token here. Move to here a flags check from verify_typedef_table_full.

2009-06-24  Zoltan Varga  <vargaz@gmail.com>

	* metadata-verify.c (is_valid_method_header): Fix a warning.

	* metadata-internals.h (MonoImage): Remove the unused 
	static_rgctx_invoke_wrapper_cache.

	* image.c marshal.c: Ditto.

2009-06-23 Rodrigo Kumpera  <rkumpera@novell.com>

	* image.c (do_mono_image_load): Enable table data verification.

2009-06-23 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (is_valid_constant): Fix nullref check.

2009-06-23 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (is_valid_constant): Fix string bounds check.

2009-06-22  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Managed allocation with pthreads TLS.

	* threads.c, threads-types.h: Functions for the JIT to tell the
	runtime whether it supports the MONO_TLS opcode.

2009-06-22 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_param_table): Fix a crash for assemblies
	without methods.

2009-06-22 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (is_valid_constant): Fix the string length check.
	Use safe overflow checking. Add decent error messages.

2009-06-22 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Move remaininh blob checks to the offline
	verification path.

2009-06-22 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Move more blob checks to the offline verification
	path.

2009-06-22  Bill Holmes  <billholmes54@gmail.com>

	* object-internals.h : Adding interrupt_on_stop field.

	* threads.c (mono_thread_request_interruption) : On Windows exit the
	  thread if interrupt_on_stop is set.

	* socket-io.c (ves_icall_System_Net_Sockets_Socket_Accept_internal) :
	 Removing old interrupt logic and setting the interrupt_on_stop for the
	 thread when calling accept.

	* socket-io.c (ves_icall_System_Net_Sockets_Socket_Receive_internal) :
	 setting the interrupt_on_stop for the thread when calling accept.

	Contributed under MIT/X11 license.

2009-06-20  Martin Baulig  <martin@ximian.com>

	* mono-debug.h (MONO_DEBUGGER_MINOR_VERSION): Bump to 3.

2009-06-21  Zoltan Varga  <vargaz@gmail.com>

	* appdomain.c (mono_try_assembly_resolve): Don't call managed code when
	running in no-exec mode.

2009-06-19 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_method_table): Move header
	checking to verify_method_table_full.

	* metata-verify.c (mono_verifier_verify_full_table_data):
	Call verify_method_table_full.

2009-06-19 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_field_table): Move signature
	checking to verify_field_table_full.

	* metata-verify.c (mono_verifier_verify_full_table_data):
	Call verify_field_table_full.

2009-06-19 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_typedef_table): Move remaining
	stuff to verify_typedef_table_full.

2009-06-19 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Kill is_corlib from VerifyContext.
	It is only used by the offline mode.
	So we better remove it from the runtime path.

2009-06-19 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Add new mono_verifier_verify_full_table_data
	function that perform the offline metadata verification steps.

	* metadata-verify.c (verify_typedef_table): Move some checks to
	verify_typedef_table_full and make it been called by new function
	mono_verifier_verify_full_table_data.

	* pedump.c: Call mono_verifier_verify_full_table_data.

	* verify-internals.h: Export mono_verifier_verify_full_table_data as
	part of the internal API.

2009-06-19 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (typedef_is_system_object): Fix System.Object
	check.

	* metadata-verify.c (verify_implmap_table): Fix implmap invalid
	flags bits. SupportLastError was confused as bit 7 instead of 6.

	* metadata-verify.c (verify_implmap_table): Fix import scope verification
	to check against the module ref table instead of module.

	* metadata-verify.c (verify_implmap_table): Fix corlib check.

	* pedump.c: Call mono_image_load_names.

2009-06-19 Rodrigo Kumpera  <rkumpera@novell.com>

	* image.c: Extract mono_image_load_names from do_mono_image_load.

	* metadata-internals.h: Export mono_image_load_names as part of
	the internal API.
	
2009-06-19  Zoltan Varga  <vargaz@gmail.com>

	* metadata.c (mono_metadata_cleanup): Free the generic method cache
	first, as it could reference data in the other caches.

2009-06-18 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Finished with method header verification.

2009-06-18 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Added more header verification code.
	Now only EH clauses are missing.

2009-06-17  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (get_runtime_invoke_type): Don't share primitive types
	for return values.

2009-06-16 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Initial method header verification.

2009-06-16 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_import_table): The IAT contents
	might end been patched by the windows DL when running with
	coree enabled.

2009-06-15 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_from_typeref): If the enclosing type is not
	found return null instead of crashing. Fixes #508487.

2009-06-15  Atsushi Enomoto  <atsushi@ximian.com>

	* normalization-tables.h : updated to the latest unicode charcter
	  data.
	* appdomain.c : bump corlib version.

2009-06-14  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_from_name): Fix support for assembly references
	in the EXPORTEDTYPE table. Fixes #511704.

2009-06-13  Geoff Norton  <gnorton@novell.com>

	* domain.c: Ensure that mono_domain_assembly_open actually opens the
	assembly in the target domain.

2009-06-12  Robert Jordan  <robertj@gmx.net>

	* cominterop.c (cominterop_get_ccw): Increment mspec's SizeParamIndex
	because "this" of the managed signature has become an
	ordinary parameter in the unmanaged signature.

2009-06-12  Zoltan Varga  <vargaz@gmail.com>

	* class-internals.h (struct _MonoGenericContainer): Add an 'image'
	field for owner-less generic containers.

	* reflection.c (mono_reflection_initialize_generic_parameter): Set the
	image field of the owner-less generic containers created here.

	* metadata.c (mono_metadata_load_generic_params): Ditto, the
	contain is ownerless until the caller sets its owner.

	* metadata.c (type_in_image): Handle owner-less generic containers
	correctly.
	
2009-06-11  Zoltan Varga  <vargaz@gmail.com>

	* image.c (mono_image_close): Support debug_assembly_unload for
	dynamic images too.

2009-06-11 Andrés G. Aragoneses  <aaragoneses@novell.com>

	* class.c: Fix some typos in comments.

2009-06-11  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (add_custom_modifiers): Avoid reading invalid memory.

	* threads.c (mono_thread_execute_interruption): Avoid creating the
	abort exception object while holding the synch_cs lock.

2009-06-10 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify basic cattr content.

2009-06-10  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (add_exported_type): Don't set the FORWARDER flag on
	nested types.
	
	* reflection.c (mono_image_fill_export_table_from_type_forwarders): Add
	support for nested types. Fixes #511704.

2009-06-09 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify methodspec signatures.

2009-06-09 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify typespec signatures.

2009-06-09  Zoltan Varga  <vargaz@gmail.com>

	* metadata.c (free_inflated_method): Call 
	mono_marshal_free_inflated_wrappers (), which was missed earlier.

2009-06-08  Miguel de Icaza  <miguel@novell.com>

	* mono-config.c: Small change to report the PPC64/ILP32 model.

2009-06-05 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (parse_type): Check szarray.

2009-06-05 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (parse_type): Check fnptr.

2009-06-05 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (parse_type): Check generic instances.

2009-06-05 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (parse_type): Check array shape.

2009-06-05  Robert Jordan  <robertj@gmx.net>

	* class.c (mono_class_create_from_typedef): Check only for
	mscorlib's System.Array.

2009-06-04 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (parse_type): Check pointer, class/valuetype
	and generic params. 

	* metadata-verify.c (parse_field): Check the signature.

2009-06-04 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Implement locals signature check.

2009-06-04  Marek Safar  <marek.safar@gmail.com>

	* domain.c: Add .NET 4.0 Beta 1 version.

2009-06-04  Bill Holmes  <billholmes54@gmail.com>

	* cominterop.c (cominterop_ccw_queryinterface): Fix for bug 499566.
	  For QueryInterface on CCWs consider the base class
	  interfaces as well.

	Code is contributed under MIT/X11 license.

2009-06-04  Zoltan Varga  <vargaz@gmail.com>

	* wrapper-types.h: Delete STATIC_RGCTX_INVOKE.

	* marshal.c (mono_marshal_ret_static_rgctx_invoke): Remove, no longer
	used.

	* icall.c (ves_icall_System_Delegate_CreateDelegate_internal): Avoid
	adding a static-rgctx invoke wrapper, it is done by the runtime trampolines.

	* generic-sharing.c (inflate_other_data): Ditto.
	
2009-06-03 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Implement property signature check.

2009-06-04  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.h: Register saving support for PPC.

2009-06-04  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Fixed a pthread TLS screwup.

2009-06-04  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Do TLS using pthread API if __thread keyword is not
	supported.

2009-06-04  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Disable TLA and managed allocation if the __thread
	keyword is not supported.

2009-06-04  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c metadata.c: Applied patch from Ulrich Weigand 
	<uweigand@de.ibm.com>: Free the wrappers of inflated generic methods when
	the inflated method is freed. Fixes #508389.

	The code is contributed under the MIT/X11 license.
	
2009-06-03  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (get_wrapper_target_class): New helper function.
	(mono_marshal_get_runtime_invoke): Place runtime-invoke wrappers into
	the <Module> class of the image. Fixes #509049.

2009-06-01 Rodrigo Kumpera  <rkumpera@novell.com>

	* threads.c (ves_icall_System_Threading_Thread_Sleep_internal):
	Check if the thread was interrupted and proccess it straight away.
	Makes abortion much more responsive.

2009-06-01 Rodrigo Kumpera  <rkumpera@novell.com>

	* threads.c (mono_thread_execute_interruption): Use atomic cas with
	MonoThread::interruption_requested to match it's counterpart.

	Fixes a hang in abort-stress-1 on a 2 core x86.

	* threads.c (ves_icall_System_Threading_Thread_GetAbortExceptionState):
	Fix warning.

2009-06-01 Rodrigo Kumpera  <rkumpera@novell.com>

	Change MonoImage::name_cache to be protected by the image lock
	instead of the loader lock.

	* appdomain.c (deregister_reflection_info_roots): Protect access
	to name_cache.

	* class.c (mono_image_init_name_cache): Change from the loader lock
	to the image lock. Check if the cache wasn't already created.

	* class.c: Change from the loader to the image lock.

	* icall.c (ves_icall_System_Reflection_Assembly_GetNamespaces): Fix
	the code to hold the image lock while iterating over name_cache and
	not go into mono_array_new holding it.

	* metadata-internals.h: Add a comment about this change.

2009-06-01 Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_System_Reflection_Assembly_InternalGetType):
	Under the 2.0 profile raise the loader error.

	Fixes #508532.

2009-06-01 Rodrigo Kumpera  <rkumpera@novell.com>

	* marshal.c (mono_marshal_get_runtime_invoke): Emit the right kind
	of ldind opcode for generic instances so we don't fail for direct wrappers.
	This only affect direct calls.

2009-05-31  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (create_dynamic_mono_image): Fix warnings.

	* generic-sharing.c (other_info_equal): Ditto.
	
2009-05-29 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Implement field signature check.

2009-05-29 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Implement standalone signature check.

2009-05-28 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Implement methodref signature check.

2009-05-28  Zoltan Varga  <vargaz@gmail.com>

	* object-internals.h (MonoRuntimeCallbacks): New structure containing
	callbacks supplied by the runtime.

	* object.c (mono_install_callbacks): New internal function to install
	the callbacks.

	* object.c (mono_create_ftnptr): Move the implementation of this to
	mini/.

	* object.c (mono_get_addr_from_ftnptr): Ditto.	

2009-05-27 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (parse_return_type): Proper byref check.
	* metadata-verify.c (is_valid_method_signature): Check for zero arity
	generic signatures and method params.

2009-05-27 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (decode_signature_header): Fix bounds check.

	* metadata-verify.c (parse_custom_mods): Check custom mods.

	* metadata-verify.c (parse_type): Do initial basic verification
	of valid values.
	
	* metadata-verify.c (is_valid_method_signature): Parse the generic
	param count.

2009-05-26 Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_Type_GetMethodsByName): Virtual methods should be
	discarded based on their most specific definition so we set the method_slots
	array before checking if the method is acceptable or not.

	Fixes #506757.

2009-05-26  Mark Probst  <mark.probst@gmail.com>

	* icall.c: Free the old array when resizing a mono_ptr_array.

2009-05-26  Mark Probst  <mark.probst@gmail.com>

	* reflection.c (create_dynamic_mono_image): Use mono_object_hash()
	for the hashes whose keys are managed objects.

2009-05-26  Mark Probst  <mark.probst@gmail.com>

	* object-internals.h, threads.c: Set the execution context on
	thread start here, not in corlib.

	* appdomain.c: Bump corlib version.

2009-05-27  Martin Baulig  <martin@ximian.com>

	* mono-debug.c (mono_debug_init): Use `MONO_DEBUG_FORMAT_DEBUGGER'
	if `_mono_debug_using_mono_debugger' is set to make things work
	properly when embedding Mono.

2009-05-25 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_class_setup_fields): Don't mark simd types as having
	16 bytes alignment as the whole runtime doesn't support.

2009-05-25 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (safe_read): Use endian safe read macros.

2009-05-25  Zoltan Varga  <vargaz@gmail.com>

	* object.c (mono_create_ftnptr): Don't allocate from the code mempool since
	it is read-only when using full aot.

2009-05-22 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (is_valid_method_signature): Verify parts
	of the return type. Provide an error message in case of failure.

2009-05-22 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (is_valid_method_signature): Verify the call conv.

2009-05-22 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Include the size prefix in the bounds check.

2009-05-22  Miguel de Icaza  <miguel@novell.com>

	* icall.c: Remove warnings.

	* mono-config.c: Allow for CONFIG_CPU to be set in config.h and
	prevent auto-detection based on GCC defines.

	Add PS3

	* metadata-verify.c: Do not include signal.h

	* generic-sharing.c, marshal.c: Add returns to avoid some warning
	messages.  Not sure why the g_assert_not_reached is not enough to
	quiet the compiler.
	

	* appdomain.c: Remove code that is not used when
	DISABLE_SHADOW_COPY is set.

	* image.c: use g_getenv

2009-05-21  Miguel de Icaza  <miguel@novell.com>

	* reflection.c: Remove code that it not used with
	DISABLE_REFLECTION_EMIT is defined.

2009-05-21  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_get_runtime_invoke): Share more runtime
	invoke wrappers.

2009-05-20  Miguel de Icaza  <miguel@novell.com>

	* socket-io.c
	(ves_icall_System_Net_Sockets_Socket_Available_internal): Remove
	the ifdef here and instead put that on io-layer

2009-05-19 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the generic param constraint table.

2009-05-19 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_generic_param_table): Fix
	thinko on the valid flags bits for generic params.

2009-05-19 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the methodspec table.

2009-05-19 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the generic param table.

2009-05-19  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Store and use the count with REMSET_VTYPE.

2009-05-19  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Use generation enum more consistently and use the
	correct generation in mono_gc_register_for_finalization().

2009-05-18 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the nested class table.

2009-05-18 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the manifest resource table.

2009-05-17  Zoltan Varga  <vargaz@gmail.com>

	* debug-helpers.c (dis_one): Add little-endian support for ldstr.

2009-05-16  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_get_vtable_entry): Avoid adding static-rgctx
	wrappers, this is now done in the JIT.
	
	* class.c (mono_set_generic_sharing_supported): New internal function.
	(mono_class_generic_sharing_enabled): Move the #ifdef stuff to the JIT.

2009-05-15 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the exported type table.

2009-05-15 Rodrigo Kumpera  <rkumpera@novell.com>

	* pedump.c (main): Fake an assembly for netmodules to make the verifier happy.

2009-05-15 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the file table.

2009-05-15 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_assembly_table): Fix an error message.

	* metadata-verify.c: Verify the assemblyref table.

2009-05-15 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_assembly_table): Fix the valid
	bits mask for flags.

2009-05-15  Zoltan Varga  <vargaz@gmail.com>

	* debug-helpers.c (mono_method_full_name): Print generic parameters of
	generic methods as well.

2009-05-15  Geoff Norton  <gnorton@novell.com>

	* gc.c: MachO/Darwin supports and uses semaphores fine for this 
	use-case and is significantly more performant than the wapi layer.

2009-05-13 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the assembly table.

2009-05-13 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Fix rows limit check.

2009-05-13 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the fieldrva table.

2009-05-13  Mark Probst  <mark.probst@gmail.com>

	* sgen.c: Speed up weak links and finalizers by grouping them by
	generation.

2009-05-13  Mark Probst  <mark.probst@gmail.com>

	* marshal.c (delegate_hash_table_add): When overwriting an entry,
	free the old GCHandle (only applies to SGen).

2009-05-13  Zoltan Varga  <vargaz@gmail.com>

	* loader.c (mono_get_method_from_token): Avoid the expensive call to
	mono_metadata_load_generic_params () for non-generic methods.

2009-05-12  Mark Probst  <mark.probst@gmail.com>

	* monitor.c, monitor.h (mono_monitor_get_object_monitor_weak_link):
	New function for returning a monitor's weak link if it has one.

	* sgen-gc.c: Remove an object's monitor's weak link (if it has
	one) when clearing a domain.  These can still be around because
	the object might not have been collected.

2009-05-12  Zoltan Varga  <vargaz@gmail.com>

	* gc.c: Fix a warning.

2009-05-12  Kornél Pál  <kornelpal@gmail.com>

	* gc.c (mono_gc_init): Set gc_thread on creation. This avoids the
	prevous wait that resulted in a deadlock on Windows when initializing
	the runtime form DllMain. Also results in improved startup time.
	(finalizer_thread): Get rid of thread_started_event.
	* threads.c, threads-types.h (mono_thread_create_internal): Return the
	resulting MonoThread.

	Contributed under MIT/X11 license.

2009-05-11 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the implmap table.
	Don't require that #US and #Strings be present.

2009-05-11  Sebastien Pouliot  <sebastien@ximian.com>

	* security-core-clr.c: Delegate checks are done at creation time,
	not a invocation time. Fix exception for Telerik Silverlight demo

2009-05-11  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c (need_remove_object_for_domain): Remove the special
	case for the Thread class.

	* threads.c: Do clean-up of abort exception/state in
	thread_cleanup() instead of Thread.free_internal().  Also clean up
	current_appcontext.  The reason we have to do that is because
	those references might point into another domain and if that
	domain is unloaded before the thread is finalized, they point to
	invalid data.

2009-05-10  Andreas Faerber  <andreas.faerber@web.de>

	* null-gc.c (mono_gc_weak_link_add, mono_gc_clear_domain): Fix
	stub signatures.
	
	Contributed unter MIT/X11 license.

2009-05-09  Miguel de Icaza  <miguel@novell.com>

	* verify.c, metadata-verifier.c: Add support for disabling the
	verifier in some builds.

	[ Sorry, my previous commit accidentally commited some work in
	progress ]

2009-05-08  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_setup_fields): Set class->field.first for
	generic instances.

2009-05-07 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the typespec table.

2009-05-07 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the module table.

2009-05-06 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the methodimpl table.

2009-05-06 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the property table.

2009-05-06  Zoltan Varga  <vargaz@gmail.com>

	* debug-helpers.c (mono_method_desc_match): Add support for generic
	glob patterns.

2009-05-05 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the propertymap table.

2009-05-04 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the event table.

	* metadata-verify.c (search_sorted_table): Fix offset
	calculation.

2009-05-02  Zoltan Varga  <vargaz@gmail.com>

	* domain-internals.h (struct _MonoJitInfo): Add a 'from_llvm' flag.

2009-05-01  Mark Probst  <mark.probst@gmail.com>

	* gc.c (mono_gc_run_finalize): Don't set the domain too late,
	because mono_delegate_free_ftnptr() needs it.

2009-04-30 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the eventmap table.

2009-04-30 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the standalonesig table.

2009-04-30 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the field layout table.

2009-04-30 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (mono_type_get_name_recurse): Don't crash
	for ownerless generic params.

	* debug-helpers.c (mono_type_get_desc): Correct the format
	for ownerless generic params.

2009-04-30 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the class layout table.

2009-04-30 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the decl security table.

2009-04-30  Mark Probst  <mark.probst@gmail.com>

	* domain.c (mono_domain_set_internal_with_options): Don't do
	anything if the old domain is the same as the old one.  Fixes
	#499326.

2009-04-30  Mark Probst  <mark.probst@gmail.com>

	* appdomain.c: Deregister the reflection_info roots when unloading
	a domain.

	* sgen-gc.c, domain.c, gc-internal.h: mono_gc_clear_domain() nulls
	memory allocated by a domain and frees its disappearing links.

	* boehm-gc.c, null-gc.c: Empty implementation of
	mono_gc_clear_domain().

2009-04-30  Mark Probst  <mark.probst@gmail.com>

	* appdomain.c (clear_cached_vtable): Free the static fields memory
	block.

2009-04-30  Mark Probst  <mark.probst@gmail.com>

	* gc.c: Set the correct domain when invoking finalizers.

	* appdomain.c: Set the correct domain when creating threads.

2009-04-30  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Fix skip size for vectors.

2009-05-03  Martin Baulig  <martin@ximian.com>

	* mono-debug-debugger.c
	(mono_debugger_check_breakpoints): Check class init handlers even
	if we don't have any method load handers.

2009-04-30  Zoltan Varga  <vargaz@gmail.com>

	* appdomain.c (ves_icall_System_AppDomain_GetAssemblies): Avoid 
	returning refonly assemblies if refonly is FALSE. Fixes #499013.

2009-04-29 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the field marshal table.

2009-04-29 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the custom attribute table.

2009-04-28 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the constant table.

2009-04-28 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the memberef table.

2009-04-28 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (get_coded_index_token): Remove
	dead argument.

2009-04-28 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the interfaceimpl table.

2009-04-28 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c: Improve error message.

	* debug-helpers.c (mono_type_get_desc): Harden the code that
	deals with VAR and MVAR.

2009-04-28  Zoltan Varga  <vargaz@gmail.com>

	* image.c (mono_image_fixup_vtable): Avoid casting an lvalue. Fixes 
	part of #498692.

2009-04-23 Tom Hindle <tom_hindle@sil.org>

	* cominterop.c (ves_icall_System_Runtime_InteropServices_Marshal_ReleaseComObjectInternal):
	changed to match .Net behaviour of not aborting on additional calls to ReleaseComObject.

2009-04-28  Sebastien Pouliot  <sebastien@ximian.com>

	* security-core-clr.c: Avoid redundant checks for platform code, 
	e.g. check for method and for class (very common) and check
	for class and outer class (less common)...

2009-04-27  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c: Avoid returning random cattrs for synthetic methods.
	Fixes #498545.

2009-04-27 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* assembly.c: assemblies in the GAC should never be shadow-copied.

2009-04-26  Mark Probst  <mark.probst@gmail.com>

	* domain.c, domain-internals.h: Disable
	track_resurrection_{objects,handles}_hash in MonoDomain if using
	SGen.

2009-04-24 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the param table.

2009-04-24 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_typedef_table): Range check FieldList and
	MethodList.

	* metadata-verify.c (verify_method_table): Proper check the ParamList
	field.

2009-04-24 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_method_table): Check for runtime
	implemented functions such as delegate .ctors. Remove spurious
	printf.
	
2009-04-24 Rodrigo Kumpera  <rkumpera@novell.com>

	* pedump.c: Proper initialize the runtime forcing the 2.0 profile.

2009-04-24  Raja R Harinath  <harinath@hurrynot.org>

	Don't allocate MonoGenericInfo for ownerless generic params.
	* class-internals.h (MonoGenericParam::info): Move field to ...
	(MonoGenericParamFull): ... this.  New struct.
	(MonoGenericContainer::type_params): Change type to
	MonoGenericParamFull.
	(MonoGenericParam, MonoGenericContainer): Update accessors.
	* metadata.c (mono_metadata_parse_generic_param): Don't initialize
	'info' field for ownerless generic param.
	(mono_metadata_load_generic_params): Update to changes.
	* reflection.c (mono_reflection_create_generic_class): Likewise.
	(reflection_methodbuilder_to_mono_method): Likewise.
	(mono_reflection_initialize_generic_parameter): Likewise.

2009-04-24  Raja R Harinath  <harinath@hurrynot.org>

	Don't use MonoGenericParamInfo for ownerless generic params.
	* class.c (get_anon_gparam_class, set_anon_gparam_class): New.  Don't
	use ParamInfo class at all.
	(mono_class_from_generic_parameter): Use them.
	(make_generic_param_class): Fix a couple of instances where 'pinfo
	== NULL' wasn't handle.

2009-04-24  Raja R Harinath  <harinath@hurrynot.org>

	* class.c (make_generic_param_class): Carve out of ...
	(mono_class_from_generic_parameter): ... here.

2009-04-24  Raja R Harinath  <harinath@hurrynot.org>

	Simplify mono_class_from_generic_parameter
	* class-internals.h (MonoGenericParamInfo::token): New field.
	* metadata.c (mono_metadata_load_generic_params): Initialize it
	from metadata.
	* class.c (mono_class_from_generic_parameter): Use it instead of
	searching through metadata.

2009-04-23 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Add verification of the method table.

2009-04-23 Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_Type_GetMethodsByName): Fix memleak for the
	Delegate::Invoke optimization.

2009-04-23 Rodrigo Kumpera  <rkumpera@novell.com>

	* appdomain.c (mono_domain_create_appdomain_internal): Free the
	string returned by get_shadow_assembly_location_base.

	* appdomain.c (get_shadow_assembly_location_base): Add a comment
	about caller's ownership.

2009-04-23 Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c: Add mono_reflection_cleanup_domain to cleanup
	reflection memory on domain unload.

	* domain.c (mono_domain_free): Don't free refobject_hash, let the
	reflection cleanup code do it.

	* domain-internals.h: Add mono_reflection_cleanup_domain.

	This fixes a memory leak for managed mirrors of reflection objects
	on domain unload. 

2009-04-22 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Implement more verification of the field table.

2009-04-22 Rodrigo Kumpera  <rkumpera@novell.com>

	* pedump.c (main): Init mono with mscorlib so it defaults to 2.0 and
	doesn't try to parse the input assembly, which can be broken.

2009-04-23  Mark Probst  <mark.probst@gmail.com>

	* boehm-gc.c, gc-internal.h, gc.c, monitor.c, null-gc.c,
	sgen-gc.c: Implement track resurrection in weak GC handles in SGen
	by using the lowest bit in the link to store whether the link is
	tracked.  Move the track_resurrection hashes into boehm-gc.c.

2009-04-22  Miguel de Icaza  <miguel@novell.com>

	* Makefile.am: Split the console support in platform specific code
	and put together a framework for making this easy in the future so
	that we can start splitting code instead of having a mess of PLATFORM_WIN32

2009-04-21 Rodrigo Kumpera  <rkumpera@novell.com>

	* pedump.c: Fix a warning.

2009-04-21 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (mono_delegate_type_equal): Compare valuetypes using
	mono_class_from_mono_type to avoid bad interactions with the dual representation
	of the generic type definition.

2009-04-21 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (do_invoke_method): Use mono_class_from_mono_type to
	get the MonoClass for the call context type as it might be a generic
	instance.

	Fixes #491483.

2009-04-21  Mark Probst  <mark.probst@gmail.com>

	* object-internals.h: The Thread object has no execution_context
	member anymore.

	* threads.c, threadpool.c, threads-types.h: Accessor functions for
	the execution context.

	* appdomain.c: Bump corlib version.

2009-04-20 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (do_newobj): Improve error message.

2009-04-20 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (verify_clause_relationship): Only mask as an error if the exception clause
	is nested in the filter block.

	* verify.c (verify_clause_relationship): The disjoint check must verify if the exception
	block is not fully nested.

	Fixes #495656.

2009-04-20 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (verify_type_compatibility_full): Compare MonoClass and
	not MonoType to check for equality of valuetypes as the generic type
	definition allows for two different encodings: the generic type definition
	class or a generic instance over the GTD arguments.

	Fixes #496175.

2009-04-20 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (dump_stack_value): Fix compilation with extra debug turned on.

	* verify.c (do_initobj): Improve error message.

2009-04-20 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Enable pe verification as the issue with #496453
	is that the authenticode data directory have a different unspecified
	format. Ignore it for now.

	* pedump.c: Run the metadata verifier together with the IL verifier.

	Fixes ##496453.

2009-04-20  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* metadata-verify.c: Temporarily disable pe verification due to #496453.

2009-04-17 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (can_access_type): Check visibility against
	the element type for pointers and arrays.

	Fixes #496150.

2009-04-17 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Fix cli and table verification to use information
	from the MonoImage. A lot of duplicated code got killed.

2009-04-17 Rodrigo Kumpera  <rkumpera@novell.com>


	This patch starts to integrate the metadata verifier with the runtime code.

	This patch causes major regression in functionality for the metadata verifier
	as cli and table verification are disabled since they require to be ported to
	use MonoImage information.

	* image.c (do_mono_image_load): Split the code in this function
	into mono_image_load_pe_data and mono_image_load_cli_data.
	Add	care_about_pecoff parameter to not load pecoff data.
	Call into the metadata verifier for pecoff and cli verification.

	* image.c (mono_image_open_raw): New function that doesn't perform
	any parsing of the image contents.
	
	The reason for the 3 new functions is to give pedump better control
	into the interaction with the verifier.

	* metadata-internals.h: Add new functions from image.c as part of the
	internal mono API.

	* metadata-verify.c: Split mono_image_verify into mono_verifier_verify_pe_data,
	mono_verifier_verify_cli_data and mono_verifier_verify_table_data. Prepare
	to make those functions work together with the runtime.

	* verify.c: Add mono_verifier_is_enabled_for_image function that returns
	true if the image needs to be verified.

	* verify-internals.h: Export new functions from metadata-verify.c and verify.c.

	* pedump.c: Use new metadata verifier API.

2009-04-19  Zoltan Varga  <vargaz@gmail.com>

	* object.c (mono_install_vtable_trampoline): Make this receive a
	trampoline creation function instead of trampoline, allowing the JIT
	to use a different trampoline for each vtable.

2009-04-18  Mark Probst  <mark.probst@gmail.com>

	* object.c (mono_raise_exception): Don't reset the thread abort
	exception state here.

2009-04-18  Mark Probst  <mark.probst@gmail.com>

	* icall-def.h: New icall for getting the thread abort exception
	state for a thread.

	* object.c, thread.c, object-internals.h: A thread's abort
	exception state is now a GC handle.  To get the object it stands
	for, we must move it into the current app domain, if it's
	different than the one where it originated from.

	* appdomain.c: Bump corlib version.

	* domain.c, domain-internals.h: New function for setting the
	domain and migrate the thread abort exception or not.

2009-04-16 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Add initial verification of the
	field table.

2009-04-16 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Add a macro to conditionally enable
	dumping of verification information. Add  make_coded_token
	and search_sorted_table to enable search sorted tables
	by a given coded token.

2009-04-16 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Add array mapping from table index
	to description offset. Add get_col_offset and get_col_size
	functions.

2009-04-16 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Add remaining table descriptions offsets.
	Add remaining coded index descriptions.

2009-04-16 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Fixed constant table description.
	Fixed calculation of HasCustomAttribute coded index size.
	Fixed calculation of size for many table indexes. 

2009-04-16 Rodrigo Kumpera  <rkumpera@novell.com>

	* pedump.c (dump_metadata): Dump table offset instead
	of useless pointer in memory.

2009-04-16 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_typedef_table): Add tests for MethodList.

2009-04-15 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_typedef_table): Add tests for FieldList and
	a missing of for interface types.

2009-04-15 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_pe_optional_header): Add comment of why
	the code is commented.

	* metadata-verify.c (verify_resources_table): Remove spurious printf
	and don't fail if there are unmanaged resources. Gmcs generates a useless
	one	for all assemblies - I bet it's some MS compatibility junk.

2009-04-15 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_typedef_table): Verify the extends field.

	* metadata-verify.c (mono_image_verify): Add a is_corlib.

	* verify-internals.h: Same.

	* pedump.c: Fix for mono_image_verify new signature.

2009-04-15 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_typedef_table): Verify for some invalid
	flags combinations.

2009-04-15 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_module_table): Ignore the generation field.

2009-04-15  Martin Baulig  <martin@ximian.com>

	* debug-mono-symfile.c
	(mono_debug_symfile_lookup_location): Don't print a warning for
	unknown extended opcodes if they're within 0x40 and 0x7f.

2009-04-15  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_get_runtime_invoke_sig): Don't share runtime
	invoke signatures returning an enum. Fixes #494847.

2009-04-14 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Initial code to verify the typedef table.

2009-04-14 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (mono_method_verify): Don't fail if an unconditional branch
	with non empty stack happens before the beginning of a try block.

	Fixes #494812.

2009-04-14 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify typename and typenamespace fields of
	the typeref table.

2009-04-13 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Initial code to verify the typeref table.

2009-04-13 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (verify_delegate_compatibility): Fix error message.

2009-04-14  Sebastien Pouliot  <sebastien@ximian.com>

	* security-core-clr.c: Fix typo

2009-04-14  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (delegate_hash_table_add): Make delegate_target_locations 
	a MonoGHashTable to keep its values alive.
	(emit_marshal_boolean): Fix a warning.

2009-04-13 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* socket-io.c: don't return IPv4/IPv6 addresses if the machine does
	not have any interface configured for IPv4/IPv6.

2009-04-13 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* assembly.c: fix typo in error message.

2009-04-14  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_delegate_to_ftnptr): Use mono_gc_alloc_fixed () for
	allocating the location holding the this argument to prevent
	'too many root sets' errors.

	* object.c (mono_class_create_runtime_vtable): Set field->offset to -1
	to mark fields as special static.
	(mono_field_static_get_value): Handle special static fields.
	(mono_field_static_set_value): Ditto.

	* class-internals.h (struct _MonoClassField): Document this.

2009-04-13  Bill Holmes  <billholmes54@gmail.com>

	* cominterop.c (mono_cominterop_emit_marshal_com_interface): Assigning
	  the argument a value of null for the MARSHAL_ACTION_MANAGED_CONV_OUT
	  case.  This will handle when managed code returns null to native code.

	Code is contributed under MIT/X11 license.

2009-04-13  Bill Holmes  <billholmes54@gmail.com>

	* object.c (build_imt_slots): Changing a free to a g_free to match
	  the g_malloc0 in add_imt_builder_entry that allocated this memory.

	Code is contributed under MIT/X11 license.

2009-04-13  Bill Holmes  <billholmes54@gmail.com>

	* marshal.c (emit_marshal_boolean): Adding code to ensure that
	  the correct TRUE value is passed through the marshaling layer.

	Code is contributed under MIT/X11 license.

2009-04-13  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_emit_managed_wrapper): Handle closed delegates
	correctly. Fixes #492330.
	
	* marshal.c: Fix the embedding of object pointers into JITted code in
	the native-to-managed wrappers by allocating some GC tracked memory, and
	embedding the address of that.

2009-04-11  Zoltan Varga  <vargaz@gmail.com>

	* object.c (mono_class_create_runtime_vtable): Avoid putting MonoMethod
	pointers into the vtable.

2009-04-09 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (mono_delegate_type_equal): Proper check MONO_TYPE_CLASS.

	* verify.c (verify_ldftn_delegate): Improve error message.

2009-04-09  Raja R Harinath  <harinath@hurrynot.org>

	* reflection.c (my_mono_class_from_mono_type): Remove.

2009-04-09  Raja R Harinath  <harinath@hurrynot.org>

	Prepare to reduce memory usage of owner-less generic parameters (1/n)
	* class-internals.h (MonoGenericParam): Carve out pklass, name, flags
	and constraints fields into ...
	(MonoGenericParamInfo): ... this.
	(mono_generic_param_info, mono_generic_container_get_param_info):
	New accessors.
	* class.c, debug-helpers.c, icall.c: Update to changes.
	* metadata.c, reflection.c, verify.c: Likewise.

2009-04-09  Zoltan Varga  <vargaz@gmail.com>

	* debug-helpers.c (dis_one): Fix decoding of strings in dynamic images.

	* marshal.c (get_runtime_invoke_type): Share enums with their base types.
	
	* marshal.c (get_runtime_invoke_type): Share pointers with ints and
	booleans with sbytes.

2009-04-08 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c (can_access_instantiation): Verify accesibility of element types
	for arrays and pointers.

	* class.c (can_access_type): Return true if the target class is VAR or MVAR.

	* class.c (mono_method_can_access_method_full): Fix typos in the documentation.

	Fixes #493068.

2009-04-08 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (do_invoke_method): Improve error messages.

2009-04-08  Bill Holmes  <billholmes54@gmail.com>

	* verify.c:  Fixing the MSVC build.

	Code is contributed under MIT/X11 license.

2009-04-08  Sebastien Pouliot  <sebastien@ximian.com>

	* security-core-clr.c: Simplify get_reflection_caller not to call
	mono_method_get_last_managed (another stack walk) and adjust the
	callers to handle a (should not happen) NULL return value.

2009-04-08  Raja R Harinath  <harinath@hurrynot.org>

	Add accessors to some MonoGenericParam fields
	* class-internals.h (mono_generic_param_owner): New accessor.
	(mono_generic_param_num): Likewise.
	(mono_type_get_generic_param_owner): New helper.
	(mono_type_get_generic_param_num): New helper.
	* class.c, icall.c, metadata.c, reflection.c, verify.c: Use them.

2009-04-08  Raja R Harinath  <harinath@hurrynot.org>

	* class-internals.h (mono_generic_container_get_param): New wrapper.
	* class.c, icall.c, metadata.c, verify.c: Use it.

2009-04-08  Raja R Harinath  <harinath@hurrynot.org>

	Fix gtest-252.cs
	* verify.c (mono_type_is_valid_type_in_context): Rewrite to use
	the standard case/loop.  In particular, don't complain about
	references to generic type definitions.

2009-04-07  Zoltan Varga  <vargaz@gmail.com>

	* debug-helpers.c (dis_one): Decode string arguments.

2009-04-07 Rodrigo Kumpera  <rkumpera@novell.com>

	* pedump.c (dump_verify_info): Dump type name correctly.

2009-04-07 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (mono_method_verify): Don't init code slots for exception boundaries if they
	are larger than code size.

	This can happen in valid code if the try/catch block is not followed by any instruction
	and do a backward branch on the leave instruction.

	Fixes #492494.

2009-04-06  Sebastien Pouliot  <sebastien@ximian.com>

	* security-core-clr.c: Fix typo while comparing second method names
	in can_avoid_corlib_reflection_delegate_optimization

2009-04-06 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (do_throw): Don't allow an unboxed generic param ar argument.

	Fixes #487738.

2009-04-06 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata.c (do_mono_metadata_parse_type): Fail if we are decoding
	a MVAR using a class context.

	Fixes #490335.

2009-04-06  Zoltan Varga  <vargaz@gmail.com>

	* object.c (mono_class_compute_gc_descriptor): Make this non-static.

	* domain-internals.h (struct _MonoJitInfo): Add a 'gc_info' field.

	* gc-internal.h (MonoGCCallbacks): New stucture containing the callback
	functions supplied by the JIT for the SGEN GC.

	* sgen-gc.c: Call the callbacks supplied by the JIT to do stack marking.
	
2009-04-06  Massimiliano Mantione  <massi@ximian.com>

	monitor.c (mono_monitor_try_enter_internal):
	Added calls to profile monitor contentions.
	Also duplicated a small piece of code (the "get the monitor" logic)
	from the fast path to the slow path, and changed the relevant goto
	statements, so that monitor acquisition events can be emitted from the
	slow path (this is by Paolo Molaro).

2009-04-06  Massimiliano Mantione  <massi@ximian.com>

	* profiler.c, profiler.h, profiler-private.h:
	Added support for profiling monitor contentions.

2009-04-03 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the modules table.

2009-04-02 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (mono_generic_param_is_constraint_compatible): Inflate the candidate
	using the context of the method been verifier and not of the method been called.

	* verify.c: Add verifier_inflate_type and mono_type_is_valid_type_in_context to
	safely inflate generic types. 

2009-04-02  Sebastien Pouliot  <sebastien@ximian.com>

	* security-core-clr.c: Change the strategy for checking the 
	"reflection using delegates optimization" to avoid unneeded 
	attributes in multiple class libraries.

2009-04-02  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Remove object element in the disappearing link struct
	by storing the object pointer in the link.

2009-03-31 Rodrigo Kumpera  <rkumpera@novell.com>

	* pedump.c (dump_verify_info): Don't crash if signature decoding fails.

2009-03-31 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (verifier_load_field): Fail if the field parent could not be loaded.

	* verify.c (mono_method_verify): Do proper bounds checking of exception
	clause ranges.

2009-03-31 Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (mono_field_from_token): Don't crash if the field parent could
	not be decoded.

2009-03-31  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Execute critical finalizers after ordinary
	finalizers.

	* class-internals.h, domain.c: Add CriticalFinalizerObject to
	mono_defaults.

2009-03-31 Jb Evain <jbevain@novell.com>

	* verify.c (do_ldstr): don't check if a string is in the user strings
	heap if the current image is dynamic.

2009-03-31  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Wait until the last finalizer has executed when
	returning from WaitForPendingFinalizers.

2009-03-31  Martin Baulig  <martin@ximian.com>

	* mono-debug-debugger.h (MonoDebuggerEvent): Add
	`MONO_DEBUGGER_EVENT_CREATE_APPDOMAIN' and
	`MONO_DEBUGGER_EVENT_UNLOAD_APPDOMAIN'.
	(mono_debugger_event_create_appdomain): New function.
	(mono_debugger_event_unload_appdomain): New function.

	* appdomain.c (mono_domain_create_appdomain_internal): Call
	mono_debugger_event_create_appdomain().

2009-03-31  Martin Baulig  <martin@ximian.com>

	* mono-debug-debugger.c
	(mono_debugger_register_class_init_callback): Also register the
	class init callback if the class is already initialized to make
	things work with shadow copied assemblies.

2009-03-31  Sebastien Pouliot  <sebastien@ximian.com>

	* security-core-clr.c
	(mono_security_core_clr_ensure_reflection_access_field): Let 
	critical code access the field (just like we do for methods). Use
	check_field_access helper.
	(mono_security_core_clr_ensure_reflection_access_method): Use 
	check_field_access helper.

2009-03-31  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Remove data (callback) element from FinalizeEntry and
	call the run-finalize function directly.

	* gc.c, gc-internal.h: Make run_finalize() non-static.

2009-03-31  Mark Probst  <mark.probst@gmail.com>

	* sgen-gc.c: Use a separate struct for disappearing links.

2009-03-31 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* socket-io.c: don't fail if the SocketOptionsFlag has Partial or
	* MaxIOVectorLength enabled, just ignore them.
	Fixes bug #349688.

2009-03-30 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Fix eglib build.

2009-03-30  Zoltan Varga  <vargaz@gmail.com>

	* threads-types.h: Fix the win32 build.

2009-03-28  Sebastien Pouliot  <sebastien@ximian.com>

	* class.c: move coreclr inheritance/override checks to 
	security-core.clr.c
	* security-core.clr.c|h: add code from class.c with additional
	documentation. Fix override check when the method is not critical.

2009-03-28  Zoltan Varga  <vargaz@gmail.com>

	* debug-helpers.c (mono_method_desc_match): Make '*' match anything.
	(match_class): Ditto.

2009-03-27 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Rename bounds_check_offset to bounds_check_datadir.

	* metadata-verify.c: Implement table layout row size calculation. Verify
	the total size of the tables.

2009-03-27 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify heap sizes and size to decode row counts. 

2009-03-27 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* appdomain.c:
	* console-io.[ch]: added new mono_console_init() to make sure that
	file descriptors 0, 1 and 2 are opened.
	Bug #489019 fixed.

2009-03-27  Sebastien Pouliot  <sebastien@ximian.com> 

	* appdomain.h: Export a new callback type and a new function to
	set this callback. This allow a mono host to provide it's own
	definition for "platform code".
	* metadata-internals.h: Add a core_clr_platform_code flag on 
	_MonoImage to (cache and) know if it is representing platform 
	code.
	* image.c (do_mono_image_open): Set core_clr_platform_code flag 
	on platform code images.
	* security-core-clr.c|h	
	(mono_security_set_core_clr_platform_callback): Allow the host
	to provide it's own platform check definition.
	(mono_security_core_clr_determine_platform_image): Detect if an 
	image is platform code (using the specified callback).
	(mono_security_core_clr_is_platform_image): Return cached value 
	for platform code.

2009-03-27  Zoltan Varga  <vargaz@gmail.com>

	* threads.c (mono_create_thread): New helper function to wrap CreateThread
	which has different parameter types for the 'tid' argument in windows and
	the io-layer.

	* appdomain.c attach.c threads.c: Use the new helper.

2009-03-26 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify valid table bits.

2009-03-26 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_metadata_header): Store size in the size field.

	* metadata-verify.c: Add initial table schema verification.

2009-03-26  Zoltan Varga  <vargaz@gmail.com>

	* icall.c (ves_icall_get_parameter_info): Add a 'member' argument, used to
	obtain the refclass argument needed by mono_param_get_objects (). Fixes
	#488383.

	* reflection.c (mono_param_get_objects_internal): Add a 'refclass' argument.

	* appdomain.c (MONO_CORLIB_VERSION): Bump this.

2009-03-26  Sebastien Pouliot  <sebastien@ximian.com>

	* security-core-clr.c: Add/update documentation

2009-03-26  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (emit_marshal_object): Generate code to throw an exception
	instead of throwing it. Fixes #488670.

2009-03-25  Sebastien Pouliot  <sebastien@ximian.com>

	* appdomain.c: Bump MONO_CORLIB_VERSION to 73.
	* icall.c (ves_icall_System_Delegate_CreateDelegate_internal): Add
	an extra 'throwOnBindFailure' parameter to the icall. Remove FIXME
	and add a call to mono_security_core_clr_ensure_delegate_creation
	to do the extra checks required by CoreCLR.
	* security-core-clr.c|h: Add function to check delegate creation,
	both in the binding and accessibility, under CoreCLR.

2009-03-25  Sebastien Pouliot  <sebastien@ximian.com> 

	* reflection.c (mono_reflection_create_dynamic_method): when 
	coreclr is enabled make sure that every resolved object are
	checked (e.g. field and method access).
	* security-core-clr.c|h: Add function to check objects resolved
	when a dynamic method is created.

2009-03-24 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Cache directory rva translations.

	* metadata-verify.c: Add cli-header and streams verification.

2009-03-24 Rodrigo Kumpera  <rkumpera@novell.com>

	* image.c (load_metadata_ptrs): We decode MonoImage::md_version_minor at
	the wrong offset (8 instead of 6).

2009-03-23  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_delegate_to_ftnptr): For delegates wrapping pinvoke
	methods, return the native function address itself. Fixes
	#487758.

2009-03-23 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* console-io.c: some of the values for control characters might not be
	present.

2009-03-21  Sebastien Pouliot  <sebastien@ximian.com>

	* exception.c|h: Add helpers to create [Field|Method]AccessException
	* icall.c: Add required coreclr check calls for field reflection.
	Move the existing (method) check logic into security-core-clr.c
	* security-core-clr.c: Add functions to check if the access of a
	field or method is allowed when reflecting under coreclr. This is
	mostly done using a stack walk to find the "real" caller: i.e. the
	code that is calling the reflection

2009-03-20  Zoltan Varga  <vargaz@gmail.com>

	* gc-internal.h: Change location of gc_wrapper.h

2009-03-20  Sebastien Pouliot  <sebastien@ximian.com> 

	* class.c: Simplification to coreclr checks for overrides that
	makes it easier to set breakpoints.

2009-03-20  Sebastien Pouliot  <sebastien@ximian.com>

	* security-core-clr.c|h: (mono_security_core_clr_class_level, 
	mono_security_core_clr_method_level): Avoid potential 
	MonoCustomAttrInfo allocation for transparent assemblies (e.g. 
	user/application code) and make it easier to set breakpoints

2009-03-19 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Reject cli header tables that mono don't handle.

2009-03-19 Rodrigo Kumpera  <rkumpera@novell.com>

	* pedump.c: Fix CLI header dumping.

2009-03-19 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: More CLI header verification.

2009-03-19  Zoltan Varga  <vargaz@gmail.com>

	* locales.c (get_current_locale_name): Use g_malloc instead of malloc.

2009-03-18 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Initial verification of the CLI header.

2009-03-18 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (verify_resources_table): Fix verification of zero
	sized resource section and id entries count.

2009-03-18  Zoltan Varga  <vargaz@gmail.com>

	* icall.c: Handle user types in many Type icalls. Fixes #486303.

2009-03-17  Jb Evain  <jbevain@novell.com>

	* profiler.c: call mono_gc_base_init from mono_profiler_load.

2009-03-17  Zoltan Varga  <vargaz@gmail.com>

	* sgen-gc.c (mono_gc_make_descr_for_object): Fix 64 bit support.
	(mono_gc_make_descr_for_array): Ditto.

2009-03-17  Sebastien Pouliot  <sebastien@ximian.com>

	* verify.c (mono_verifier_is_class_full_trust): Add support for
	CoreCLR security mode where trusted assemblies are defined as
	"platform code".

2009-03-16 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Add minimal PECOFF resource verification.

2009-03-16 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Be less restrictive with some coff fields.

2009-03-16 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (init_stack_with_value_at_exception_boundary): Init generic
	params as boxed values on stack. Fixes #485706.

2009-03-16 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* console-io.c: the termios values may vary in different flavors of unix.

2009-03-16 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* console-io.[ch]: return the entire set of control characters when
	initializing the terminal.
	* appdomain.c: bump corlib version.

Mon Mar 16 11:11:26 CET 2009 Paolo Molaro <lupus@ximian.com>

	* mono-perfcounters.c: added support for in-process custom
	performance counters.

2009-03-13 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Small cleanup and add comment for IAT directory entry. 

2009-03-13 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify the data pointed by the import table. 

2009-03-13 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c (load_data_directories): Store data
	directory contents.

	* metadata-verify.c: Verify the import table. 

2009-03-12 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Verify data directories.

2009-03-12 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Check section header flags.

2009-03-12 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* appdomain.c: if the assembly name is a shadow-copied file, return
	TRUE from mono_is_shadow_copy_enabled but don't actually do anything
	in mono_make_shadow_copy.
	* icall.c: if the assembly name is a shadow-copied file, replace it
	with the original assembly path.

	Bug #484244 fixed. NUnit tests for corlib can be run without
	--noshadow now.

2009-03-12  Zoltan Varga  <vargaz@gmail.com>

	* sgen-gc.c (add_to_global_remset): Fix the handling of root global remset
	entries when the table is reallocated.

	* icall.c: Allocate the memory used by the mono_ptr_array macros using
	mono_gc_alloc_fixed () since it contains GC refs.

2009-03-10  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (ensure_complete_type): New helper function to call
	type resolve handlers for unfinished dynamic types.
	(resolve_object): Call it for MonoClassFields. Fixes #483852.

2009-03-09  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (mono_custom_attrs_has_attr): Handle interfaces. Fixes
	#483247.

2009-03-08 Rodrigo Kumpera  <rkumpera@novell.com>

	* appdomain.c (get_shadow_assembly_location): Fix memleak.

2009-03-08  Zoltan Varga  <vargaz@gmail.com>

	* domain-internals.h (struct _MonoDomain): Add new hash tables mapping
	between GCHandles of type WeakTrackResurrection and the objects they
	point to.

	* gc.c: Partly implement the sematics of GCHandles of type 
	WeakTrackResurrection: these handles should only be cleared after the
	finalizer of the object they are pointing to has ran.

2009-03-06  Mark Probst  <mark.probst@gmail.com>

	* icall.c: Partially revert r126631 because using the jump
	trampolines for generic shared methods makes it superfluous.

2009-03-06  Zoltan Varga  <vargaz@gmail.com>

	* threads.c (handle_store): Create the 'threads' hash table with the proper
	MONO_HASH_VALUE_GC type.

2009-03-05  Zoltan Varga  <vargaz@gmail.com>

	* domain-internals.h (struct _MonoDomain): Move 'typeof_void' before
	FIRST_GC_TRACKED.

	* domain.c (mono_domain_create): Register the fields between FIRST_GC_TRACKED
	and LAST_GC_TRACKED as a GC root.

	* gc-internal.h: Fix the comment of mono_gc_alloc_fixed.

	* object.c (mono_class_create_runtime_vtable): Create a GC descriptor for
	the static data even if it consists of 1 reference.

	* boehm-gc.c (mono_gc_alloc_fixed): Allocate using GC_MALLOC_EXPLICITLY_TYPED
	if there is a GC descriptor.

	* reflection.c (ALLOC_REFENTRY): Allocate ReflectedEntry-es using malloc
	instead of through the GC since they contain no object references.

2009-03-05  Mark Probst  <mark.probst@gmail.com>

	* generic-sharing.c (instantiate_other_info): Always return a jump
	trampoline for method code.

2009-03-05  Marek Habersack  <mhabersack@novell.com>

	* culture-info-tables.h: generated to include the en-tt culture.

2009-03-04 Rodrigo Kumpera  <rkumpera@novell.com>

	* domain-internals.h (MonoDomain): Add two fields to cache invoke wrappers to
	capture the thread context.

	* object.c (mono_async_result_new): Cache the invoke wrappers to
	ExecutionContext::Capture.

2009-03-04 Rodrigo Kumpera  <rkumpera@novell.com>

	* marshal.h: Add a prototype for what mono_compile_method returns
	for invoke wrappers.

	* gc.c: Use the new prototype declaration.

2009-03-04  Geoff Norton  <gnorton@novell.com>

	* boehm-gc.c: Add some MONO_LOG tracing for the GC
	* gc-internal.h:
	* mono-gc.h: Expose mono_gc_invoke_finalizers in the embedding api.

2009-03-04  Martin Baulig  <martin@ximian.com>

	* mono-debug.h
	(mono_debugger_runtime_invoke): Removed.

	* mono-debug-debugger.c
	(mono_runtime_invoke): Moved into ../mini/debug-mini.c.

2009-03-02  Martin Baulig  <martin@ximian.com>

	* mono-debug.h
	(mono_debugger_unhandled_exception): Removed.
	(mono_debugger_handle_exception): Removed.
	(mono_debugger_throw_exception): Removed.

	* mono-debug.c
	(mono_debug_debugger_version): Bump to 5.

	* mono-debug-debugger.c: Moved the exception handling code to
	../mini/debug-mini.c

2009-03-03  Zoltan Varga  <vargaz@gmail.com>

	* domain-internals.h (struct _MonoDomain): Add a separate lock for the
	finalize_objects_hash.

	* gc.c: Use the separate lock to access the finalize_objects_hash field.
	
	* domain-internals.h (struct _MonoDomain): Add finalize_runtime_invoke
	field.

	* metadata-internals.h (struct _MonoImage): Add runtime_invoke_vcall_cache
	cache.

	* image.c (mono_image_close): Free it.
	
	* marshal.c (mono_marshal_get_runtime_invoke): Add a 'virtual' argument
	allowing a creation of a wrapper which invokes its method using a CALLVIRT
	on the this argument.

	* gc.c (run_finalize): Optimize the calling of the finalizers.

2009-03-03  Martin Baulig  <martin@ximian.com>

	* mono-debug.h (MONO_DEBUGGER_MAJOR_VERSION): Bump to 81 because
	of the `MonoGenericInst' changes.

2009-03-03 Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_MonoType_GetGenericArguments): Use
	mono_array_class_get_cached to reduce locking contention. Extract
	a domain var.

	* icall.c (ves_icall_Type_GetFields_internal): Avoid allocating
	intermediary managed arrays. Use caching version of mono_array_new
	to allocate the result array.

	* icall.c (ves_icall_Type_GetEvents_internal): Same.	

	* icall.c (ves_icall_Type_GetNestedTypes): Same.	

	* locales.c (create_names_array_idx):  Use mono_array_new_cached
	to reduce locking contention.

2009-03-03  Zoltan Varga  <vargaz@gmail.com>
		
	* object.c (mono_method_add_generic_virtual_invocation): Put back the
	thunk builder code for the non-interface case.

2009-03-02  Zoltan Varga  <vargaz@gmail.com>

	* object.c (get_generic_virtual_entries): New helper function to collect
	the virtual generic method instances which need to be added to an IMT
	thunk.
	(mono_method_add_generic_virtual_invocation): Add a 'vtable' argument.
	Instead of creating a new IMT thunk, reset the vtable slot to the
	trampoline, the thunk will be created the next time the trampoline is called.
	(build_imt_slots): Add support for virtual generic methods in interfaces by
	adding to the IMT thunk all the methods registered using 
	mono_method_add_generic_virtual_invocation ().

	* object-internals.h (_MonoImtBuilderEntry): Add a 'has_target_code' field.
	(struct _MonoIMTCheckItem): Ditto.

	* object.c (mono_method_add_generic_virtual_invocation): Take a
	MonoMethod argument instead of a MonoGenericInst. Fix the construction of
	the IMT thunk to include all items.
	
	* object.c (mono_class_create_runtime_vtable): Add a missing
	mono_loader_unlock ().

2009-03-02 Rodrigo Kumpera  <rkumpera@novell.com>

	* appdomain.c (MONO_CORLIB_VERSION): Bump corlib version.

	* object-internals.h (MonoReflectionEvent): Add cached_add_event.

2009-03-02 Rodrigo Kumpera  <rkumpera@novell.com>

	* object-internals.h: Rename _MonoReflectionEvent to
	MonoReflectionMonoEvent so it reflects the right managed type.
	Add a MonoReflectionEvent that correctly represents System.EventInfo.

	* icall.c:
	* reflection.c: Adjust code to use the new MonoReflectionMonoEvent
	type.

2009-03-02 Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_Type_GetMethodsByName): Avoid allocating
	intermediary managed arrays. Use caching version of mono_array_new
	to allocate the result array.

2009-03-01 Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c: Use cached version of mono_array_new alongside
	the mono_reflection_get_custom_attrs_by_type call path.

2009-03-01 Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c (ves_icall_Type_GetInterfaces): Avoid allocating
	intermediary managed arrays. Use caching version of mono_array_new
	to allocate the result array.

	* icall.c (ves_icall_Type_GetConstructors_internal): Same.

2009-03-01 Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c: Add small implementation of a growable stack bound array.

	* icall.c (ves_icall_System_Enum_get_hashcode): Fix warning.

	* icall.c (ves_icall_Type_GetPropertiesByName): Avoid allocating
	intermediary managed arrays. Use caching version of mono_array_new
	to allocate the result array.

2009-02-27 Rodrigo Kumpera  <rkumpera@novell.com>

	* icall.c: New icall ves_icall_System_Enum_compare_value_to that
	helps Enum::CompareTo to be implemented without reboxing all enums
	to their underlying type.
2009-02-27  Zoltan Varga  <vargaz@gmail.com>

	* domain.c (SET_APPDOMAIN): Avoid calling TlsSetValue () on some platforms,
	since it acquires a global lock leading to scalability problems.

	* profiler.c: Make the stat profiler work with multiple appdomains, this
	currently only works when no appdomains are unloaded.

2009-02-26 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* appdomain.c: make the check to avoid copying when the assembly is
	already shadow copied actually work.

2009-02-26  Zoltan Varga  <vargaz@gmail.com>

	* appdomain.c (MONO_CORLIB_VERSION): Bump corlib version.

	* object-internals.h (struct _MonoReflectionGenericClass): Sync with
	changes to the managed side.

2009-02-25  Zoltan Varga  <vargaz@gmail.com>

	* metadata-internals.h (struct _MonoImage): Add a new cache for szarray
	classes + a separate lock for it, as it is used frequently at runtime, not
	just during metadata loading/JIT compilation.

	* class.c (mono_bounded_array_class_get): Use the separate cache + lock
	for szarrays.
	
	* object-internals.h (mono_class_from_name_cached): New macro to cache
	the results of the lookup locally without having to declare a static
	variable to hold it.
	(mono_class_get_field_from_name_cached): Ditto.
	(mono_array_class_get_cached): Ditto.

	* threadpool.c threads.c locales.c icall.c reflection.c socket-io.c: Use
	the new macros.
	
	* object.c (mono_get_delegate_invoke): Call setup_methods () to avoid the
	slower search in metadata.

	* pedump.c: Fix a warning.

2009-02-23  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (encode_locals): Add checks for user types.
	(method_encode_clauses): Ditto.
	(method_encode_code): Ditto.
	(mono_image_create_token): Ditto.

	* object-internals.h: Change the type of more fields from MonoReflectionType*
	to MonoObject*.

2009-02-22  Zoltan Varga  <vargaz@gmail.com>

	* threads.c (mono_thread_suspend_all_other_threads): Handle the case when
	the a thread does not suspend within 100ms.

	* monitor.c (mono_monitor_try_enter_internal): Handle SuspendRequested
	in addition to StopRequested as well.

	* mono-debug.c: Call _mono_debug_get_image () while holding the debug lock.

	* debug-mono-symfile.c (mono_debug_symfile_lookup_method): Actually
	search the method_hash before inserting a new entry, to avoid crashes when
	the same method is inserted multiple times, causing the old 
	MonoDebugMethodInfo structure to be freed by the value dtor function.

2009-02-22 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* socket-io.c: support SO_MAXCONN, SO_USELOOPBACK and
	SO_EXLUSIVEADDRUSE where available.

2009-02-21  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_get_runtime_invoke): Fix _another_ bug sharing
	runtime invoke wrappers, this time it is string ctor wrappers, which
	pass a dummy string as 'this' instead of their obj argument. Fixes
	#478473.

2009-02-21  Jb Evain  <jbevain@novell.com>

	* icall.c (ves_icall_System_Reflection_Assembly_GetReferencedAssemblies):
	only get create_culture once.

2009-02-20  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (mono_reflection_setup_internal_class): Move the user type
	check before the locking.
	
	* reflection.c (mono_reflection_setup_internal_class): Check for user types.
	(mono_reflection_create_runtime_class): Ditto.
	(mono_reflection_sighelper_get_signature_local): Ditto.
	(mono_reflection_sighelper_get_signature_field): Ditto.

	* object-internals.h (CHECK_MONOTYPE): New macro to check that a Type object
	is a System.MonoType object or similar.
	(monotype_cast): New helper function to cast a MonoObject to a 
	MonoReflectionType object.

	* object-internals.h: Change MonoReflectionType* members in structures to
	MonoObject* members to force the usage of the monotype_cast () function.

	* reflection.c icall.c: Use monotype_cast () for accessing Type members of
	structures/arrays. This causes us to assert instead of crashing when 
	instances of user defined subclasses of System.Type are encountered.

2009-02-20 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* cil-coff.h:
	* icall-def.h:
	* icall.c: add new GetUnmanagedResourcePtr that returns a pointer to a
	win32 resource loaded from a PE file.

	* image.c: fix mono_image_lookup_resource.

2009-02-20 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* icall-def.h:
	* threads-types.h:
	* threads.c: added internal call for WaitHandle.SignalAndWait.

2009-02-19  Bill Holmes  <billholmes54@gmail.com>

	* cominterop.c : Adding cominterop_type_from_handle and 
	  registering it as an icall.  Replacing all references
	  to type_from_handle.

	Code is contributed under MIT/X11 license.

2009-02-19 Rodrigo Kumpera  <rkumpera@novell.com>

	* Makefile.am: Add lock-tracer.h and lock-trace.c.

	* appdomain.c: Call the tracer init function.

 	* domain-internals.h: Enable the tracer for the domain locks.

	* image.c: Enable the tracer for image locks.

	* loader.c: Enable the trace for the loader lock.

	* lock-tracer.h:
	* lock-tracer.c: Initial implementation of the lock trace utility.
	The tracer requires a compile time define to be enabled and a env var
	to be enabled at runtime.

2009-02-19 Rodrigo Kumpera  <rkumpera@novell.com>

	* domain.c (mono_domain_code_foreach): Improve documentation.

2009-02-19 Rodrigo Kumpera  <rkumpera@novell.com>

	* appdomain.c:
	* generic-sharing.c:
	* object.c:
	* reflection.c:  Adjust locking order to the new semantics where the loader lock
	comes first.

2009-02-18 Rodrigo Kumpera  <rkumpera@novell.com>

	* domain.c: Add mono_domain_code_* functions that perform locking
	around the domain codeman.

	* domain-internals.h: Export those functions.

	* object.c: Use new functions instead of acquiring the domain lock.

2009-02-19  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_ftnptr_to_delegate): Convert a NULL ftnptr to a null
	delegate. Fixes #477396.

2009-02-18  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (create_custom_attr): Get rid of alloca.

2009-02-18  Bill Holmes  <billholmes54@gmail.com>

	* cominterop.c (cominterop_get_managed_wrapper_adjusted) :
	  Adding exception handling for all CCW calls.

	Code is contributed under MIT/X11 license.

2009-02-18  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (mono_reflection_init): Remove the unused reflection mutex.

	* marshal.c (emit_marshal_boolean): Add null checks to the new 
	native->managed marshalling code. Fixes #476247.

2009-02-17  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_get_vtable_entry): Move the addition of
	static rgctx invoke wrappers for vtable methods here, this simplifies
	a lot of code and causes fewer rgctx wrappers to be created.

	* marshal.c (mono_marshal_get_static_rgctx_invoke): Change the
	name of the statistics to begin with an uppercase.

2009-02-17 Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c: Revert previous change as it breaks the build.
	
2009-02-17 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c: Properly handle SZARRAY element type.

	Fixes #474271.

2009-02-17 Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (mono_image_create_method_token): Correctly encode
	MethodDef MemberRefParent token.

	Fixes #472845.

2009-02-17  Zoltan Varga  <vargaz@gmail.com>

	* image.c (mono_image_close): Delete the critical section before
	freeing the memory holding it.

2009-02-16 Rodrigo Kumpera  <rkumpera@novell.com>

	* verify.c (mono_method_verify): rethrow opcode doesn not fall through.
	Fixes #476257.

2009-02-16 Rodrigo Kumpera  <rkumpera@novell.com>

	* pedump.c (main): Call mono_marshal_init so pedump
	doesn't crash.

2009-02-16 Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (method_from_memberref): Properly fix #474271 and
	don't break the runtime bad.

2009-02-16  Zoltan Varga  <vargaz@gmail.com>

	* domain.c (mono_domain_alloc): Add locking so the caller doesn't have to.
	(mono_domain_alloc0): Ditto.

2009-02-16 Rodrigo Kumpera  <rkumpera@novell.com>

	* loader.c (method_from_memberref): Don't abort if the array
	method is not found. A regular loader failure is more informative
	and correct.

	Fixes #474271.

2009-02-16 Rodrigo Kumpera  <rkumpera@novell.com>

	*loader.c: Guard MonoImage::method_cache/methodref_cache
	using the image lock instead of the loader lock.

	* metadata.h: Add comments about which fields are protected by
	the image lock.

2009-02-16  Zoltan Varga  <vargaz@gmail.com>

	* appdomain.c (mono_set_private_bin_path_from_config): Fix a warning.

	* generic-sharing.c (mono_method_construct_object_context): Remove the
	wrapper_type == NONE assert, it is not needed.

2009-02-15  Zoltan Varga  <vargaz@gmail.com>

	* reflection.c (clear_cached_object): New helper function.
	(mono_method_clear_object): New function to clear the cached reflection
	objects for a dynamic method.

	* object.c (mono_runtime_free_method): Call mono_method_clear_object ().
	Partly fixes # 463323.
	
2009-02-14 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c:
	* loader.c:
	* reflection.c: Remove all explicit uses of MonoImage::property_hash.

2009-02-14 Rodrigo Kumpera  <rkumpera@novell.com>

	* image.c: Add mono_image_property_(lookup,insert,remove) functions that
	take the image lock instead of the loader lock.

	* metadata-internals.h: Export new functions.

2009-02-12  Miguel de Icaza  <miguel@novell.com>

	* domain.c (app_config_parse): Remove another use of stat that is
	not necessary as g_file_get_contents already does the presence
	check. 

2009-02-13  Zoltan Varga  <vargaz@gmail.com>

	* cominterop.c icall-def.h: Fix the DISABLE_COM build.

	* marshal.c: Move the bstr handling code to cominterop.c.

	* marshal.c: Remove some COM interop code missed previously.

2009-02-12  Miguel de Icaza  <miguel@novell.com>

	More Paolo patches from the Wii port:
	
	* security.c: Remove ves_icall_System_Environment_get_UserName
	from here.

	* icall.c: And put ves_icall_System_Environment_get_UserName
	here. 

	* appdomain.c (mono_set_private_bin_path_from_config): Remove
	redundant call to stat that was only used to test for the file
	existence.   Patch from Paolo.

	* gc.c (run_finalize): If COM is disabled, do not link in
	mono_marshal_free_ccw.

	* generic-sharing.c: Use alloca.h here as well.

2009-02-13 Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (mono_reflection_lookup_dynamic_token): Do the locking properly.

2009-02-13  Zoltan Varga  <vargaz@gmail.com>

	* cominterop.c cominterop.h: New files.

	* marshal.c: Move the COM interop related code to cominterop.c. Make a few
	function/typedefs which are needed by cominterop.c global.

2009-02-12  Mark Probst  <mark.probst@gmail.com>

	* generic-sharing.c: Don't take the loader lock to guard image
	mempool allocs.

2009-02-12 Rodrigo Kumpera  <rkumpera@novell.com>

	* reflection.c (mono_reflection_lookup_dynamic_token): This function might be
	called without the loader lock which is required to guard MonoImage:tokens.

2009-02-12 Rodrigo Kumpera  <rkumpera@novell.com>

	* class.c:
	* metadata.c:
	* method-builder.c:
	* marshal.c:
	* reflection.c: Don't take the loader lock to alloc memory from the image mempool.

2009-02-12 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata.c: Remove mono_image_alloc_lock and mono_image_alloc0_lock.
	Rework the code to use regular mono_image_alloc/0.

	* loader.c: Rework the code to use regular mono_image_alloc/0.

	* metadata-internals.h: Remove mono_image_alloc_lock and mono_image_alloc0_lock.

2009-02-12  Bill Holmes  <billholmes54@gmail.com>

	* object-internals.h : Fixing a typo in the 
	  MonoReflectionComVisibleAttribute struct.

	* marshal.c (cominterop_com_visible): Check the implemented 
	  interfaces for ComImport.

	* marshal.c (cominterop_get_native_wrapper_adjusted): For COM calls 
	  assume that bools should be treated as VARIANTBOOLs.

	* marshal.c (emit_marshal_boolean): Adding cases for 
	  MARSHAL_ACTION_MANAGED_CONV_IN and MARSHAL_ACTION_MANAGED_CONV_OUT.

	* marshal.c (mono_marshal_emit_managed_wrapper): Adding calls to 
	  emit_marshal MARSHAL_ACTION_MANAGED_CONV_IN and OUT for bools.

	* marshal.c (cominterop_get_ccw): For COM calls assume that bools
	  should be treated as VARIANTBOOLs.	

	Code is contributed under MIT/X11 license.

2009-02-12 Rodrigo Kumpera  <rkumpera@novell.com>

	* image.c (mono_image_alloc, mono_image_alloc0, mono_image_strdup): Guard mempool
	allocation with the image lock.

2009-02-12 Rodrigo Kumpera  <rkumpera@novell.com>

	This patch is the last of a series to remove explicit reference of MonoImage::mempool
	and use mono_image_alloc set of functions instead. This time we finish with reflection.c

	* object.c: Add mono_string_to_utf8_image.

	* object-internals.h: Export mono_string_to_utf8_image.

	* reflection.c: Rework all explicit references to the the image mempool to go thought
	the mono_image_alloc set of functions.

2009-02-12 Rodrigo Kumpera  <rkumpera@novell.com>

	This patch is the third of a series to remove explicit reference of MonoImage::mempool
	and use mono_image_alloc set of functions instead. This time we finish with marshal.c
	and generics-sharing.c.

	* generics-sharing.c (set_other_info_templates): Take a MonoImage instead of a MonoMemPool
	as first argument. Note that this function remains broken as it doesn't perform locking around the
	mempool allocation.

	* generics-sharing.c (rgctx_template_set_other_slot): Pass the image and not the mempool.

	* image.c: Add g_slist_append_image.

	* metadata.c (mono_metadata_field_info_with_mempool): Remove the mempool argument and use
	the supplied image for allocation. Move code into mono_metadata_field_info_full.

	* metadata.c (mono_metadata_parse_marshal_spec_full): Take a MonoImage instead of a MonoMemPool.
	Fix all related code to do the same.

	* marshal.c (mono_marshal_load_type_info): Pass the image instead of the mempool.

	* metadata-internals.h: Fix the signatures.

2009-02-12 Rodrigo Kumpera  <rkumpera@novell.com>

	This patch is the second of a series to remove explicit reference of MonoImage::mempool
	and use mono_image_alloc set of functions instead. This time we rework mono_metadata_type_dup
	and similar to work using MonoImage.

	* class.c (mono_mempool_dup): Rename to mono_image_memdup and take a MonoImage instead of a
	MonoMemPool.

	* class.c (mono_dup_array_type): Take a MonoImage instead of a MonoMemPool as first argument.

	* class.c (mono_metadata_signature_deep_dup): Same.

	* class.c (inflate_generic_type): Same.

	* class.c (mono_class_inflate_generic_type_with_mempool): Same.

	* metadata.c (mono_metadata_signature_dup_full): Same.

	* metadata.c: Add mono_metadata_signature_dup_mempool and extract common functionality from 
	mono_metadata_signature_dup_full.

	* metadata.c (mono_metadata_type_dup): Same.

	* marshal.c: Pass the image to calls to mono_metadata_type_dup.

	* reflection.c: Same.

	* generic-sharing.c: Pass the image to calls to mono_class_inflate_generic_type_with_mempool.

	* metadata-internals.h: Fix the signatures.

	* class-internals.h: Same.

2009-02-11 Rodrigo Kumpera  <rkumpera@novell.com>

	This patch is the first of a series to remove explicit reference of MonoImage::mempool
	and use mono_image_alloc set of functions instead. 

	* class.c (mono_class_inflate_generic_type_with_mempool_no_copy):
	Rename to mono_class_inflate_generic_type_no_copy and take a MonoImage instead
	of a MonoMemPool.

	* class.c (mono_class_setup_fields): Adapt to mono_class_inflate_generic_type_no_copy.

	* class.c (g_list_prepend_mempool): Removed.

	* class.c (mono_class_get_nested_types): Use g_list_prepend_image instead of g_list_prepend_mempool.

	* image.c: Add g_list_prepend_image.

	* metadata-internals.h (struct MonoImage): Fix comment. Export g_list_prepend_image as internal.

	* reflection.c (mono_reflection_create_runtime_class): Use g_list_prepend_image instead of g_list_prepend_mempool.


2009-02-11 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-internals.h (struct MonoImage): Add lock field. Export mono_image_lock and
	mono_image_unlock.

	* image.c (mono_image_init): Init the lock field.
 
	* image.c (mono_image_init): Cleanup the lock field.

	* image.c: Add mono_image_(un)lock functions.

2009-02-11  Mark Probst  <mark.probst@gmail.com>

	* class.c, class-internals.h: mono_method_get_context_general()
	combines the functionality of mono_method_get_context() and
	mini_method_get_context().

	* generic-sharing.c, domain-internals.h:
	mono_method_construct_object_context() and
	mono_domain_lookup_shared_generic() moved from mini.

	* icall.c (ves_icall_InternalInvoke): Handle the case where the
	method doesn't have the correct instantiation because it's shared
	generic code.  Fixes #473999.

2009-02-11  Zoltan Varga  <vargaz@gmail.com>

	* loader.c (mono_method_get_wrapper_data): Handle inflated methods as well.

	* loader.c (mono_loader_lock): Add a comment pointing to the locking document.
	
2009-02-11 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata.c: Make mono_image_alloc_lock and mono_image_alloc0_lock non static.

	* metadata-internals.h: Export mono_image_alloc_lock and mono_image_alloc0_lock.

	* loader.c (mono_get_method_full): Drop the loader lock while constructing the method
	and recheck the cache for dups after it.

	* loader.c (mono_get_method_from_token): Use _lock version of mono_image_alloc0.

	Fixes one of the deadlocks found in #473150.

2009-02-11  Bill Holmes  <billholmes54@gmail.com>

	* socket-io.c (ves_icall_System_Net_Sockets_Socket_Accept_internal):
	  For Win32, add additional break conditions for accept.

	Code is contributed under MIT/X11 license.

2009-02-10  Zoltan Varga  <vargaz@gmail.com>

	* marshal.c (mono_marshal_get_native_func_wrapper): Use get_cache to
	lazily initialize the native wrapper cache.
	(mono_marshal_get_native_wrapper): Put aot-ed native wrappers into a separate
	cache, since they are different from the normal wrappers.

	* image.c (mono_image_init): Initialize native_wrapper_cache lazily as well.

	* metadata-internals.h (struct _MonoImage): Add a new wrapper for
	AOT compiled native wrappers.

2009-02-09  Geoff Norton  <gnorton@novell.com>

	* appdomain.h:
	* security-core-clr.c: Allow enabling core-clr from the embedding
	API.

2009-02-07 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* socket-io.c: when requesting all the local ips, if there are no
	interfaces up and running, MS returns 127.0.0.1.

2009-02-07 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* mono-perfcounters-def.h: processor time is an inverse time.
	Fixes bug #468625.

2009-02-07 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* socket-io.c: an empty host name returns the list of local IPs.
	Fixes bug #386637 part 1/2.

2009-02-07  Zoltan Varga  <vargaz@gmail.com>

	* verify.c (mono_class_interface_implements_interface): Call
	mono_class_setup_interfaces ().
	(merge_stacks): Ditto.

2009-02-06  Zoltan Varga  <vargaz@gmail.com>

	* class.c (mono_class_setup_interfaces): New function to lazily initalize
	klass->interfaces.
	(mono_generic_class_get_class): Don't initalize klass->interfaces.
	(mono_generic_class_get_class): Ditto.

2009-02-06  U-QUACK\miguel  <miguel@quack>

	* icall-defs.h: Include also the Encrypt/Decrypt string methods as
	they live in security.c

	* debug-mono-symfile.c (mono_debug_open_mono_symbols): Integrated
	another bit from Paolo's code.

2009-02-06  Zoltan Varga  <vargaz@gmail.com>

	* object.c (build_imt_slots): Add a small optimization to avoid inflating
	methods which will be discarded by add_imt_builder_entry ().

	* marshal.c (get_runtime_invoke_type): Avoid sharing enum types since they
	need to be boxed.

	* loader.c: Add a statistics for the size of the memberref signature cache.
	
	* loader.c (find_cached_memberref_sig): New helper function.
	(cache_memberref_sig): Ditto.

	* loader.c: Cache the result of parsing memberref signatures, since otherwise
	they will be parsed again for every generic instantiation, leading to unbounded
	memory growth.

2009-02-05  Zoltan Varga  <vargaz@gmail.com>

	* loader.c (mono_get_method_from_token): Avoid creating class for the generic
	parameters of generic methods.

	* class.c (mono_class_inflate_generic_method_full): Set is_mb_open again
	after the original method is copied to the inflated method.
	(mono_class_get_vtable_entry): Handle rgctx invoke wrappers more efficiently.

	* class-internals.h (struct _MonoMethodInflated): Move the is_mb_open
	field to MonoMethod since it only consumes 1 bit there, and 4/8 bytes here.

	* class.c metadata.c: Update after the changes above.

2009-02-05 Rodrigo Kumpera  <rkumpera@novell.com>

	* metadata-verify.c: Simplified error handling and added
